#!/bin/sh

# THIS PRODUCT CONTAINS RESTRICTED MATERIALS OF IBM
# 5724-J34, 5655-P28  (C) COPYRIGHT International Business Machines Corp., 2006
# All Rights Reserved * Licensed Materials - Property of IBM
# US Government Users Restricted Rights - Use, duplication or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.

PLATFORM=`/bin/uname`

CUR_DIR=`pwd`
OBJECTGRID_DIR=`dirname ${0}`/../
cd "${OBJECTGRID_DIR}"
OBJECTGRID_HOME=`pwd`
cd "${CUR_DIR}"

case $PLATFORM in
	SunOS)

    	if [ "$JAVA_HOME" = "" ]
    	then
       		echo "Set the JAVA_HOME environment variable."
       		exit
    	fi
    	;;
	*)
	
		if [ "$JAVA_HOME" == "" ]
		then
			echo "Set the JAVA_HOME environment variable."
			exit
		fi
		;;

esac




export OBJECTGRID_HOME JAVA_HOME
