<%-- IBM Confidential OCO Source Material --%>
<%-- 5724-J34 (C) COPYRIGHT International Business Machines Corp. 2004, 2005 --%>
<%-- The source code for this program is not published or otherwise divested --%>
<%-- of its trade secrets, irrespective of what has been deposited with the --%>
<%-- U.S. Copyright Office. --%>

<%@ page language="java"%>
<%@ taglib uri="/WEB-INF/ibmcommon.tld" prefix="ibmcommon" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<%@ taglib uri="/WEB-INF/tiles.tld" prefix="tiles" %>

<%@ page import="java.util.*"%>
<%@ page language="java" import="com.ibm.ws.console.distmanagement.wizard.*"%>
<%@ page language="java" import="com.ibm.websphere.management.metadata.*"%>
<%@ page language="java" import="com.ibm.ws.sm.workspace.RepositoryContext"%>
<%@ page language="java" import="com.ibm.ws.console.core.Constants"%>


<tiles:useAttribute name="actionForm" classname="java.lang.String" />

<%// defect 126608

String descImage = "pluginId=com.ibm.ws.console.dynamiccluster";
String image = "";
String pluginId = "";
String pluginRoot = "";

if (descImage != "") {
	int index = descImage.indexOf("pluginId=");
	if (index >= 0) {
		pluginId = descImage.substring(index + 9);
		if (index != 0)
			descImage = descImage.substring(0, index);
		else
			descImage = "";
	} else {
		index = descImage.indexOf("pluginContextRoot=");
		if (index >= 0) {
			pluginRoot = descImage.substring(index + 18);
			if (index != 0)
				descImage = descImage.substring(0, index);
			else
				descImage = "";
		}
	}
}
%>
<ibmcommon:setPluginInformation pluginIdentifier="<%=pluginId%>"
	pluginContextRoot="<%=pluginRoot%>" />
<ibmcommon:detectLocale />


<table border="0" cellpadding="3" cellspacing="1" width="100%"
	summary="List table">
	<tbody>
		<tr valign="top">
		 <td class="table-text"  nowrap valign="top">
               <span class="requiredField">
                 <label for="name" title='<bean:message key="dynamiccluster.name.description"/>'>
                   <img src="images/attend.gif" width="8" height="8" align="absmiddle" alt='<bean:message key="information.required"/>'>
                   <bean:message key="dynamiccluster.name.displayName" />
                 </LABEL>
               </SPAN>
               <BR>
               <html:text property="name" size="30" styleId="name" styleClass="textEntryRequired"/>
          </td>
		</tr>
		<tr valign="top">
			<td class="table-text" scope="row">
				<span class="requiredField">
				  <label for="selectedNodeGroup" title='<bean:message key="dynamiccluster.nodegroup.description"/>'>
				 	<img src="images/attend.gif" width="8" height="8" align="absmiddle" alt='<bean:message key="information.required"/>'>
					<bean:message key="dynamiccluster.nodegroup.displayName" />
				  </label>
				</span>
				<br>
				
				<html:select property="selectedNodeGroup" styleId="nodegroup">
				<logic:iterate id="ng" name="<%=actionForm%>" property="nodeGroupList">
					<html:option value="<%=(String) ng%>">
						<%=(String) ng%>
					</html:option>
				</logic:iterate>
				</html:select>
			</td>
		</tr>
		<tr valign="top">
			<td class="table-text" scope="row">
				<label for="preferLocal" title='<bean:message key="dynamiccluster.preferLocal.description"/>'>
					<html:checkbox property="preferLocal" value="true" />
				<bean:message key="prefer.local" />
				</label>
			</td>			
		</tr>
		<tr valign="top">
			<td class="table-text" scope="row">
				<label for="createDomain" title='<bean:message key="create.replication.domain.description"/>'>
					<html:checkbox property="createDomain" value="true" />
				<bean:message key="create.replication.domain" />
				</label>
			</td>
		</tr>


	</tbody>
</table>
