<%-- IBM Confidential OCO Source Material --%>
<%-- 5724-J34 (C) COPYRIGHT International Business Machines Corp. 2004, 2005 --%>
<%-- The source code for this program is not published or otherwise divested --%>
<%-- of its trade secrets, irrespective of what has been deposited with the --%>
<%-- U.S. Copyright Office. --%>

<%@ page language="java"%>
<%@ taglib uri="/WEB-INF/ibmcommon.tld" prefix="ibmcommon" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<%@ taglib uri="/WEB-INF/tiles.tld" prefix="tiles" %>

<%@ page import="java.util.*"%>
<%@ page language="java" import="com.ibm.ws.console.distmanagement.wizard.*"%>
<%@ page language="java" import="com.ibm.websphere.management.metadata.*"%>
<%@ page language="java" import="com.ibm.ws.sm.workspace.RepositoryContext"%>
<%@ page language="java" import="com.ibm.ws.console.core.Constants"%>


<tiles:useAttribute name="actionForm" classname="java.lang.String" />

<%// defect 126608

String descImage = "pluginId=com.ibm.ws.console.dynamiccluster";
String image = "";
String pluginId = "";
String pluginRoot = "";

if (descImage != "") {
	int index = descImage.indexOf("pluginId=");
	if (index >= 0) {
		pluginId = descImage.substring(index + 9);
		if (index != 0)
			descImage = descImage.substring(0, index);
		else
			descImage = "";
	} else {
		index = descImage.indexOf("pluginContextRoot=");
		if (index >= 0) {
			pluginRoot = descImage.substring(index + 18);
			if (index != 0)
				descImage = descImage.substring(0, index);
			else
				descImage = "";
		}
	}
}
%>
<ibmcommon:setPluginInformation pluginIdentifier="<%=pluginId%>"
	pluginContextRoot="<%=pluginRoot%>" />
<ibmcommon:detectLocale />


<table border="0" cellpadding="3" cellspacing="1" width="100%"
	summary="List table">
	<tbody>
    	<tr valign="top">
          	<td class="table-text"  scope="row" nowrap>
               <FIELDSET id="minimumInstances">
               <legend for ="minimumInstances" TITLE="<bean:message key="dynamiccluster.minimumInstances.description"/>">
                 <bean:message key="dynamiccluster.minimum.instances"/>
               </legend>
			<table width="100%" border="0" cellspacing="0" cellpadding="0">
                           <tbody>
                               <tr valign="top">
                                   <td class="table-text" nowrap scope="row">
                                       <label for="MINIMUM_INSTANCES_ZERO" TITLE="<bean:message key="dynamiccluster.minimum.instances.zero"/>">
                                           <html:radio property="selectedMinInstances"
                                                       styleId="MINIMUM_INSTANCES_ZERO"
                                                       value="MINIMUM_INSTANCES_ZERO"
                                                       onclick="enableDisable('MINIMUM_INSTANCES_ZERO:selectedServerInactivityTime,MINIMUM_INSTANCES_ONE,MINIMUM_INSTANCES_MULTIPLE:selectedMinimumNumberInstances')"/>
                                           <bean:message key="dynamiccluster.minimum.instances.zero"/>
                                       </label>
                                   </td>
                               </tr>
                               <tr valign="top">
                                   <td class="complex-property" nowrap>
                                   <label for="serverInactivityTime" TITLE="<bean:message key="dynamiccluster.minimum.instances.waittime"/>">
                                       <bean:message key="dynamiccluster.minimum.instances.waittime"/>
                                   </label>
                                   <br>
                                   <html:text property="selectedServerInactivityTime"
                                              size="15"
                                              styleId="selectedServerInactivityTime"
                                              styleClass="textEntry" /> <bean:message key="dynamiccluster.minimum.instances.minutes"/>
                                   </td>
                               </tr>
                               <tr valign="top">
                                   <td class="table-text" nowrap scope="row">
                                       <label for="MINIMUM_INSTANCES_ONE" TITLE="<bean:message key="dynamiccluster.minimum.instances.one"/>">
                                           <html:radio property="selectedMinInstances"
                                                       styleId="MINIMUM_INSTANCES_ONE"
                                                       value="MINIMUM_INSTANCES_ONE"
                                                       onclick="enableDisable('MINIMUM_INSTANCES_ZERO:selectedServerInactivityTime,MINIMUM_INSTANCES_ONE,MINIMUM_INSTANCES_MULTIPLE:selectedMinimumNumberInstances')"/>
                                           <bean:message key="dynamiccluster.minimum.instances.one"/>
                                       </label>
                                   </td>
                               </tr>
                               <tr valign="top">
                                   <td class="table-text" nowrap scope="row">
                                       <label for="MINIMUM_INSTANCES_MULTIPLE" TITLE="<bean:message key="dynamiccluster.minimum.instances.multiple"/>">
                                           <html:radio property="selectedMinInstances"
                                                       styleId="MINIMUM_INSTANCES_MULTIPLE"
                                                       value="MINIMUM_INSTANCES_MULTIPLE"
                                                       onclick="enableDisable('MINIMUM_INSTANCES_ZERO:selectedServerInactivityTime,MINIMUM_INSTANCES_ONE,MINIMUM_INSTANCES_MULTIPLE:selectedMinimumNumberInstances')"/>
                                           <bean:message key="dynamiccluster.minimum.instances.multiple"/>
                                       </label>
                                   </td>
                               </tr>
                               <tr valign="top">
                                   <td class="complex-property" nowrap>
                                   <label for="selectedMinimumNumberInstances" TITLE="<bean:message key="dynamiccluster.number.instances"/>">
                                       <bean:message key="dynamiccluster.number.instances"/>
                                   </label>
                                   <br>
                                   <html:text property="selectedMinimumNumberInstances"
                                              size="15"
                                              styleId="selectedMinimumNumberInstances"
                                              styleClass="textEntry" />
                                   </td>
                               </tr>
			</table>
		</FIELDSET>
          </td>
     </tr>
    	<tr valign="top">
          	<td class="table-text"  scope="row" nowrap>
               <FIELDSET id="maximumInstances">
               <legend for ="maximumInstances" TITLE="<bean:message key="dynamiccluster.maximumInstances.description"/>">
                 <bean:message key="dynamiccluster.maximum.instances"/>
               </legend>
			<table width="100%" border="0" cellspacing="0" cellpadding="0">
                           <tbody>
                               <tr valign="top">
                                   <td class="table-text" nowrap scope="row">
                                       <label for="MAXIMUM_INSTANCES_LIMIT" TITLE="<bean:message key="dynamiccluster.maximum.instances.limit"/>">
                                           <html:radio property="selectedMaxInstances"
                                                       styleId="MAXIMUM_INSTANCES_LIMIT"
                                                       value="MAXIMUM_INSTANCES_LIMIT"
                                                       onclick="enableDisable('MAXIMUM_INSTANCES_LIMIT:selectedMaximumNumberInstances,MAXIMUM_INSTANCES_NOLIMIT')"/>
                                           <bean:message key="dynamiccluster.maximum.instances.limit"/>
                                       </label>
                                   </td>
                               </tr>
                               <tr valign="top">
                                   <td class="complex-property" nowrap>
                                   <label for="selectedMaximumNumberInstances" TITLE="<bean:message key="dynamiccluster.number.instances"/>">
                                       <bean:message key="dynamiccluster.number.instances"/>
                                   </label>
                                   <br>
                                   <html:text property="selectedMaximumNumberInstances"
                                              size="15"
                                              styleId="selectedMaximumNumberInstances"
                                              styleClass="textEntry" />
                                   </td>
                               </tr>
                               <tr valign="top">
                                   <td class="table-text" nowrap scope="row">
                                       <label for="MAXIMUM_INSTANCES_NOLIMIT" TITLE="<bean:message key="dynamiccluster.maximum.instances.nolimit"/>">
                                           <html:radio property="selectedMaxInstances"
                                                       styleId="MAXIMUM_INSTANCES_NOLIMIT"
                                                       value="MAXIMUM_INSTANCES_NOLIMIT"
                                                       onclick="enableDisable('MAXIMUM_INSTANCES_LIMIT:selectedMaximumNumberInstances,MAXIMUM_INSTANCES_NOLIMIT')"/>
                                           <bean:message key="dynamiccluster.maximum.instances.nolimit"/>
                                       </label>
                                   </td>
                               </tr>
			</table>
		</FIELDSET>
          </td>
     </tr>
    	<tr valign="top">
          	<td class="table-text"  scope="row" nowrap>
               <FIELDSET id="verticalStacking">
               <legend for ="verticalStacking" TITLE="<bean:message key="dynamiccluster.verticalStacking.description"/>">
                 <bean:message key="dynamiccluster.verticalStacking.instances"/>
               </legend>
			<table width="100%" border="0" cellspacing="0" cellpadding="0">
                           <tbody>
                               <tr valign="top">
                                   <td class="table-text" nowrap scope="row">
                                       <label for="VERTICALSTACKING_INSTANCES_ALLOW" TITLE="<bean:message key="dynamiccluster.verticalStacking.allow"/>">
                                           <html:checkbox property="selectedVerticalStackingInstances"
                                                       styleId="VERTICALSTACKING_INSTANCES_ALLOW"
                                                       value="true"
                                                       onclick="enableDisable('VERTICALSTACKING_INSTANCES_ALLOW:selectedVerticalStackingNumberInstances')"/>
                                           <bean:message key="dynamiccluster.verticalStacking.allow"/>
                                       </label>
                                   </td>
                               </tr>
                               <tr valign="top">
                                   <td class="complex-property" nowrap>
                                   <label for="selectedVerticalStackingNumberInstances" TITLE="<bean:message key="dynamiccluster.number.instances"/>">
                                       <bean:message key="dynamiccluster.number.instances"/>
                                   </label>
                                   <br>
                                   <html:text property="selectedVerticalStackingNumberInstances"
                                              size="15"
                                              styleId="selectedVerticalStackingNumberInstances"
                                              styleClass="textEntry" />
                                   </td>
                               </tr>
			</table>
		</FIELDSET>
          </td>
     </tr>
	</tbody>
</table>

<script type="text/javascript" language="JavaScript">
    /**
     * Enable and disable the fields associated with the minimum, maximum and vertical stacking instances type when
     * the page is initially loaded.
     */
     enableDisable('MINIMUM_INSTANCES_ZERO:selectedServerInactivityTime,MINIMUM_INSTANCES_ONE,MINIMUM_INSTANCES_MULTIPLE:selectedMinimumNumberInstances');
     enableDisable('MAXIMUM_INSTANCES_LIMIT:selectedMaximumNumberInstances,MAXIMUM_INSTANCES_NOLIMIT');
     enableDisable('VERTICALSTACKING_INSTANCES_ALLOW:selectedVerticalStackingNumberInstances');
</script>
