<%-- IBM Confidential OCO Source Material --%>
<%-- 5724-J34 (C) COPYRIGHT International Business Machines Corp. 2004, 2005 --%>
<%-- The source code for this program is not published or otherwise divested --%>
<%-- of its trade secrets, irrespective of what has been deposited with the --%>
<%-- U.S. Copyright Office. --%>

<%@ page language="java"%>
<%@ page import="org.apache.struts.util.MessageResources"%>
<%@ page import="org.apache.struts.action.*"%>
<%@ taglib uri="/WEB-INF/ibmcommon.tld" prefix="ibmcommon" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<%@ taglib uri="/WEB-INF/tiles.tld" prefix="tiles" %>

<tiles:useAttribute name="actionForm" classname="java.lang.String" />

<bean:define id="name" name="<%=actionForm%>" property="name" type="java.lang.String" />
<bean:define id="description" name="<%=actionForm%>" property="description" type="java.lang.String" />
<bean:define id="reactionMode" name="<%=actionForm%>" property="reactionMode" type="java.lang.String" />
<bean:define id="type" name="<%=actionForm%>" property="type" type="java.lang.String" />
<bean:define id="age" name="<%=actionForm%>" property="age" type="java.lang.Integer" />
<bean:define id="ageUnits" name="<%=actionForm%>" property="ageUnits" type="java.lang.String" />
<bean:define id="requests" name="<%=actionForm%>" property="totalRequests" type="java.lang.Long" />
<bean:define id="responseTime" name="<%=actionForm%>" property="responseTime" type="java.lang.Integer" />
<bean:define id="timeUnits" name="<%=actionForm%>" property="responseTimeUnits" type="java.lang.String" />
<bean:define id="totalMemory" name="<%=actionForm%>" property="totalMemory" type="java.lang.Integer" />
<bean:define id="timeOverThreshold" name="<%=actionForm%>" property="timeOverThreshold" type="java.lang.Integer" />
<bean:define id="units" name="<%=actionForm%>" property="timeUnits" type="java.lang.String" />
<bean:define id="clusters" name="<%=actionForm%>" property="selectedCLString" type="java.lang.String" />
<bean:define id="dynamicclusters" name="<%=actionForm%>" property="selectedDCString" type="java.lang.String" />
<bean:define id="genericserverclusters" name="<%=actionForm%>" property="selectedGSCString" type="java.lang.String" />
<bean:define id="appservers" name="<%=actionForm%>" property="selectedAPString" type="java.lang.String" />
<bean:define id="cellLevel" name="<%=actionForm%>" property="cellLevelPolicy" type="java.lang.String" />
<bean:define id="timeoutPercent" name="<%=actionForm%>" property="timeoutPercent" type="java.lang.Integer" />
<bean:define id="stormDrainConditionLevel" name="<%=actionForm%>" property="stormDrainConditionLevel" type="java.lang.String" />
<bean:define id="memoryLeakConditionLevel" name="<%=actionForm%>" property="memoryLeakConditionLevel" type="java.lang.String" />

<table border="0" cellpadding="3" cellspacing="1" width="100%" summary="List table">

  <tr valign="baseline" >
      <td class="wizard-step-text" width="100%" align="left">
          <bean:message key="healthclass.confirm.msg1"/>
          <bean:message key="healthclass.confirm.msg2"/>
	  </td>
  </tr>
</table>
	
<table border="0" cellpadding="3" cellspacing="1" width="100%" summary="List table" class="framing-table">
   <tr>
      <th class="column-head-name" scope="col">
          <bean:message key="healthclass.confirm.msg3"/>
	  </th>
   </tr>
   <%
	MessageResources messages = (MessageResources)application.getAttribute(Action.MESSAGES_KEY);
	java.util.Locale locale = request.getLocale();
	String translatedReactionMode = messages.getMessage(locale,reactionMode);
	description = description.replaceAll("<","&#60;");
    description = description.replaceAll(">","&#62;");
	%>
   <tr>
      <td class="table-text"  valign="top">
      		<%if (description.length() > 0) { %>
               <bean:message key="healthclass.confirm.msg4desc" arg0="<%=name%>" arg1="<%=description%>" arg2="<%=translatedReactionMode%>"  />
            <%} else { %>
               <bean:message key="healthclass.confirm.msg4" arg0="<%=name%>" arg1="<%=translatedReactionMode%>"  />
            <%} %>
            <br>
             <%if (type.equalsIgnoreCase("AGE")) {
	               String ageString = age.toString();
	               String translatedUnits = messages.getMessage(locale,ageUnits); %>
	               <bean:message key="healthclass.confirm.agecondition" arg0="<%=ageString%>" arg1="<%=translatedUnits%>" />
               <%
             }
             else if (type.equalsIgnoreCase("WORKLOAD")) {
             	String requestsString = requests.toString();               %>
               <bean:message key="healthclass.confirm.workloadcondition" arg0="<%=requestsString%>"   />
               <%
             }
             else if (type.equalsIgnoreCase("RESPONSE")) {
                String timeString = responseTime.toString();
                String translatedUnits = messages.getMessage(locale,timeUnits); %>
               <bean:message key="healthclass.confirm.responsecondition" arg0="<%=timeString%>" arg1="<%=translatedUnits%>"  />
               <%
             }
             else if (type.equalsIgnoreCase("MEMORY")) {
                String translatedUnits = messages.getMessage(locale,units);
                String memoryString = totalMemory.toString();
                String timeString = timeOverThreshold.toString();  %>
               <bean:message key="healthclass.confirm.memorycondition" arg0="<%=memoryString%>" arg1="<%=timeString%>" arg2="<%=translatedUnits%>"  />
               <%
             }
             else if (type.equalsIgnoreCase("STUCKREQUEST")) {
                String timeoutPercentString = timeoutPercent.toString(); %>
               <bean:message key="healthclass.confirm.stuckrequestcondition" arg0="<%=timeoutPercentString%>"   />
               <%
             }
             else if (type.equalsIgnoreCase("STORMDRAIN")) {
                String translatedlevel = "";
                if (stormDrainConditionLevel.equals("CONDITION_LEVEL_NORMAL"))
                   translatedlevel = messages.getMessage(locale,"healthclass.stormdrain.normallevel");
                else
                   translatedlevel = messages.getMessage(locale,"healthclass.stormdrain.conservativelevel"); %>
               <bean:message key="healthclass.confirm.stormdraincondition" arg0="<%=translatedlevel%>"   />
               <%
             }
             else if (type.equalsIgnoreCase("MEMORYLEAK")) {
                String translatedlevel = "";
                if (memoryLeakConditionLevel.equals("CONDITION_LEVEL_AGGRESSIVE"))
                   translatedlevel = messages.getMessage(locale,"healthclass.memoryleak.aggressivelevel");
                else if (memoryLeakConditionLevel.equals("CONDITION_LEVEL_NORMAL"))
                   translatedlevel = messages.getMessage(locale,"healthclass.memoryleak.normallevel");
                else
                   translatedlevel = messages.getMessage(locale,"healthclass.memoryleak.conservativelevel"); %>
               <bean:message key="healthclass.confirm.memoryleakcondition" arg0="<%=translatedlevel%>"   />
               <%
             } %>
             <%if (cellLevel.equalsIgnoreCase("true")) { %>
               <bean:message key="healthclass.confirm.celllevel" />
             <% } %>
             <br>
             <% if (appservers.length() > 0) { %>
               <bean:message key="healthclass.confirm.appservers" arg0="<%=appservers%>" />
             <br>
             <% } %>
             <% if (clusters.length() > 0) { %>
               <bean:message key="healthclass.confirm.clusters" arg0="<%=clusters%>"   />
             <br>
             <% } %>
             <% if (dynamicclusters.length() > 0) { %>
               <bean:message key="healthclass.confirm.dynclusters" arg0="<%=dynamicclusters%>"  />
             <br>
             <% } %>
             <% if (genericserverclusters.length() > 0) { %>
               <bean:message key="healthclass.confirm.genericserverclusters" arg0="<%=genericserverclusters%>"  />
             <% } %>
	  </td>
   </tr>

</table>
