<%-- IBM Confidential OCO Source Material --%>
<%-- 5724-J34 (C) COPYRIGHT International Business Machines Corp. 2004, 2005 --%>
<%-- The source code for this program is not published or otherwise divested --%>
<%-- of its trade secrets, irrespective of what has been deposited with the --%>
<%-- U.S. Copyright Office. --%>

<%@ page language="java" import="java.util.Collection,java.lang.reflect.*,com.ibm.ws.util.XDConstants,com.ibm.ws.console.healthconfig.util.Constants,com.ibm.ws.console.healthconfig.form.HealthClassDetailForm"%>
<%@ page import="java.beans.*"%>
<%@ page import="org.apache.struts.util.MessageResources"%>
<%@ page import="org.apache.struts.action.*"%>
<%@ page errorPage="/error.jsp"%>
<%@ page import="com.ibm.ws.sm.workspace.*"%>
<%@ page import="com.ibm.ws.workspace.query.*"%>
<%@ page import="com.ibm.ws.console.core.*"%>
<%@ page import="java.util.*,com.ibm.ws.security.core.SecurityContext,com.ibm.websphere.product.*"%>

<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/tiles.tld" prefix="tiles" %>
<%@ taglib uri="/WEB-INF/ibmcommon.tld" prefix="ibmcommon" %>

<tiles:useAttribute name="readOnlyView" classname="java.lang.String"/>
<tiles:useAttribute name="attributeList" classname="java.util.List"/>
<tiles:useAttribute name="formAction" classname="java.lang.String" />
<tiles:useAttribute name="formName" classname="java.lang.String" />
<tiles:useAttribute name="formType" classname="java.lang.String" />
<tiles:useAttribute name="formFocus" classname="java.lang.String" />

<script language="JavaScript">
var changing = false;
var selectedAvailableNodes; // array of currently selected available nodes
var selectedCurrentNodes; // array of currently selected member nodes
var availNodes;
var currentNodes;
var availField;
var outputField;
var inited = false;
var originalAvailField;
var originalOutputField;
var descField;
var conditionField;
var modeField;
var ageField;
var ageUnitsField;
var requestsField;
var cellLevelField;
var percentField;	//used for both response, memory and stuck request
var valVield;	//used for both response and memory
var unitField;	//used for both response and memory
var healthConditionType;
var restartServerField;
var threadDumpField;
var heapDumpField;
var aggressiveDetectionField;
var normalDetectionField;
var conservativeDetectionField;

//this function resets the membership form to the initial state (before any changes were made by the user)
function resetForm(){
	window.location = "/ibm/console/HealthClassDetail.do?&ResetClicked=true";	
}

function initVars(formElem, hc_type){

   // hc_type (healthConditionType):
   //  age=1
   //  workload=2
   //  response=3
   //  memory=4
   //  memoryleak=5
   //  stuckrequest=6
   //  stormdrain=7

	if (inited){
		return inited;
	}
	
	var theform = formElem.form;
//    for (var i =0; i<theform.elements.length; i++) {
//        document.write("Fields: " + hc_type + "Element " + i + ": " + theform.elements[i] + "\n\t" + i + "Value: " + theform.elements[i].value + "\n");
//    }	
	changing = false;
	selectedAvailableNodes = new Array(); //associative array of currently selected available nodes (keyed on Node Name)
	selectedCurrentNodes = new Array(); //associative array of currently selected member nodes (keyed on Node Name)
	descField      = theform.elements[1];	
	cellLevelField = theform.elements[2];
	conditionField = theform.elements[2];
          // element[3] is 'Health Condition Properties' legend
	if (hc_type == 1) { // age condition
		ageField      = theform.elements[4];
		ageUnitsField = theform.elements[5];
                  // element[6] is 'Health Management Monitor Reaction' legend
	        modeField          = theform.elements[7];
               restartServerField = theform.elements[8];
                  // element[9] is hidden restartServerField
                  // element[10] is 'Memberships' legend
               memberTypeField = theform.elements[11];
               availNodes      = theform.elements[12];
                  // element[13] is 'Add' button
                  // element[14] is 'Remove' button
               currentNodes    = theform.elements[15];
		healthConditionType = 1;
	}
	if (hc_type == 2) {  // workload condition
		requestsField = theform.elements[4];
                  // element[5] is 'Health Management Monitor Reaction' legend
	        modeField          = theform.elements[6];
               restartServerField = theform.elements[7];
                  // element[8] is hidden restartServerField
                  // element[9] is 'Memberships' legend
               memberTypeField = theform.elements[10];
               availNodes      = theform.elements[11];
                  // element[12] is 'Add' button
                  // element[13] is 'Remove' button
               currentNodes    = theform.elements[14];
		healthConditionType = 2;
	}
	if (hc_type == 3) { // response condition
		valField   = theform.elements[4];
		unitsField = theform.elements[5];
                  // element[6] is 'Health Management Monitor Reaction' legend
	        modeField          = theform.elements[7];
               restartServerField = theform.elements[8];
                  // element[9] is hidden restartServerField
                  // element[10] is 'Memberships' legend
               memberTypeField = theform.elements[11];
               availNodes      = theform.elements[12];
                  // element[13] is 'Add' button
                  // element[14] is 'Remove' button
               currentNodes    = theform.elements[15];
		healthConditionType = 3;
	}
	if (hc_type == 4) {  // memory condition
		percentField = theform.elements[4];
		valField     = theform.elements[5];
		unitsField   = theform.elements[6];
                  // element[7] is 'Health Management Monitor Reaction' legend
	        modeField          = theform.elements[8];
               restartServerField = theform.elements[9];
                  // element[10] is hidden restartServerField
                  // element[11] is 'Memberships' legend
               memberTypeField = theform.elements[12];
               availNodes      = theform.elements[13];
                  // element[14] is 'Add' button
                  // element[15] is 'Remove' button
               currentNodes    = theform.elements[16];
		healthConditionType = 4;
	}
	if (hc_type == 5) {  // memory leak condition
               aggressiveDetectionField   = theform.elements[4];
               normalDetectionField       = theform.elements[5];
               conservativeDetectionField = theform.elements[6];
                  // element[7] is 'Health Management Monitor Reaction' legend
	        modeField          = theform.elements[8];
               heapDumpField      = theform.elements[9];
               restartServerField = theform.elements[10];
                  // element[11] is 'Memberships' legend
               memberTypeField = theform.elements[12];
               availNodes      = theform.elements[13];
                  // element[14] is 'Add' button
                  // element[15] is 'Remove' button
               currentNodes    = theform.elements[16];
		healthConditionType = 5;
	}
	if (hc_type == 6) {  // stuck request condition
		percentField = theform.elements[4];
                  // element[5] is 'Health Management Monitor Reaction' legend
	        modeField          = theform.elements[6];
               threadDumpField    = theform.elements[7];
               restartServerField = theform.elements[8];
                  // element[9] is 'Memberships' legend
               memberTypeField = theform.elements[10];
               availNodes      = theform.elements[11];
                  // element[12] is 'Add' button
                  // element[13] is 'Remove' button
               currentNodes    = theform.elements[14];
		healthConditionType = 6;
	}
	if (hc_type == 7) {  // storm drain condition
               normalDetectionField       = theform.elements[4];
               conservativeDetectionField = theform.elements[5];
                  // element[6] is 'Health Management Monitor Reaction' legend
	        modeField          = theform.elements[7];
               restartServerField = theform.elements[8];
                  // element[9] is hidden restartServerField
                  // element[10] is 'Memberships' legend
               memberTypeField = theform.elements[11];
               availNodes      = theform.elements[12];
                  // element[13] is 'Add' button
                  // element[14] is 'Remove' button
               currentNodes    = theform.elements[15];
		healthConditionType = 7;
	}
	//this means reponse time, there aren't that many fields, but we needed to tell it from the other ones
	inited=true;
	return inited;
}

function myOnChange() {}
function healthConditionChanged() {
	//handles when the Condition has changed.   No need to pass back condition values, since the condition is changing
	var selectedCondition = conditionField.value;
	var selectedType = memberTypeField.value;
	var checked = "false";
	if (cellLevelField.checked) checked="true";
	var newDesc = descField.value;
	var newMode = modeField.value;
	window.location = encodeURI("/ibm/console/HealthClassDetail.do?type=" + selectedCondition + "&cell="+ checked + "&typeChanged=true" + "&mode=" + newMode + "&memberType="+ selectedType + "&desc=" + encodeURI(newDesc));
}

function finishMethod(urlString, newDesc) {
	//determine the condition fields
	if (healthConditionType == 1) {  // age condition
		var newAge = ageField.value;
		var newAgeUnits = ageUnitsField.value;
               var newHealthAction = '';
               if (restartServerField.checked)
                 newHealthAction = restartServerField.value;
		urlString = urlString + "&arg0=" + newAge + "&arg1=" + newAgeUnits + "&arg2=" + newHealthAction;
	}
	if (healthConditionType == 2) {  // workload condition
		var newRequests = requestsField.value;
               var newHealthAction = '';
               if (restartServerField.checked)
                 newHealthAction = restartServerField.value;
		urlString = urlString + "&arg0=" + newRequests + "&arg1=" + newHealthAction;
	}
	if (healthConditionType == 3) {  // response condition
		//var newPercent = percentField.value;
		var newVal = valField.value;
		var newUnits = unitsField.value;
               var newHealthAction = '';
               if (restartServerField.checked)
                 newHealthAction = restartServerField.value;
		urlString = urlString + "&arg0=" + newVal + "&arg1=" + newUnits + "&arg2=" + newHealthAction;
	}
	if (healthConditionType == 4) {  // memory condition
		var newPercent = percentField.value;
		var newVal = valField.value;
		var newUnits = unitsField.value;
               var newHealthAction = '';
               if (restartServerField.checked)
                 newHealthAction = restartServerField.value;
		urlString = urlString + "&arg0=" + newPercent + "&arg1=" + newVal + "&arg2=" + newUnits + "&arg3=" + newHealthAction;
	}
	if (healthConditionType == 5) {  // memory leak condition
               var newDetectionLevel;
               if (aggressiveDetectionField.checked)
                  newDetectionLevel = aggressiveDetectionField.value;
               else if (normalDetectionField.checked)
                  newDetectionLevel = normalDetectionField.value;
               else
                  newDetectionLevel = conservativeDetectionField.value;

               var newTemp1 = '';
               if (heapDumpField.checked)
                  newTemp1 = '&arg1=' + heapDumpField.value;
               var newTemp2 = '';
               if (restartServerField.checked)
                   newTemp2 = '&arg1=' + restartServerField.value;

               var newHealthAction = newTemp1 + newTemp2;

		urlString = urlString + "&arg0=" + newDetectionLevel + newHealthAction;
	}
	if (healthConditionType == 6) {  // stuck request condition
		var newPercentField = percentField.value;
               var newTemp1 = '';
               if (threadDumpField.checked)
                  newTemp1 = '&arg1=' + threadDumpField.value;
               var newTemp2 = '';
               if (restartServerField.checked)
                   newTemp2 = '&arg1=' + restartServerField.value;

               var newHealthAction = newTemp1 + newTemp2;

		urlString = urlString + "&arg0=" + newPercentField + newHealthAction;
	}
	if (healthConditionType == 7) {  // storm drain condition
               var newDetectionLevel;
               if (normalDetectionField.checked)
                  newDetectionLevel = normalDetectionField.value;
               else
                  newDetectionLevel = conservativeDetectionField.value;

               var newHealthAction = '';
               if (restartServerField.checked)
                 newHealthAction = restartServerField.value;

		urlString = urlString + "&arg0=" + newDetectionLevel + "&arg1=" + newHealthAction;
	}
	//add the description at the end
	urlString = urlString + "&desc=" + encodeURI(newDesc);
	window.location = encodeURI(urlString);
}

function memberTypeChange() {
	//When the app name changes we need to reset the WebModName lists
	var selectedType = memberTypeField.value;
	var selectedCondition = conditionField.value;
	var newDesc = descField.value;
	var newMode = modeField.value;
	var checked = "false";
	if (cellLevelField.checked) checked="true";
	var urlString = "/ibm/console/HealthClassDetail.do?memberType="+ selectedType + "&memberTypeChanged=true" + "&type=" + selectedCondition + "&cell="+ checked + "&mode=" + newMode;
	finishMethod(urlString,newDesc);
}
	
function addClicked(optionsToAdd) {
	if (optionsToAdd.length > 0) {
               if ((optionsToAdd.length == 1) && (optionsToAdd[0].value == "-------------------------------------------"))
                  return;
		var selectedType = memberTypeField.value;
		var selectedCondition = conditionField.value;
		var newDesc = descField.value;
		var newMode = modeField.value;
		var checked = "false";
		if (cellLevelField.checked) checked="true";
		
		var optionsToAddString = "";
		for(var x = 0; x < optionsToAdd.length; x++){
			if (optionsToAdd[x].value != "-------------------------------------------")
				optionsToAddString = optionsToAddString + ";;" + optionsToAdd[x].value;
		}
		if (optionsToAddString.length != 0) {
			optionsToAddString=optionsToAddString.substring(2); //take off the first 2 ";;"
			var urlString = "/ibm/console/HealthClassDetail.do?memberType=" + selectedType + "&AddClicked=true" + "&stringToAdd=" + encodeURI(optionsToAddString) + "&type=" + selectedCondition + "&cell="+ checked + "&mode=" + newMode;	
		}
	finishMethod(urlString,newDesc);
	}
}

function removeClicked(optionsToRemove) {
	if (optionsToRemove.length > 0) {
               if ((optionsToRemove.length == 1) && (optionsToRemove[0].value == "-------------------------------------------"))
                  return;
		var optionsToRemoveString = "";
		var selectedCondition = conditionField.value;
		var selectedType = memberTypeField.value;
		var newDesc = descField.value;
		var newMode = modeField.value;
		var checked = "false";
		if (cellLevelField.checked) checked="true";

		for(var x = 0; x < optionsToRemove.length; x++){
			if (optionsToRemove[x].value != "-------------------------------------------")
				optionsToRemoveString = optionsToRemoveString + ";;" + optionsToRemove[x].value;
		}
		if (optionsToRemoveString.length != 0) {
			optionsToRemoveString=optionsToRemoveString.substring(2); //take off the first 2 ";;"
			var urlString = "/ibm/console/HealthClassDetail.do?memberType=" + selectedType + "&RemoveClicked=true" + "&stringToRemove=" + encodeURI(optionsToRemoveString) + "&type=" + selectedCondition + "&cell="+ checked + "&mode=" + newMode;	
		}
	finishMethod(urlString,newDesc);
	}
}


/*
This function sets the global selectedAvailableNodes array to correspond with the selected
objects in the box represented by "nodeList" (either currentNodes or availNodes)
*/
function setSelectedNodes(nodeList, selectObject){
	changing = true;
	empty(nodeList);
	var numSelected = 0;	
	var itemSelected;
	if (selectObject.selectedIndex != -1){
		var index=0;
		var str;
		for (var x = 0; x < selectObject.options.length; x++) {
			if (selectObject.options[x].selected){				
				nodeList[index++] = selectObject.options[x]; //copy a reference to this field into our list of selected Options
				itemSelected = selectObject.options[x].value;
				numSelected = numSelected + 1;
			}				
		}		
	}	
	var tempString="";
	first = true;
	for (var y = 0; y < nodeList.length; y++){
		if (!first){
			tempString += "!";			
		}
		tempString += nodeList[y].value;
		first = false;
	}	

	changing = false;
}


function empty(nodeList){
	for (x=0; x<nodeList.length; x++){
		nodeList.pop();
	}
}

function submitIt(){
	while (changing){}
	changing=true;
}
</script>

<%
String healthCondition = "";
HealthClassDetailForm testForm = (HealthClassDetailForm)session.getAttribute("HealthClassDetailForm");


String renderReadOnlyView = "no";
if( (readOnlyView != null) && (readOnlyView.equalsIgnoreCase("yes")) ) {
  renderReadOnlyView = "yes";
} else if (SecurityContext.isSecurityEnabled()) {
    renderReadOnlyView = "yes";
    if (request.isUserInRole("administrator")) {
        renderReadOnlyView = "no";
    }
    else if (request.isUserInRole("configurator")) {
        renderReadOnlyView = "no";
    }
}

//Boolean descriptionsOn = (Boolean) session.getAttribute("descriptionsOn");
String numberOfColumns = "3";
//if (descriptionsOn.booleanValue() == false)
//	numberOfColumns = "2";	
String fieldLevelHelpTopic = "HealthClass.detail.";
String topicKey = fieldLevelHelpTopic;
int fields = 0;
int healthConditionType = 0;

if (testForm.getType().equalsIgnoreCase("AGE"))
   healthConditionType = 1;
else if (testForm.getType().equalsIgnoreCase("WORKLOAD"))
   healthConditionType = 2;
else if (testForm.getType().equalsIgnoreCase("RESPONSE"))
   healthConditionType = 3;
else if (testForm.getType().equalsIgnoreCase("MEMORY"))
   healthConditionType = 4;
else if (testForm.getType().equalsIgnoreCase("MEMORYLEAK"))
   healthConditionType = 5;
else if (testForm.getType().equalsIgnoreCase("STUCKREQUEST"))
   healthConditionType = 6;
else if (testForm.getType().equalsIgnoreCase("STORMDRAIN"))
   healthConditionType = 7;

String typeDropDownChanged = "initVars(this, " + healthConditionType + ");healthConditionChanged()";
%>

<a name="general"></a>

<% if (renderReadOnlyView.equalsIgnoreCase("yes")) { %>
	<tiles:insert page="/com.ibm.ws.console.healthconfig/HealthClassCustomPropsLayoutReadOnly.jsp"  flush="false">
		<tiles:put name="attributeList" value="<%=attributeList%>"/>
		<tiles:put name="formAction" value="<%=formAction%>" />
		<tiles:put name="formName" value="<%=formName%>" />
		<tiles:put name="formType" value="<%=formType%>" />
		<tiles:put name="formFocus" value="<%=formFocus%>" />
		<tiles:put name="numberOfColumns" value="<%=numberOfColumns%>"/>
		<tiles:put name="topicKey" value="<%=topicKey%>" />
		<tiles:put name="testForm" value="<%=testForm%>" />
		<tiles:put name="fieldLevelHelpTopic" value="<%=fieldLevelHelpTopic%>" />
	</tiles:insert>
<% } %>

<% if (renderReadOnlyView.equalsIgnoreCase("no")) { %>

<h2><bean:message key="config.general.properties"/></h2>

<html:form action="<%=formAction%>" name="<%=formName%>" type="<%=formType%>" >
<html:hidden property="action"/>

    <table border="0" cellpadding="5" cellspacing="0" width="100%" summary="Properties Table" >
        <tbody>
        <logic:iterate id="item" name="attributeList" type="com.ibm.ws.console.core.item.PropertyItem">

<%
        String fieldLevelHelpAttribute = item.getAttribute();
        if (fieldLevelHelpAttribute.equals(" ") || fieldLevelHelpAttribute.equals(""))
            fieldLevelHelpTopic = item.getLabel();
        else
            fieldLevelHelpTopic = topicKey + fieldLevelHelpAttribute; %>

       	 	<tr valign="top">
<%
                String isRequired = item.getRequired();
                String strType = item.getType();
                String isReadOnly = item.getReadOnly();
                %>

                 <% if (strType.equalsIgnoreCase("Text")) { %>
                      <tiles:insert page="/secure/layouts/textFieldLayout.jsp" flush="false">
                          <tiles:put name="property" value="<%=item.getAttribute()%>" />
                          <tiles:put name="isReadOnly" value="<%=isReadOnly%>" />
                          <tiles:put name="isRequired" value="<%=isRequired%>" />
                          <tiles:put name="label" value="<%=item.getLabel()%>" />
                          <tiles:put name="size" value="30" />
                          <tiles:put name="units" value="<%=item.getUnits()%>"/>
                          <tiles:put name="desc" value="<%=item.getDescription()%>"/>
                          <tiles:put name="bean" value="<%=formName%>" />
                       </tiles:insert>
                <%  fields++; } %>

                <% if (strType.equalsIgnoreCase("TextArea")) { %>
                    <tiles:insert page="/secure/layouts/textAreaLayout.jsp" flush="false">
                        <tiles:put name="property" value="<%=item.getAttribute()%>" />
                        <tiles:put name="isReadOnly" value="<%=isReadOnly%>" />
                        <tiles:put name="isRequired" value="<%=isRequired%>" />
                        <tiles:put name="label" value="<%=item.getLabel()%>" />
                        <tiles:put name="size" value="5" />
                        <tiles:put name="units" value="<%=item.getUnits()%>"/>
                        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
                        <tiles:put name="bean" value="<%=formName%>" />
                    </tiles:insert>
                <%  fields++; } %>

                <% if (strType.equalsIgnoreCase("Select")) {
                    try {
                        session.removeAttribute("valueVector");
                        session.removeAttribute("descVector");
                    }
                    catch (Exception e) {
                    }

                    StringTokenizer st1 = new StringTokenizer(item.getEnumDesc(), ",");
                    Vector descVector = new Vector();
                    while(st1.hasMoreTokens())
                    {
                        String enumDesc = st1.nextToken();
                        descVector.addElement(enumDesc);
                    }
                    StringTokenizer st = new StringTokenizer(item.getEnumValues(), ",");
                    Vector valueVector = new Vector();
                    while(st.hasMoreTokens())
                    {
                        String str = st.nextToken();
                        valueVector.addElement(str);
                    }

                    session.setAttribute("descVector", descVector);
                    session.setAttribute("valueVector", valueVector);

                    /*
                    if (testForm.getType().equalsIgnoreCase("AGE")) {
                       healthConditionType = 1;
                    }
                    if (testForm.getType().equalsIgnoreCase("WORKLOAD")) {
                       healthConditionType = 2;
                    }
                    if (testForm.getType().equalsIgnoreCase("RESPONSE")) {
                       healthConditionType = 3;
                    }
                    if (testForm.getType().equalsIgnoreCase("MEMORY")) {
                       healthConditionType = 4;
                    }
                    if (testForm.getType().equalsIgnoreCase("MEMORYLEAK")) {
                       healthConditionType = 5;
                    }
                    if (testForm.getType().equalsIgnoreCase("STUCKREQUEST")) {
                       healthConditionType = 6;
                    }
                    if (testForm.getType().equalsIgnoreCase("STORMDRAIN")) {
                       healthConditionType = 7;
                    }

                    String typeDropDownChanged = "initVars(this, " + healthConditionType + ");healthConditionChanged()";
                    */

                    %>

                   <% if (item.getAttribute().equalsIgnoreCase("type")) { %>
                    <tiles:insert page="/com.ibm.ws.console.healthconfig/submitLayoutWithOnChange.jsp" flush="false">
                        <tiles:put name="property" value="<%=item.getAttribute()%>" />
                        <tiles:put name="readOnly" value="<%=isReadOnly%>" />
                        <tiles:put name="isRequired" value="<%=isRequired%>" />
                        <tiles:put name="label" value="<%=item.getLabel()%>" />
                        <tiles:put name="size" value="30" />
                        <tiles:put name="units" value=""/>
                        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
                        <tiles:put name="bean" value="<%=formName%>" />
                        <tiles:put name="onChange" value="<%=typeDropDownChanged%>"  />
        		    </tiles:insert>
   					<%} else { %>
                    <tiles:insert page="/com.ibm.ws.console.healthconfig/submitLayoutWithOnChange.jsp" flush="false">
                        <tiles:put name="property" value="<%=item.getAttribute()%>" />
                        <tiles:put name="readOnly" value="<%=isReadOnly%>" />
                        <tiles:put name="isRequired" value="<%=isRequired%>" />
                        <tiles:put name="label" value="<%=item.getLabel()%>" />
                        <tiles:put name="size" value="30" />
                        <tiles:put name="units" value=""/>
                        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
                        <tiles:put name="bean" value="<%=formName%>" />
                        <tiles:put name="onChange" value="myOnChange()" />
        	    </tiles:insert>
                <% }
                  fields++; } %>


        </tr>
        </logic:iterate>

        <tr valign="top">
           <td class="table-text"  scope="row" valign="top" nowrap>
              <label for="type" TITLE="<bean:message key="healthclass.healthcondition.description"/>">
                <bean:message key="healthclass.type"/>
              </label>
              <br>
              <P CLASS="readOnlyElement" ID="type">
              <bean:message key="<%=testForm.getType()%>"/>
              &nbsp;
              </P>
           </td>
        </tr>
        <html:hidden property="type" name="<%=formName%>"/>
<%
//The last thing was the health condition, so here we wil put in the Health Condition attributes
		if (testForm.getType().equalsIgnoreCase("AGE")) { %>
                 <tr valign="top">
                    <td class="table-text"  scope="row">
                        <bean:message key="healthclass.age.healthcondition.description"/>
                    </td>
                 </tr>
                 <tr valign="top">
                    <td class="table-text"  scope="row" nowrap>
                       <FIELDSET id="age">
                          <legend for ="age" TITLE="<bean:message key="healthclass.age.healthcondition.description"/>">
                             <bean:message key="healthclass.conditionproperties"/>
                          </legend>
                          <table width="100%" border="0" cellspacing="0" cellpadding="0">
                            <tbody>
                              <tr valign="top">
                                <td class="complex-property" nowrap>
                                   <span class="requiredField">
                                   <br>
                                      <label for="age" TITLE="<bean:message key="healthclass.wizard.age.description"/>">
                                         <img src="images/attend.gif" width="8" height="8" align="absmiddle" alt='<bean:message key="information.required"/>'>
                                         <bean:message key="healthclass.age"/>
                                      </label>
                                   </span>
                                   <br>
                                   <html:text property="age"
                                         name="<%=formName%>"
                                         size="25"
                                         styleId="age"
                                         styleClass="textEntryRequired" />
                         	       <html:select property="ageUnits" name="<%=formName%>" styleId="ageUnits">
                                        <html:option value="UNITS_DAYS"><bean:message key="UNITS_DAYS"/></html:option>
                                        <html:option value="UNITS_HOURS"><bean:message key="UNITS_HOURS"/></html:option>
                         	       </html:select>
                                   <br>
                                </td>
                              </tr>
                          </table>
                       </FIELDSET>
                    </td>
                 </tr>
                 <tr valign="top">
                    <td class="table-text"  scope="row" nowrap>
                       <FIELDSET id="monitorReaction">
                          <legend for ="monitorReaction" TITLE="<bean:message key="healthclass.monitorreaction.description"/>">
                             <bean:message key="healthclass.monitorreaction"/>
                          </legend>
                          <table width="100%" border="0" cellspacing="0" cellpadding="0">
                            <tbody>
                              <tr valign="top">
                                <td class="complex-property" nowrap>
                                   <br>
                                   <label for="reactionMode" title='<bean:message key="healthclass.wizard.reactionMode.description"/>'>
                                       <bean:message key="healthclass.reactionMode" />
                                   </label>
                                   <br>
                                   <html:select property="reactionMode" name="<%=formName%>" styleId="reactionMode">
                                      <html:option value="REACTION_MODE_SUPERVISED">
                                        <bean:message key="REACTION_MODE_SUPERVISED"/>
                                      </html:option>
                                      <html:option value="REACTION_MODE_AUTOMATIC">
                                        <bean:message key="REACTION_MODE_AUTOMATIC"/>
                                      </html:option>
                                   </html:select>
                                   <br>
                                </td>
                              </tr>
                              <tr valign="top">
                                <td class="complex-property" nowrap>
                                   <span class="requiredField">
                                   <br>
                                      <label for="healthAction" TITLE="<bean:message key="healthclass.healthaction.select"/>">
                                         <img src="images/attend.gif" width="8" height="8" align="absmiddle" alt='<bean:message key="information.required"/>'>
                                         <bean:message key="healthclass.healthaction.select"/>
                                      </label>
                                   </span>
                                   <br>
                                   <html:multibox property="ageHealthAction" name="<%=formName%>" disabled="true" value="HEALTH_ACTION_RESTART" />
                                       <bean:message key="HEALTH_ACTION_RESTART" />
                                       <html:hidden property="ageHealthAction" name="<%=formName%>" value="HEALTH_ACTION_RESTART"/>
                                   <br>
                                </td>
                              </tr>
                          </table>
                       </FIELDSET>
                    </td>
                 </tr>

<%
		
		} else if (testForm.getType().equalsIgnoreCase("WORKLOAD")) {%>
                 <tr valign="top">
                    <td class="table-text"  scope="row">
                        <bean:message key="healthclass.workload.healthcondition.description"/>
                    </td>
                 </tr>
                 <tr valign="top">
                    <td class="table-text"  scope="row" nowrap>
                       <FIELDSET id="workload">
                          <legend for ="workload" TITLE="<bean:message key="healthclass.workload.healthcondition.description"/>">
                             <bean:message key="healthclass.conditionproperties"/>
                          </legend>
                          <table width="100%" border="0" cellspacing="0" cellpadding="0">
                            <tbody>
                              <tr valign="top">
                                <td class="complex-property" nowrap>
                                   <span class="requiredField">
                                   <br>
                                      <label for="totalRequests" TITLE="<bean:message key="healthclass.wizard.requests.description"/>">
                                         <img src="images/attend.gif" width="8" height="8" align="absmiddle" alt='<bean:message key="information.required"/>'>
                                         <bean:message key="healthclass.requests"/>
                                      </label>
                                   </span>
                                   <br>
                                   <html:text property="totalRequests"
                                         name="<%=formName%>"
                                         size="25"
                                         styleId="totalRequests"
                                         styleClass="textEntryRequired" />
                                   <br>
                                </td>
                              </tr>
                          </table>
                       </FIELDSET>
                    </td>
                 </tr>
                 <tr valign="top">
                    <td class="table-text"  scope="row" nowrap>
                       <FIELDSET id="monitorReaction">
                          <legend for ="monitorReaction" TITLE="<bean:message key="healthclass.monitorreaction.description"/>">
                             <bean:message key="healthclass.monitorreaction"/>
                          </legend>
                          <table width="100%" border="0" cellspacing="0" cellpadding="0">
                            <tbody>
                              <tr valign="top">
                                <td class="complex-property" nowrap>
                                   <br>
                                   <label for="reactionMode" title='<bean:message key="healthclass.wizard.reactionMode.description"/>'>
                                       <bean:message key="healthclass.reactionMode" />
                                   </label>
                                   <br>
                                   <html:select property="reactionMode" name="<%=formName%>" styleId="reactionMode">
                                      <html:option value="REACTION_MODE_SUPERVISED">
                                        <bean:message key="REACTION_MODE_SUPERVISED"/>
                                      </html:option>
                                      <html:option value="REACTION_MODE_AUTOMATIC">
                                        <bean:message key="REACTION_MODE_AUTOMATIC"/>
                                      </html:option>
                                   </html:select>
                                   <br>
                                </td>
                              </tr>
                              <tr valign="top">
                                <td class="complex-property" nowrap>
                                   <span class="requiredField">
                                   <br>
                                      <label for="healthAction" TITLE="<bean:message key="healthclass.healthaction.select"/>">
                                         <img src="images/attend.gif" width="8" height="8" align="absmiddle" alt='<bean:message key="information.required"/>'>
                                         <bean:message key="healthclass.healthaction.select"/>
                                      </label>
                                   </span>
                                   <br>
                                   <html:multibox property="workloadHealthAction" name="<%=formName%>" disabled="true" value="HEALTH_ACTION_RESTART" />
                                       <bean:message key="HEALTH_ACTION_RESTART" />
                                       <html:hidden property="workloadHealthAction" name="<%=formName%>" value="HEALTH_ACTION_RESTART"/>
                                   <br>
                                </td>
                              </tr>
                          </table>
                       </FIELDSET>
                    </td>
                 </tr>

<%
		
		} else if (testForm.getType().equalsIgnoreCase("MEMORY")) {%>
                 <tr valign="top">
                    <td class="table-text"  scope="row">
                        <bean:message key="healthclass.memory.healthcondition.description"/>
                        <br><br>
                        <img src="<%=request.getContextPath()%>/images/Information.gif" border="0" alt="<bean:message key="error.msg.information"/>"/>
                        <bean:message key="healthclass.memory.memoryleak.recommended.description"/>
                    </td>
                 </tr>
                 <tr valign="top">
                    <td class="table-text"  scope="row" nowrap>
                       <FIELDSET id="memory">
                          <legend for ="memory" TITLE="<bean:message key="healthclass.memory.healthcondition.description"/>">
                             <bean:message key="healthclass.conditionproperties"/>
                          </legend>
                          <table width="100%" border="0" cellspacing="0" cellpadding="0">
                            <tbody>
                              <tr valign="top">
                                <td class="complex-property" nowrap>
                                   <span class="requiredField">
                                   <br>
                                      <label for="totalMemory" TITLE="<bean:message key="healthclass.wizard.memory.description"/>">
                                         <img src="images/attend.gif" width="8" height="8" align="absmiddle" alt='<bean:message key="information.required"/>'>
                                         <bean:message key="healthclass.memory"/>
                                      </label>
                                   </span>
                                   <br>
                                   <html:text property="totalMemory"
                                         name="<%=formName%>"
                                         size="15"
                                         styleId="totalMemory"
                                         styleClass="textEntryRequired" /> <bean:message key="percent.sign"/>
                                   <br>
                                </td>
                              </tr>
                              <tr valign="top">
                                <td class="complex-property" nowrap>
                                   <span class="requiredField">
                                   <br>
                                      <label for="timeOverThreshold" TITLE="<bean:message key="healthclass.wizard.timeoverthreshold.description"/>">
                                         <img src="images/attend.gif" width="8" height="8" align="absmiddle" alt='<bean:message key="information.required"/>'>
                                         <bean:message key="healthclass.timeoverthreshold"/>
                                      </label>
                                   </span>
                                   <br>
                                   <html:text property="timeOverThreshold"
                                         name="<%=formName%>"
                                         size="25"
                                         styleId="timeOverThreshold"
                                         styleClass="textEntryRequired" />
                                   <html:select property="timeUnits" name="<%=formName%>" styleId="timeUnits">
                                        <html:option value="UNITS_MINUTES"><bean:message key="UNITS_MINUTES"/></html:option>
                                        <html:option value="UNITS_SECONDS"><bean:message key="UNITS_SECONDS"/></html:option>
                         	       </html:select>
                                   <br>
                                </td>
                              </tr>
                          </table>
                       </FIELDSET>
                    </td>
                 </tr>
                 <tr valign="top">
                    <td class="table-text"  scope="row" nowrap>
                       <FIELDSET id="monitorReaction">
                          <legend for ="monitorReaction" TITLE="<bean:message key="healthclass.monitorreaction.description"/>">
                             <bean:message key="healthclass.monitorreaction"/>
                          </legend>
                          <table width="100%" border="0" cellspacing="0" cellpadding="0">
                            <tbody>
                              <tr valign="top">
                                <td class="complex-property" nowrap>
                                   <br>
                                   <label for="reactionMode" title='<bean:message key="healthclass.wizard.reactionMode.description"/>'>
                                       <bean:message key="healthclass.reactionMode" />
                                   </label>
                                   <br>
                                   <html:select property="reactionMode" name="<%=formName%>" styleId="reactionMode">
                                      <html:option value="REACTION_MODE_SUPERVISED">
                                        <bean:message key="REACTION_MODE_SUPERVISED"/>
                                      </html:option>
                                      <html:option value="REACTION_MODE_AUTOMATIC">
                                        <bean:message key="REACTION_MODE_AUTOMATIC"/>
                                      </html:option>
                                   </html:select>
                                   <br>
                                </td>
                              </tr>
                              <tr valign="top">
                                <td class="complex-property" nowrap>
                                   <span class="requiredField">
                                   <br>
                                      <label for="healthAction" TITLE="<bean:message key="healthclass.healthaction.select"/>">
                                         <img src="images/attend.gif" width="8" height="8" align="absmiddle" alt='<bean:message key="information.required"/>'>
                                         <bean:message key="healthclass.healthaction.select"/>
                                      </label>
                                   </span>
                                   <br>
                                   <html:multibox property="memoryHealthAction" name="<%=formName%>" disabled="true" value="HEALTH_ACTION_RESTART" />
                                       <bean:message key="HEALTH_ACTION_RESTART" />
                                       <html:hidden property="memoryHealthAction" name="<%=formName%>" value="HEALTH_ACTION_RESTART"/>
                                   <br>
                                </td>
                              </tr>
                          </table>
                       </FIELDSET>
                    </td>
                 </tr>
<%
			
		} else if (testForm.getType().equalsIgnoreCase("RESPONSE")) {%>
                 <tr valign="top">
                    <td class="table-text"  scope="row">
                        <bean:message key="healthclass.response.healthcondition.description"/>
                    </td>
                 </tr>
                 <tr valign="top">
                    <td class="table-text"  scope="row" nowrap>
                       <FIELDSET id="response">
                          <legend for ="response" TITLE="<bean:message key="healthclass.response.healthcondition.description"/>">
                             <bean:message key="healthclass.conditionproperties"/>
                          </legend>
                          <table width="100%" border="0" cellspacing="0" cellpadding="0">
                            <tbody>
                              <tr valign="top">
                                <td class="complex-property" nowrap>
                                   <span class="requiredField">
                                   <br>
                                      <label for="responseTime" TITLE="<bean:message key="healthclass.wizard.responsetime.description"/>">
                                         <img src="images/attend.gif" width="8" height="8" align="absmiddle" alt='<bean:message key="information.required"/>'>
                                         <bean:message key="healthclass.responsetime"/>
                                      </label>
                                   </span>
                                   <br>
                                   <html:text property="responseTime"
                                         name="<%=formName%>"
                                         size="25"
                                         styleId="responseTime"
                                         styleClass="textEntryRequired" />
                                   <html:select property="responseTimeUnits" name="<%=formName%>" styleId="responseTimeUnits">
                                        <html:option value="UNITS_MINUTES"><bean:message key="UNITS_MINUTES"/></html:option>
                                        <html:option value="UNITS_SECONDS"><bean:message key="UNITS_SECONDS"/></html:option>
                                        <html:option value="UNITS_MILLISECONDS"><bean:message key="UNITS_MILLISECONDS"/></html:option>
                         	       </html:select>
                                   <br>
                                </td>
                              </tr>
                          </table>
                       </FIELDSET>
                    </td>
                 </tr>
                 <tr valign="top">
                    <td class="table-text"  scope="row" nowrap>
                       <FIELDSET id="monitorReaction">
                          <legend for ="monitorReaction" TITLE="<bean:message key="healthclass.monitorreaction.description"/>">
                             <bean:message key="healthclass.monitorreaction"/>
                          </legend>
                          <table width="100%" border="0" cellspacing="0" cellpadding="0">
                            <tbody>
                              <tr valign="top">
                                <td class="complex-property" nowrap>
                                   <br>
                                   <label for="reactionMode" title='<bean:message key="healthclass.wizard.reactionMode.description"/>'>
                                       <bean:message key="healthclass.reactionMode" />
                                   </label>
                                   <br>
                                   <html:select property="reactionMode" name="<%=formName%>" styleId="reactionMode">
                                      <html:option value="REACTION_MODE_SUPERVISED">
                                        <bean:message key="REACTION_MODE_SUPERVISED"/>
                                      </html:option>
                                      <html:option value="REACTION_MODE_AUTOMATIC">
                                        <bean:message key="REACTION_MODE_AUTOMATIC"/>
                                      </html:option>
                                   </html:select>
                                   <br>
                                </td>
                              </tr>
                              <tr valign="top">
                                <td class="complex-property" nowrap>
                                   <span class="requiredField">
                                   <br>
                                      <label for="healthAction" TITLE="<bean:message key="healthclass.healthaction.select"/>">
                                         <img src="images/attend.gif" width="8" height="8" align="absmiddle" alt='<bean:message key="information.required"/>'>
                                         <bean:message key="healthclass.healthaction.select"/>
                                      </label>
                                   </span>
                                   <br>
                                   <html:multibox property="responseHealthAction" name="<%=formName%>" disabled="true" value="HEALTH_ACTION_RESTART" />
                                       <bean:message key="HEALTH_ACTION_RESTART" />
                                       <html:hidden property="responseHealthAction" name="<%=formName%>" value="HEALTH_ACTION_RESTART"/>
                                   <br>
                                </td>
                              </tr>
                          </table>
                       </FIELDSET>
                    </td>
                 </tr>
<%

		} else if (testForm.getType().equalsIgnoreCase("STUCKREQUEST")) {%>
                 <tr valign="top">
                    <td class="table-text"  scope="row">
                        <bean:message key="healthclass.stuckrequest.healthcondition.description"/>
                    </td>
                 </tr>
                 <tr valign="top">
                    <td class="table-text"  scope="row" nowrap>
                       <FIELDSET id="stuckRequest">
                          <legend for ="stuckRequest" TITLE="<bean:message key="healthclass.stuckrequest.healthcondition.description"/>">
                             <bean:message key="healthclass.conditionproperties"/>
                          </legend>
                          <table width="100%" border="0" cellspacing="0" cellpadding="0">
                            <tbody>
                              <tr valign="top">
                                <td class="complex-property" nowrap>
                                   <span class="requiredField">
                                   <br>
                                      <label for="timeoutPercent" TITLE="<bean:message key="healthclass.wizard.timeoutpercent.description"/>">
                                         <img src="images/attend.gif" width="8" height="8" align="absmiddle" alt='<bean:message key="information.required"/>'>
                                         <bean:message key="healthclass.timeoutpercent"/>
                                      </label>
                                   </span>
                                   <br>
                                   <html:text property="timeoutPercent"
                                         name="<%=formName%>"
                                         size="15"
                                         styleId="timeoutPercent"
                                         styleClass="textEntryRequired" /> <bean:message key="percent.sign"/>
                                   <br>
                                </td>
                              </tr>
                          </table>
                       </FIELDSET>
                    </td>
                 </tr>
                 <tr valign="top">
                    <td class="table-text"  scope="row" nowrap>
                       <FIELDSET id="monitorReaction">
                          <legend for ="monitorReaction" TITLE="<bean:message key="healthclass.monitorreaction.description"/>">
                             <bean:message key="healthclass.monitorreaction"/>
                          </legend>
                          <table width="100%" border="0" cellspacing="0" cellpadding="0">
                            <tbody>
                              <tr valign="top">
                                <td class="complex-property" nowrap>
                                   <br>
                                   <label for="reactionMode" title='<bean:message key="healthclass.wizard.reactionMode.description"/>'>
                                       <bean:message key="healthclass.reactionMode" />
                                   </label>
                                   <br>
                                   <html:select property="reactionMode" name="<%=formName%>" styleId="reactionMode">
                                      <html:option value="REACTION_MODE_SUPERVISED">
                                        <bean:message key="REACTION_MODE_SUPERVISED"/>
                                      </html:option>
                                      <html:option value="REACTION_MODE_AUTOMATIC">
                                        <bean:message key="REACTION_MODE_AUTOMATIC"/>
                                      </html:option>
                                   </html:select>
                                   <br>
                                </td>
                              </tr>
                              <tr valign="top">
                                <td class="complex-property" nowrap>
                                   <span class="requiredField">
                                   <br>
                                      <label for="healthAction" TITLE="<bean:message key="healthclass.healthaction.select"/>">
                                         <img src="images/attend.gif" width="8" height="8" align="absmiddle" alt='<bean:message key="information.required"/>'>
                                         <bean:message key="healthclass.healthaction.select"/>
                                      </label>
                                   </span>
                                   <br>
                                   <html:multibox property="stuckRequestHealthAction" name="<%=formName%>" value="HEALTH_ACTION_THREADDUMP" />
                                       <bean:message key="HEALTH_ACTION_THREADDUMP" />
                                   <br>
                                   <html:multibox property="stuckRequestHealthAction" name="<%=formName%>" value="HEALTH_ACTION_RESTART" />
                                       <bean:message key="HEALTH_ACTION_RESTART" />
                                   <br>
                                </td>
                              </tr>
                          </table>
                       </FIELDSET>
                    </td>
                 </tr>
<%

		} else if (testForm.getType().equalsIgnoreCase("STORMDRAIN")) {%>
                 <tr valign="top">
                    <td class="table-text"  scope="row">
                        <bean:message key="healthclass.stormdrain.healthcondition.description"/>
                    </td>
                 </tr>
                 <tr valign="top">
                    <td class="table-text"  scope="row" nowrap>
                       <FIELDSET id="stormDrain">
                          <legend for ="stormDrain" TITLE="<bean:message key="healthclass.stormdrain.healthcondition.description"/>">
                             <bean:message key="healthclass.conditionproperties"/>
                          </legend>
                          <table width="100%" border="0" cellspacing="0" cellpadding="0">
                            <tbody>
                              <tr valign="top">
                                <td class="complex-property" nowrap>
                                   <br>
                                      <label for="detectionlevel" TITLE="<bean:message key="healthclass.stormdrain.detection.description"/>">
                                         <bean:message key="healthclass.detectionlevel"/>
                                      </label>
                                   <br>
                                   <html:radio property="stormDrainConditionLevel"
                                               name="<%=formName%>"
                                               styleId="stormDrainConditionLevel"
                                               value="CONDITION_LEVEL_NORMAL"/>
                                      <bean:message key="healthclass.stormdrain.normallevel"/>
                                   <br>
                                   <html:radio property="stormDrainConditionLevel"
                                               name="<%=formName%>"
                                               styleId="stormDrainConditionLevel"
                                               value="CONDITION_LEVEL_CONSERVATIVE"/>
                                      <bean:message key="healthclass.stormdrain.conservativelevel"/>
                                   <br>
                                   <br>
                                </td>
                              </tr>
                          </table>
                       </FIELDSET>
                    </td>
                 </tr>
                 <tr valign="top">
                    <td class="table-text"  scope="row" nowrap>
                       <FIELDSET id="monitorReaction">
                          <legend for ="monitorReaction" TITLE="<bean:message key="healthclass.monitorreaction.description"/>">
                             <bean:message key="healthclass.monitorreaction"/>
                          </legend>
                          <table width="100%" border="0" cellspacing="0" cellpadding="0">
                            <tbody>
                              <tr valign="top">
                                <td class="complex-property" nowrap>
                                   <br>
                                   <label for="reactionMode" title='<bean:message key="healthclass.wizard.reactionMode.description"/>'>
                                       <bean:message key="healthclass.reactionMode" />
                                   </label>
                                   <br>
                                   <html:select property="reactionMode" name="<%=formName%>" styleId="reactionMode">
                                      <html:option value="REACTION_MODE_SUPERVISED">
                                        <bean:message key="REACTION_MODE_SUPERVISED"/>
                                      </html:option>
                                      <html:option value="REACTION_MODE_AUTOMATIC">
                                        <bean:message key="REACTION_MODE_AUTOMATIC"/>
                                      </html:option>
                                   </html:select>
                                   <br>
                                </td>
                              </tr>
                              <tr valign="top">
                                <td class="complex-property" nowrap>
                                   <span class="requiredField">
                                   <br>
                                      <label for="healthAction" TITLE="<bean:message key="healthclass.healthaction.select"/>">
                                         <img src="images/attend.gif" width="8" height="8" align="absmiddle" alt='<bean:message key="information.required"/>'>
                                         <bean:message key="healthclass.healthaction.select"/>
                                      </label>
                                   </span>
                                   <br>
                                   <html:multibox property="stormDrainHealthAction" name="<%=formName%>" disabled="true" value="HEALTH_ACTION_RESTART" />
                                       <bean:message key="HEALTH_ACTION_RESTART" />
                                       <html:hidden property="stormDrainHealthAction" name="<%=formName%>" value="HEALTH_ACTION_RESTART"/>
                                   <br>
                                </td>
                              </tr>
                          </table>
                       </FIELDSET>
                    </td>
                 </tr>
<%

		} else if (testForm.getType().equalsIgnoreCase("MEMORYLEAK")) {%>
                 <tr valign="top">
                    <td class="table-text"  scope="row">
                        <bean:message key="healthclass.memoryleak.healthcondition.description"/>
                        <br><br>
                        <img src="<%=request.getContextPath()%>/images/Information.gif" border="0" alt="<bean:message key="error.msg.information"/>"/>
                        <bean:message key="healthclass.memory.memoryleak.recommended.description"/>
                    </td>
                 </tr>
                 <tr valign="top">
                    <td class="table-text"  scope="row" nowrap>
                       <FIELDSET id="memoryLeak">
                          <legend for ="memoryLeak" TITLE="<bean:message key="healthclass.memoryleak.healthcondition.description"/>">
                             <bean:message key="healthclass.conditionproperties"/>
                          </legend>
                          <table width="100%" border="0" cellspacing="0" cellpadding="0">
                            <tbody>
                              <tr valign="top">
                                <td class="complex-property" nowrap>
                                   <br>
                                      <label for="detectionlevel" TITLE="<bean:message key="healthclass.memoryleak.detection.description"/>">
                                         <bean:message key="healthclass.detectionlevel"/>
                                      </label>
                                   <br>
                                   <html:radio property="memoryLeakConditionLevel"
                                               name="<%=formName%>"
                                               styleId="memoryLeakConditionLevel"
                                               value="CONDITION_LEVEL_AGGRESSIVE"/>
                                      <bean:message key="healthclass.memoryleak.aggressivelevel"/>
                                   <br>
                                   <html:radio property="memoryLeakConditionLevel"
                                               name="<%=formName%>"
                                               styleId="memoryLeakConditionLevel"
                                               value="CONDITION_LEVEL_NORMAL"/>
                                      <bean:message key="healthclass.memoryleak.normallevel"/>
                                   <br>
                                   <html:radio property="memoryLeakConditionLevel"
                                               name="<%=formName%>"
                                               styleId="memoryLeakConditionLevel"
                                               value="CONDITION_LEVEL_CONSERVATIVE"/>
                                      <bean:message key="healthclass.memoryleak.conservativelevel"/>
                                   <br>
                                </td>
                              </tr>
                          </table>
                       </FIELDSET>
                    </td>
                 </tr>
                 <tr valign="top">
                    <td class="table-text"  scope="row" nowrap>
                       <FIELDSET id="monitorReaction">
                          <legend for ="monitorReaction" TITLE="<bean:message key="healthclass.monitorreaction.description"/>">
                             <bean:message key="healthclass.monitorreaction"/>
                          </legend>
                          <table width="100%" border="0" cellspacing="0" cellpadding="0">
                            <tbody>
                              <tr valign="top">
                                <td class="complex-property" nowrap>
                                   <br>
                                   <label for="reactionMode" title='<bean:message key="healthclass.wizard.reactionMode.description"/>'>
                                       <bean:message key="healthclass.reactionMode" />
                                   </label>
                                   <br>
                                   <html:select property="reactionMode" name="<%=formName%>" styleId="reactionMode">
                                      <html:option value="REACTION_MODE_SUPERVISED">
                                        <bean:message key="REACTION_MODE_SUPERVISED"/>
                                      </html:option>
                                      <html:option value="REACTION_MODE_AUTOMATIC">
                                        <bean:message key="REACTION_MODE_AUTOMATIC"/>
                                      </html:option>
                                   </html:select>
                                   <br>
                                </td>
                              </tr>
                              <tr valign="top">
                                <td class="complex-property" nowrap>
                                   <span class="requiredField">
                                   <br>
                                      <label for="healthAction" TITLE="<bean:message key="healthclass.healthaction.select"/>">
                                         <img src="images/attend.gif" width="8" height="8" align="absmiddle" alt='<bean:message key="information.required"/>'>
                                         <bean:message key="healthclass.healthaction.select"/>
                                      </label>
                                   </span>
                                   <br>
                                   <html:multibox property="memoryLeakHealthAction" name="<%=formName%>" value="HEALTH_ACTION_HEAPDUMP" />
                                       <bean:message key="HEALTH_ACTION_HEAPDUMP" />
                                   <br>
                                   <html:multibox property="memoryLeakHealthAction" name="<%=formName%>" value="HEALTH_ACTION_RESTART" />
                                       <bean:message key="HEALTH_ACTION_RESTART" />
                                   <br>
                                </td>
                              </tr>
                          </table>
                       </FIELDSET>
                    </td>
                 </tr>
<%

	}

MessageResources messages = (MessageResources)application.getAttribute(Action.MESSAGES_KEY);
java.util.Locale locale = request.getLocale();
ArrayList availableMembers = (ArrayList)testForm.getAvailableNames();
ArrayList selectedNodesBean = (ArrayList)testForm.getCurrentMembership(messages, locale);
//Do the dropdown with the member types
Collection memberTypes = new ArrayList();
memberTypes.add(new org.apache.struts.util.LabelValueBean(messages.getMessage(locale,"member.type.none"),String.valueOf(Constants.MEMBER_TYPE_NONE)));
if (testForm.getType().equalsIgnoreCase("STORMDRAIN")) {
   memberTypes.add(new org.apache.struts.util.LabelValueBean(messages.getMessage(locale,"member.type.dynamiccluster"),String.valueOf(XDConstants.DYNAMICCLUSTER_MEMBER)));
   memberTypes.add(new org.apache.struts.util.LabelValueBean(messages.getMessage(locale,"member.type.cell"),String.valueOf(XDConstants.CELL_MEMBER)));
//
// defect 305139
// commented out GSC support for now, will add this back in XD 7.0
// and also GSCs would have applied to more policy types other than RESPONSE
//
// } else if (testForm.getType().equalsIgnoreCase("RESPONSE")) {
//    memberTypes.add(new org.apache.struts.util.LabelValueBean(messages.getMessage(locale,"member.type.appserver"),String.valueOf(XDConstants.APPSERVER_MEMBER)));
//    memberTypes.add(new org.apache.struts.util.LabelValueBean(messages.getMessage(locale,"member.type.cluster"),String.valueOf(XDConstants.CLUSTER_MEMBER)));
//    memberTypes.add(new org.apache.struts.util.LabelValueBean(messages.getMessage(locale,"member.type.dynamiccluster"),String.valueOf(XDConstants.DYNAMICCLUSTER_MEMBER)));
//    memberTypes.add(new org.apache.struts.util.LabelValueBean(messages.getMessage(locale,"member.type.cell"),String.valueOf(XDConstants.CELL_MEMBER)));
//    memberTypes.add(new org.apache.struts.util.LabelValueBean(messages.getMessage(locale,"member.type.genericservercluster"),String.valueOf(XDConstants.GENERICSERVERCLUSTER_MEMBER)));
} else {
   memberTypes.add(new org.apache.struts.util.LabelValueBean(messages.getMessage(locale,"member.type.appserver"),String.valueOf(XDConstants.APPSERVER_MEMBER)));
   memberTypes.add(new org.apache.struts.util.LabelValueBean(messages.getMessage(locale,"member.type.cluster"),String.valueOf(XDConstants.CLUSTER_MEMBER)));
   memberTypes.add(new org.apache.struts.util.LabelValueBean(messages.getMessage(locale,"member.type.dynamiccluster"),String.valueOf(XDConstants.DYNAMICCLUSTER_MEMBER)));
   memberTypes.add(new org.apache.struts.util.LabelValueBean(messages.getMessage(locale,"member.type.cell"),String.valueOf(XDConstants.CELL_MEMBER)));
}

//To make the boxes stay at a specific minimum size, we are going to add one at the bottom to provide a minimum size
if (!selectedNodesBean.contains("-------------------------------------------"))
	selectedNodesBean.add(selectedNodesBean.size(),"-------------------------------------------");
if (!availableMembers.contains("-------------------------------------------"))
	availableMembers.add(availableMembers.size(),"-------------------------------------------");

String hcName = testForm.getRefId();
String selectedTypeString = testForm.getSelectedType(); //this is already translated

pageContext.setAttribute("availableNodesBean", availableMembers);
pageContext.setAttribute("selectedNodesBean", selectedNodesBean);
pageContext.setAttribute("appNamesBean", memberTypes);

String availNodesSelectChange = "initVars(this, " + healthConditionType + "); setSelectedNodes(selectedAvailableNodes, availNodes)";
String currNodesSelectChange = "initVars(this, " + healthConditionType + ");setSelectedNodes(selectedCurrentNodes, currentNodes)";
String removeButtonClicked = "initVars(this, " + healthConditionType + ");removeClicked(selectedCurrentNodes)";
String addButtonClicked = "initVars(this, " + healthConditionType + ");addClicked(selectedAvailableNodes)";
String memberTypeChanged = "initVars(this, " + healthConditionType + ");memberTypeChange()";
%>


<!-- INSERT THE MEMBERSHIP ROW HERE -->
<%
int numMembershipColumns = Integer.parseInt(numberOfColumns);
if (numMembershipColumns > 0)
	numMembershipColumns--;
	fieldLevelHelpTopic = topicKey + "membership"; 		
%>
<br>
    <tr>
        <td class="table-text"  scope="row" valign="top" nowrap>
        	<FIELDSET id="selectTemplate">
               	<legend for ="membership" TITLE="<bean:message key="healthclass.detail.membershipdescription"/>">
                 	<bean:message key="healthclass.details.membership"/>
               	</legend>

			<table class="framing-table" border="0" cellpadding="0" cellspacing="0" width="100%">									
				<tr>
					<td class="table-text">
						<table>
							<tr>
								<td class="table-text">
									<bean:message key="member.type" /> 							
									&nbsp;&nbsp;
									<html:select size="1" value="<%=selectedTypeString%>" property="notUsed" onchange="<%=memberTypeChanged%>">
                                                                           <html:options collection="appNamesBean" property="value" labelProperty="label" />
									</html:select>
								</td>
							</tr>
						</table>
						<br>
						<table>
							<tr>
								<td valign="top"><span class="table-text"><center>
									<bean:message key="healthclass.details.availableMembers"   />
									</center></span>
								</td>
								<td>&nbsp;</td>
								<td valign="top"> <span class="table-text"><center>
									<bean:message key="healthclass.details.membersOf" arg0="<%=hcName%>" />
									</center></span>
								</td>
							</tr>
							<tr>
								<td valign="top" class="table-text" width="35%">
									<html:select multiple="true" size="7" property="notUsed"
												 onchange="<%=availNodesSelectChange%>">
										<html:options name="availableNodesBean" />
									</html:select>
								</td>	
                                <td class="table-text" align="center" valign="middle" cellpadding="10" width="30%">
									<html:button styleClass="buttons" property="notUsed"
												 onclick="<%=addButtonClicked%>"
												 styleId="other" style="width:100%;">
										<bean:message key="healthclass.button.add" />
									</html:button>
								<br>
								<br>
									<html:button styleClass="buttons" property="notUsed"
												 onclick="<%=removeButtonClicked%>"
												 styleId="other" style="width:100%;">
										 <bean:message key="healthclass.button.remove" />
									</html:button>
								</td>
								<td rowspan="2" valign="top" class="table-text" width="35%">
									<html:select multiple="true" size="7" property="notUsed"
												 onchange="<%=currNodesSelectChange%>">
										<html:options name="selectedNodesBean" />
									</html:select>
								</td>
							</tr>
						</table>
					</td>
    			</tr>
    		</table>
    	</FIELDSET>
    	</td>
    	
    </tr>

    <% String initVars = "initVars(this, " + healthConditionType + ");";
       String applyClick = initVars + " submitIt()";
       String resetClick = initVars + " resetForm()";
    %>

   	<tr>
      	<td class="button-section" colspan="<%= numberOfColumns %>">
        	<input type="submit" name="apply" value="<bean:message key="button.apply"/>" class="buttons" id="navigation" onclick="<%=applyClick%>">
        	<input type="submit" name="save" value="<bean:message key="button.ok"/>" class="buttons" id="navigation" onclick="<%=applyClick%>">
        	<input type="reset" name="reset" value="<bean:message key="button.reset"/>" class="buttons" id="navigation" onClick="<%=resetClick%>">
        	<input type="submit" name="org.apache.struts.taglib.html.CANCEL" value="<bean:message key="button.cancel"/>" class="buttons" id="navigation">
      	</td>
  	</tr>
	</tbody>
</table>

</html:form>

<%}
%>
