<%-- IBM Confidential OCO Source Material --%>
<%-- 5724-J34 (C) COPYRIGHT International Business Machines Corp. 1997, 2005 --%>
<%-- The source code for this program is not published or otherwise divested --%>
<%-- of its trade secrets, irrespective of what has been deposited with the --%>
<%-- U.S. Copyright Office. --%>

<%@ page import="com.ibm.ws.sm.workspace.*"%>
<%@ page import="com.ibm.ws.workspace.query.*"%>
<%@ page import="com.ibm.ws.console.core.*"%>
<%@ page import="com.ibm.ws.console.core.ConfigFileHelper"%>  <%-- LIDB2303A --%>
<%@ page import="java.util.*,com.ibm.ws.security.core.SecurityContext,com.ibm.websphere.product.*"%>
<%@ page import="com.ibm.websphere.management.metadata.ManagedObjectMetadataAccessor"%>
<%@ page import="com.ibm.websphere.management.metadata.ManagedObjectMetadataAccessorFactory"%>
<%@ page import="com.ibm.ws.console.core.selector.*"%>
<%@ page import="com.ibm.ws.*"%>
<%@ page import="com.ibm.wsspi.*"%>
<%@ page import="com.ibm.ws.console.taskconfig.form.NotificationDetailForm"%>

<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/tiles.tld" prefix="tiles" %>
<%@ taglib uri="/WEB-INF/ibmcommon.tld" prefix="ibmcommon" %>

<tiles:useAttribute  name="readOnlyView" classname="java.lang.String"/>
<tiles:useAttribute  name="attributeList" classname="java.util.List"/>
<tiles:useAttribute name="formAction" classname="java.lang.String" />
<tiles:useAttribute name="formName" classname="java.lang.String" />
<tiles:useAttribute name="formType" classname="java.lang.String" />
<tiles:useAttribute name="formFocus" classname="java.lang.String" />

<%String contextId = null;%>
<logic:notEmpty name="<%=formName%>" property="contextId">
<bean:define id="contextId_new" name="<%=formName%>" property="contextId" type="java.lang.String"/>
<%contextId = contextId_new;%>
</logic:notEmpty>

<bean:define id="perspective"    name="<%=formName%>" property="perspective"/>


<script language="JavaScript">
var changing = false;
var selectedCurrentNodes; // array of currently selected member nodes
var currentNodes;
var outputField;
var inited = false;
var originalOutputField;
var emailField;

function initVars(formElem){
	if (inited){
		return inited;
	}
	
	changing = false;
	var theform = formElem.form;
		
	selectedCurrentNodes = new Array(); //associative array of currently selected member nodes (keyed on Node Name)
	emailField = theform.elements[7];
	currentNodes = theform.elements[10];
	outputField =	theform.elements[11]; //this is the hidden field
	updateHiddenFields();
	originalOutputField = outputField.value;

	inited=true;
	return inited;
}

//this function removes all elements from the array "nodeList"
function empty(nodeList){
	var len = nodeList.length;
	for (x=0; x<len; x++){
		nodeList.pop();
	}
}


//removes leading and trailing whitespace from a string
function trimString(string){
    var s = string.replace(/^\s+/g, ""); //remove leading whitespace
    return s.replace(/\s+$/g, ""); //remove leading whitespace;
}

/*
Removes all references to "removeThis" from "from"
from:  Array from which any references that are equal to "removeThis" will be removed
removeThis: object which will be removed from "from"
*/
function remove(from, removeThis){
	for (var x = 0; x < from.length; x++){
		if (from[x] == removeThis){
			from[x] = null; //since from is an options array, doing this removes the object
		}
	}
}

/*
This function sets the global selectedAvailableNodes array to correspond with the selected
objects in the box represented by "nodeList" (either currentNodes or availNodes)
*/
function setSelected(nodeList, selectObject){
	changing = true;
	empty(nodeList);	
	if (selectObject.selectedIndex != -1){
		var index=0;
		var str;
		for (var x = 0; x < selectObject.options.length; x++) {
			if (selectObject.options[x].selected){				
				nodeList[index++] = selectObject.options[x]; //copy a reference to this field into our list of selected Options
			}				
		}		
	}	
	var tempString="";
	first = true;
	for (var y = 0; y < nodeList.length; y++){
		if (!first){
			tempString += ",";			
		}
		tempString += nodeList[y].value;
		first = false;
	}	
	changing = false;
}

/*
Adds all objects in "optionsToMove" to "to", and removes all of those objects from "from"
optionsToMove: one of either selectedCurrentCL or selectedAvailableCL
from:  An options array (from either availCL or currentNodes)
to:    An options array (from the other of either availCL or currentNodes)
*/
function addOption(optionToAdd, to){
        optionToAdd.value = trimString(optionToAdd.value);
        if (optionToAdd.value != ""){
          changing = true;
          to[to.length] = new Option(optionToAdd.value, optionToAdd.value, false, false);
          updateHiddenFields();
          emailField.value="";
          changing = false;
        }
}

function removeOption(optionsToMove, from) {
        changing = true;
        for(var x = 0; x < from.length; x++){
                if (!from[x].selected)
                        continue;
                moveThis = from[x];
                remove(from, moveThis);
                x--;//we removed the top of the list...gotta bump back this index.  we could start at the end of the list and work backwards, but then the items would be added in reverse order, which could look weird.
        }
        updateHiddenFields();
        //empty(optionsToMove);
        changing = false;
}


function updateHiddenFields(){	
	var tempString = "";
	if (currentNodes.options.length > 0){
		tempString += currentNodes.options[0].value;
		for (var x = 1; x < currentNodes.options.length; x++){
			tempString += "," + currentNodes.options[x].value;
		}		
	}	
	outputField.value = tempString;	
	
}
function submitIt(){
	updateHiddenFields();
}

//this function resets the membership form to the initial state (before any changes were made by the user)
function resetForm(){
	setOptionsList(currentNodes.options, originalOutputField);
}

//optionsList: options array from a select object which will be emptied, and repopulated according to "stringValue"
//stringValue: "," tokenized string of values which correspond to the nodes which will be placed in "optionsList"
function setOptionsList(optionsList, stringValue){
	optionsList.length = 0;
	var tokens = stringValue.split(",");
	for (var a = 0; a < tokens.length; a++){
		if (tokens[a].length > 0)
			optionsList[optionsList.length] = new Option(tokens[a], tokens[a], false, false);			
	}
}


</script>

<%

String contextType=(String)request.getAttribute("contextType");
String cellname = null;
String nodename = null;
String token = null;
java.util.Properties props= null;

java.util.ArrayList attributeList_ext =  new java.util.ArrayList();
for(int i=0;i<attributeList.size(); i++)
     attributeList_ext.add(attributeList.get(i));

IPluginRegistry registry= IPluginRegistryFactory.getPluginRegistry();

String extensionId = "com.ibm.websphere.wsc.form";
IConfigurationElementSelector ic = new ConfigurationElementSelector(contextType,extensionId);

IExtension[] extensions= registry.getExtensions(extensionId,ic);

if(extensions!=null && extensions.length>0){
    if(contextId!=null && contextId!="nocontext"){
        props = ConfigFileHelper.getNodeMetadataProperties((String)contextId); //213515
    }

    props = ConfigFileHelper.getAdditionalAdaptiveProperties(request, props, formName); // LIDB2303A

    attributeList_ext = FieldSelector.getFields(extensions,attributeList_ext,props,(String)perspective);
    }
attributeList_ext = FieldSelector.getCategories(extensions,attributeList_ext,(String)perspective);

pageContext.setAttribute("attributeList_ext",attributeList_ext);


%>


<%  String renderReadOnlyView = "no";
if( (readOnlyView != null) && (readOnlyView.equalsIgnoreCase("yes")) ) {
  renderReadOnlyView = "yes";
} else if (SecurityContext.isSecurityEnabled()) {
    renderReadOnlyView = "yes";
    if (request.isUserInRole("administrator")) {
        renderReadOnlyView = "no";
    }
    else if (request.isUserInRole("configurator")) {
        renderReadOnlyView = "no";
    }
}
%>

<%
        //Boolean descriptionsOn = (Boolean) session.getAttribute("descriptionsOn");
        String numberOfColumns = "3";
        //if (descriptionsOn.booleanValue() == false)
        // numberOfColumns = "2";
        WASProduct productInfo = new WASProduct();
%>

<%
   String fieldLevelHelpTopic = "";
   String fieldLevelHelpAttribute = "";
   String DETAILFORM = "DetailForm";
   String objectType = "";
   int index = formType.lastIndexOf ('.');
   if (index > 0)
   {
      String fType = formType.substring (index+1);
      if (fType.endsWith (DETAILFORM))
         objectType = fType.substring (0, fType.length()-DETAILFORM.length());
      else
         objectType = fType;
   }
   fieldLevelHelpTopic = objectType+".detail.";
   String topicKey = fieldLevelHelpTopic;
%>


<%
//  If there's no properties, don't show this section
if (attributeList_ext.size() > 0) {
%>


   <a name="general"></a>
       <h2><bean:message key="config.general.properties"/></H2>

    <% if (renderReadOnlyView.equalsIgnoreCase("yes")) { %>


<html:form action="<%=formAction%>" name="<%=formName%>" type="<%=formType%>">
<%--html:hidden property="action"/--%>

<table class="framing-table" border="0" cellpadding="5" cellspacing="0" width="100%" summary="Properties Table" >

    <tbody>

    <%

               int propCounterReadOnly = 0;
               String activeSubhead = "";



             %>


    <logic:iterate id="item" name="attributeList_ext" type="com.ibm.ws.console.core.item.PropertyItem">

    <%if (item.getCategoryId()!=null) {
	%>

        <%
          if ((!activeSubhead.equals(item.getCategoryId()) && (!activeSubhead.equals(""))) || ((item.getCategoryId().equalsIgnoreCase("general") && propCounterReadOnly!=0))) {
    	%>

        </TABLE>
        </FIELDSET>
        </TD>
        </TR>

        <%
    	  }
          if(!item.getCategoryId().equalsIgnoreCase("general")){
              activeSubhead = item.getCategoryId();
    	%>

        <TR>
        <TD CLASS="table-text">

        <FIELDSET>
        <LEGEND>
          <bean:message key="<%=item.getCategoryId()%>"/>
        </LEGEND>

        <table class="categorizedField" id="<%=item.getCategoryId()%>" border="0" cellpadding="5" cellspacing="0" width="100%" summary="Properties Category Table" >




    <%}else
         activeSubhead="";
        } else { %>





    <%        fieldLevelHelpAttribute = item.getAttribute();
            if (fieldLevelHelpAttribute.equals(" ") || fieldLevelHelpAttribute.equals(""))
                fieldLevelHelpTopic = item.getLabel();
            else
                fieldLevelHelpTopic = topicKey + fieldLevelHelpAttribute;
            //this code gets productId from icon attribute of PropertyItem
            //and checks if product is installed
            // If product  is installed , then make row visible
            String productId = item.getIcon();
            boolean productEnabled = true;
            if ( (productId == null)  || (productId !=null && productId.equals("")) ) {
                productId = "BASE";
        } else if (productId.equals("ND") && productInfo.productPresent(productId)) {
            WorkSpaceQueryUtil util = WorkSpaceQueryUtilFactory.getUtil();
            RepositoryContext cellContext = (RepositoryContext)session.getAttribute(com.ibm.ws.console.core.Constants.CURRENTCELLCTXT_KEY);
            try {
                if (util.isStandAloneCell(cellContext)) {
                    productEnabled = false;
                }
                else {
                    productEnabled = true;
                }
            }
            catch (Exception e) {
                System.out.println("exception in util.isStandAloneCell " + e.toString());
                productEnabled = false;
            }
        } else if (productId.equals("PME") && productInfo.productPresent(productId)) {
                productEnabled = true;
        } else {
            productEnabled = false;
        }

            if (productEnabled) {
    %>


    <tr valign="top">
                <% if (item.getType().equalsIgnoreCase("Custom")) { %>

        <tiles:insert page="/secure/layouts/customLayout.jsp" flush="false">
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        <tiles:put name="readOnly" value="true" />
        <tiles:put name="jspPage" value="<%=item.getUnits()%>"/>
        <tiles:put name="units" value=""/>
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="isRequired" value="<%=item.getRequired()%>" />
        <tiles:put name="size" value="30" />
        </tiles:insert>

                <% } else if (item.getType().equalsIgnoreCase("jsp")) { %>

        <tiles:insert page="<%=item.getUnits()%>" flush="false">
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        <tiles:put name="readOnly" value="true" />
        <tiles:put name="jspPage" value="<%=item.getUnits()%>"/>
        <tiles:put name="units" value=""/>
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="isRequired" value="<%=item.getRequired()%>" />
        <tiles:put name="size" value="30" />
        </tiles:insert>

                    <% } else if (item.getType().equalsIgnoreCase("select")) {

                        try {
                            session.removeAttribute("valueVector");
                            session.removeAttribute("descVector");
                        }
                        catch (Exception e) {
                        }

                        StringTokenizer st1 = new StringTokenizer(item.getEnumDesc(), ";,");
                        Vector descVector = new Vector();
                        while(st1.hasMoreTokens())
                        {
                            String enumDesc = st1.nextToken();
                            descVector.addElement(enumDesc);
                        }
                        StringTokenizer st = new StringTokenizer(item.getEnumValues(), ";,");
                        Vector valueVector = new Vector();
                        while(st.hasMoreTokens())
                        {
                            String str = st.nextToken();
                            valueVector.addElement(str);
                        }

                        session.setAttribute("descVector", descVector);
                        session.setAttribute("valueVector", valueVector);
                        %>

        <tiles:insert page="/secure/layouts/submitLayout.jsp"  flush="false">
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="isRequired" value="<%=item.getRequired()%>" />
        <tiles:put name="readOnly" value="true" />
        <tiles:put name="valueVector" value="<%=valueVector%>" />
        <tiles:put name="descVector" value="<%=descVector%>" />
        <tiles:put name="size" value="30" />
        <tiles:put name="units" value=""/>
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        </tiles:insert>

                        <% } else if (item.getType().equalsIgnoreCase("Dynamicselect")) {
                        try {
                            session.removeAttribute("valueVector");
                            session.removeAttribute("descVector");
                        }
                        catch (Exception e) {
                        }
                        Vector valVector = (Vector) session.getAttribute(item.getEnumValues());
                        Vector descriptVector = (Vector) session.getAttribute(item.getEnumDesc());

                        session.setAttribute("descVector", descriptVector);
                        session.setAttribute("valueVector", valVector);
                        %>

        <tiles:insert page="/secure/layouts/dynamicSelectionLayout.jsp" flush="false">
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="readOnly" value="true" />
        <tiles:put name="isRequired" value="<%=item.getRequired()%>" />
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="size" value="30" />
        <tiles:put name="units" value=""/>
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        <tiles:put name="multiSelect" value="<%=item.isMultiSelect()%>" />
        </tiles:insert>

                    <% } else if (item.getType().equalsIgnoreCase("Password")) { %>

        <td class="table-text"  scope="row" nowrap>
            <label  for="<%=item.getAttribute() %>">
            <bean:message key="<%= item.getLabel() %>"/>
            </label>
            <BR>
            <DIV CLASS="readOnlyElement" ID="<%= item.getAttribute() %>">
                **********
            </DIV>
        </td>

        <% } else { %>


        <tiles:insert page="/secure/layouts/textFieldLayout.jsp" flush="false">
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="isReadOnly" value="true" />
        <tiles:put name="isRequired" value="false" />
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="size" value="30" />
        <tiles:put name="units" value="<%=item.getUnits()%>"/>
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        </tiles:insert>


                    <% } %>

                    <% propCounterReadOnly += 1;%>




    </tr>

            <% }%>

    <%}%>

    </logic:iterate>


<%///MEMBERSHIPS %>
<%
int numMembershipColumns = Integer.parseInt(numberOfColumns);
if (numMembershipColumns > 0)
    numMembershipColumns--;
fieldLevelHelpTopic = topicKey + "emailAddresses"; 		
NotificationDetailForm testForm = (NotificationDetailForm)session.getAttribute("NotificationDetailForm");
Collection emailAddressesBean = testForm.getEmailAddresses();
pageContext.setAttribute("emailAddressesBean", emailAddressesBean);
%>

	<tr valign="top">
      <td class="table-text"  scope="row" nowrap>
          <FIELDSET id="emailAddresses">
           	<legend for ="emailAddresses" TITLE="<bean:message key="notification.email.description"/>">
             	<bean:message key="notification.email"/>
           	</legend>			
			<table class="framing-table" border="0" cellpadding="0" cellspacing="0" width="100%">
				<tr>
					<td class="table-text">
						<table>
							<tr>
								<td class="table-text" align="center">
									<bean:message key="notification.email.current" />
								</td>
								<td width="*">
								</td>
							</tr>
							<tr>
                				<td class="table-text"  align="center" valign="top" width="35%"><span>
 		                			<html:select property="notUsed" multiple="multiple" size="8" style="width:300px;">
                        				<html:options name="emailAddressesBean" />
                					</html:select>
               		 			</td>
								<td width="*">
								</td>
       						 </tr>
       		 				<html:hidden property="selectedString"/>
 						</table>
 					</td>
   				</tr>
   			</table>			
        </td>
 	</tr>





    <%
      if (!activeSubhead.equals("")) {
	%>

    </TABLE>
    </FIELDSET>
    </TD>
    </TR>

    <%
	  }
	%>


    <tr>
        <td class="navigation-button-section" VALIGN="top">
            <input type="submit" name="org.apache.struts.taglib.html.CANCEL" value="<bean:message key="button.back"/>" class="buttons" id="navigation">
        </td>
    </tr>

    </tbody>

</table>

</html:form>

    <% } %>









    <% if (renderReadOnlyView.equalsIgnoreCase("no")) { %>

<html:form action="<%=formAction%>" name="<%=formName%>" type="<%=formType%>">
<html:hidden property="action"/>
<table class="framing-table" border="0" cellpadding="5" cellspacing="0" width="100%" summary="Properties Table" >
    <tbody>
             <%
               int propSet = attributeList_ext.size();
               int propEven = propSet%2;
               int propCounter = 0;
               String activeSubhead = "";


             %>

    <logic:iterate id="item" name="attributeList_ext" type="com.ibm.ws.console.core.item.PropertyItem">

    <%if (item.getCategoryId()!=null) {
	%>

        <%
          if ((!activeSubhead.equals(item.getCategoryId()) && (!activeSubhead.equals(""))) || ((item.getCategoryId().equalsIgnoreCase("general") && propCounter!=0))) {
    	%>

        </TABLE>
        </FIELDSET>
        </TD>
        </TR>

        <%
    	  }
          if(!item.getCategoryId().equalsIgnoreCase("general")){
              activeSubhead = item.getCategoryId();
    	%>

        <TR>
        <TD CLASS="table-text">

        <FIELDSET>
        <LEGEND>
          <bean:message key="<%=item.getCategoryId()%>"/>
        </LEGEND>

        <table class="categorizedField" id="<%=item.getCategoryId()%>" border="0" cellpadding="5" cellspacing="0" width="100%" summary="Properties Category Table" >




    <%}else
         activeSubhead="";
       } else { %>

    <%
            fieldLevelHelpAttribute = item.getAttribute();
            if (fieldLevelHelpAttribute.equals(" ") || fieldLevelHelpAttribute.equals(""))
                fieldLevelHelpTopic = item.getLabel();
            else
                fieldLevelHelpTopic = topicKey + fieldLevelHelpAttribute;
            //this code gets productId from icon attribute of PropertyItem
            //and checks if product is installed
            // If product  is installed , then make row visible
            String productId = item.getIcon();
            boolean productEnabled = true;
            if ( (productId == null)  || (productId !=null && productId.equals("")) ) {
            productId = "BASE";
        } else if (productId.equals("ND") && productInfo.productPresent(productId)) {
            WorkSpaceQueryUtil util = WorkSpaceQueryUtilFactory.getUtil();
            RepositoryContext cellContext = (RepositoryContext)session.getAttribute(com.ibm.ws.console.core.Constants.CURRENTCELLCTXT_KEY);
            try {
                if (util.isStandAloneCell(cellContext)) {
                    productEnabled = false;
                }
                else {
                    productEnabled = true;
                }
            }
            catch (Exception e) {
                System.out.println("exception in util.isStandAloneCell " + e.toString());
                productEnabled = false;
            }
        } else if (productId.equals("PME") && productInfo.productPresent(productId)) {
                productEnabled = true;
        } else {
            productEnabled = false;
        }

            if (productEnabled) {
    %>




            <tr valign="top">


                    <%
                    String isRequired = item.getRequired();
                    String strType = item.getType();
                    String isReadOnly = item.getReadOnly();
                    %>

                    <% if (strType.equalsIgnoreCase("Text")) { %>

        <tiles:insert page="/secure/layouts/textFieldLayout.jsp" flush="false">
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="isReadOnly" value="<%=isReadOnly%>" />
        <tiles:put name="isRequired" value="<%=isRequired%>" />
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="size" value="30" />
        <tiles:put name="units" value="<%=item.getUnits()%>"/>
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        </tiles:insert>
                    <% } %>

                    <% if (strType.equalsIgnoreCase("TextMedium")) { %>

        <tiles:insert page="/secure/layouts/textFieldLayout.jsp" flush="false">
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="isReadOnly" value="<%=isReadOnly%>" />
        <tiles:put name="isRequired" value="<%=isRequired%>" />
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="size" value="60" />
        <tiles:put name="units" value="<%=item.getUnits()%>"/>
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        </tiles:insert>
                    <% } %>

                    <% if (strType.equalsIgnoreCase("TextLong")) { %>

        <tiles:insert page="/secure/layouts/textFieldLayout.jsp" flush="false">
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="isReadOnly" value="<%=isReadOnly%>" />
        <tiles:put name="isRequired" value="<%=isRequired%>" />
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="size" value="90" />
        <tiles:put name="units" value="<%=item.getUnits()%>"/>
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        </tiles:insert>
                    <% } %>

                    <% if (strType.equalsIgnoreCase("TextArea")) { %>

        <tiles:insert page="/secure/layouts/textAreaLayout.jsp" flush="false">
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="isReadOnly" value="<%=isReadOnly%>" />
        <tiles:put name="isRequired" value="<%=isRequired%>" />
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="size" value="5" />
        <tiles:put name="units" value="<%=item.getUnits()%>"/>
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        </tiles:insert>
                    <% } %>

                    <% if (strType.equalsIgnoreCase("checkbox")) { %>

        <tiles:insert page="/secure/layouts/checkBoxLayout.jsp" flush="false">
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="isReadOnly" value="<%=isReadOnly%>" />
        <tiles:put name="isRequired" value="<%=isRequired%>" />
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="size" value="30" />
        <tiles:put name="units" value="<%=item.getUnits()%>"/>
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        </tiles:insert>
                    <% } %>

                    <% if (strType.equalsIgnoreCase("Password")) { %>

        <tiles:insert page="/secure/layouts/passwordLayout.jsp" flush="false">
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="isReadOnly" value="<%=isReadOnly%>" />
        <tiles:put name="isRequired" value="<%=isRequired%>" />
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="size" value="30" />
        <tiles:put name="units" value="<%=item.getUnits()%>"/>
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        </tiles:insert>
                    <% } %>

                    <% if (strType.equalsIgnoreCase("Custom")) { %>

        <tiles:insert page="/secure/layouts/customLayout.jsp" flush="false">
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        <tiles:put name="readOnly" value="<%=isReadOnly%>" />
        <tiles:put name="jspPage" value="<%=item.getUnits()%>"/>
        <tiles:put name="size" value="30" />
        <tiles:put name="units" value=""/>
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="isRequired" value="<%=item.getRequired()%>" />
        </tiles:insert>
                    <% } %>

                    <% if (strType.equalsIgnoreCase("jsp")) { %>

        <tiles:insert page="<%=item.getUnits()%>" flush="false">
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        <tiles:put name="readOnly" value="<%=isReadOnly%>" />
        <tiles:put name="jspPage" value="<%=item.getUnits()%>"/>
        <tiles:put name="size" value="30" />
        <tiles:put name="units" value=""/>
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="isRequired" value="<%=item.getRequired()%>" />
        </tiles:insert>
                    <% } %>

                    <% if (strType.equalsIgnoreCase("select")) {

                        try {
                            session.removeAttribute("valueVector");
                            session.removeAttribute("descVector");
                        }
                        catch (Exception e) {
                        }

                        StringTokenizer st1 = new StringTokenizer(item.getEnumDesc(), ",");
                        Vector descVector = new Vector();
                        while(st1.hasMoreTokens())
                        {
                            String enumDesc = st1.nextToken();
                            descVector.addElement(enumDesc);
                        }
                        StringTokenizer st = new StringTokenizer(item.getEnumValues(), ",");
                        Vector valueVector = new Vector();
                        while(st.hasMoreTokens())
                        {
                            String str = st.nextToken();
                            valueVector.addElement(str);
                        }

                        session.setAttribute("descVector", descVector);
                        session.setAttribute("valueVector", valueVector);
                        %>

        <tiles:insert page="/secure/layouts/submitLayout.jsp" flush="false">
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="readOnly" value="<%=isReadOnly%>" />
        <tiles:put name="isRequired" value="<%=isRequired%>" />
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="size" value="30" />
        <tiles:put name="units" value=""/>
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        </tiles:insert>
                    <% } %>

                    <% if (strType.equalsIgnoreCase("Dynamicselect")) {
                        try {
                            session.removeAttribute("valueVector");
                            session.removeAttribute("descVector");
                        }
                        catch (Exception e) {
                        }
                        Vector valVector = (Vector) session.getAttribute(item.getEnumValues());
                        Vector descriptVector = (Vector) session.getAttribute(item.getEnumDesc());

                        session.setAttribute("descVector", descriptVector);
                        session.setAttribute("valueVector", valVector);
                        %>

        <tiles:insert page="/secure/layouts/dynamicSelectionLayout.jsp" flush="false">
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="readOnly" value="<%=isReadOnly%>" />
        <tiles:put name="isRequired" value="<%=isRequired%>" />
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="size" value="30" />
        <tiles:put name="units" value=""/>
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        <tiles:put name="multiSelect" value="<%=item.isMultiSelect()%>" />
        </tiles:insert>
                    <% } %>


                    <% if (strType.equalsIgnoreCase("Radio")) {

                        try {
                            session.removeAttribute("valueVector");
                            session.removeAttribute("descVector");
                        }
                        catch (Exception e) {
                        }

                        StringTokenizer st1 = new StringTokenizer(item.getEnumDesc(), ",");
                        Vector descVector = new Vector();
                        while(st1.hasMoreTokens())
                        {
                            String enumDesc = st1.nextToken();
                            descVector.addElement(enumDesc);
                        }
                        StringTokenizer st = new StringTokenizer(item.getEnumValues(), ",");
                        Vector valueVector = new Vector();
                        while(st.hasMoreTokens())
                        {
                            String str = st.nextToken();
                            valueVector.addElement(str);
                        }

                        session.setAttribute("descVector", descVector);
                        session.setAttribute("valueVector", valueVector);
                        %>

        <tiles:insert page="/secure/layouts/radioButtonLayout.jsp" flush="false">
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="isReadOnly" value="<%=isReadOnly%>" />
        <tiles:put name="isRequired" value="<%=isRequired%>" />
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="size" value="30" />
        <tiles:put name="units" value=""/>
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        </tiles:insert>
                    <% } %>

        <% } %>


             <% propCounter += 1;%>

             </TR>


    <%}%>

    </logic:iterate>

<%///MEMBERSHIPS %>
<%
int numMembershipColumns = Integer.parseInt(numberOfColumns);
if (numMembershipColumns > 0)
    numMembershipColumns--;
fieldLevelHelpTopic = topicKey + "emailAddresses"; 		
NotificationDetailForm testForm = (NotificationDetailForm)session.getAttribute("NotificationDetailForm");
Collection emailAddressesBean = testForm.getEmailAddresses();
pageContext.setAttribute("emailAddressesBean", emailAddressesBean);

String applyClick = "initVars(this);submitIt();";
String resetClick = "initVars(this);resetForm()";
String cancelClick = "initVars(this);resetForm();updateHiddenFields()";
String removeClicked = "initVars(this);removeOption(selectedCurrentNodes, currentNodes.options)";
String addClicked = "initVars(this);addOption(emailField, currentNodes.options)";
String testClicked = "initVars(this);";
%>
		
		
<tr valign="top">
      <td class="table-text"  scope="row" nowrap>
          <FIELDSET id="emailAddresses">
           	<legend for ="emailAddresses" TITLE="<bean:message key="notification.email.description"/>">
             	<bean:message key="notification.email"/>
           	</legend>
               			
			<table class="framing-table" border="0" width="95%" cellpadding="3" cellspacing="0">
				<tr>
                	<td class="table-text" align="left" VALIGN="middle" WIDTH="20%">
                    	<LABEL>
                    		<bean:message key="task.email.address" />
                        	<br>
                        	<html:text property="notUsed" styleId="emailAddresses" disabled="false" styleClass="textEntry"/>
                        </LABEL>
	            	</td>
                                        
                	<td class="table-text" align="center" valign="middle">
		            	<html:button styleClass="buttons" property="notUsed" onclick="<%=addClicked%>" styleId="other" style="width:80%">
		            		<bean:message key="task.addbutton" />
		            	</html:button>
		                <br>
		               	<br>
		                <html:button styleClass="buttons" property="notUsed" onclick="<%=removeClicked%>" styleId="other" style="width:80%">
		                	<bean:message key="task.removebutton" />
		               	</html:button>
              		 </td>
                                        
                	 <td class="table-text"  align="left" valign="middle">
	                     <LABEL>
	                     	<bean:message key="notification.email.current" />
	                     	<BR>
 		                	<html:select property="notUsed" multiple="multiple" size="8" styleClass="textEntry" onchange="initVars(this);setSelected(selectedCurrentNodes, currentNodes)">
                        	<html:options name="emailAddressesBean" />
                			</html:select>
                		</LABEL>
						<html:hidden property="selectedString"/>
 					</td>
   				</tr>
           	</table>
       	</fieldset>
        </td>
  	</tr>



    <%
      if (!activeSubhead.equals("")) {
	%>

    </TABLE>
    </FIELDSET>
    </TD>
    </TR>

    <%
	  }
	%>


    <tr>
        <td class="navigation-button-section" nowrap VALIGN="top">
            <input type="submit" name="apply" value="<bean:message key="button.apply"/>" class="buttons" id="navigation" onclick="<%=applyClick%>">
            <input type="submit" name="save" value="<bean:message key="button.ok"/>" class="buttons" id="navigation" onclick="<%=applyClick%>">
            <input type="reset"  name="reset" value="<bean:message key="button.reset"/>" class="buttons" id="navigation" onclick="<%=resetClick%>">
            <input type="submit" name="org.apache.struts.taglib.html.CANCEL" value="<bean:message key="button.cancel"/>" class="buttons" id="navigation" onclick="<%=cancelClick%>">
            <input type="submit" name="test" value="<bean:message key="button.test"/>" onclick="<%=testClicked%>" class="buttons" id="navigation">
        </td>
    </tr>

    </tbody>
</table>

</html:form>
    <% } %>

<br>

<%
}
%>
