<%-- IBM Confidential OCO Source Material --%>
<%-- 5724-J34 (C) COPYRIGHT International Business Machines Corp. 2005 --%>
<%-- The source code for this program is not published or otherwise divested --%>
<%-- of its trade secrets, irrespective of what has been deposited with the --%>
<%-- U.S. Copyright Office. --%>

<%@ page import="com.ibm.ws.sm.workspace.*"%>
<%@ page import="com.ibm.ws.workspace.query.*"%>
<%@ page import="com.ibm.ws.console.core.*"%>
<%@ page import="java.util.*,com.ibm.ws.security.core.SecurityContext,com.ibm.websphere.product.*"%>
<%@ page import="com.ibm.ws.console.workclass.form.WorkClassCollectionForm"%>
<%@ page import="com.ibm.ws.xd.config.workclass.util.ApplicationUtil"%>
<%@ page import="com.ibm.ws.xd.config.workclass.util.WorkClassConstants"%>
<%@ page import="com.ibm.ws.xd.config.workclass.util.WorkClassXDUtil"%>

<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/tiles.tld" prefix="tiles" %>

<tiles:useAttribute name="formAction" classname="java.lang.String"/>
<tiles:useAttribute name="formName" classname="java.lang.String"/>
<tiles:useAttribute name="formType" classname="java.lang.String"/>

<%
Double dblValue = (Double)session.getAttribute("multiplier");
double multiplier = dblValue.doubleValue();
%>
 
<style type="text/css">
a.tree { color: #000000; text-decoration: none; }

.workclassRow {
	font-size: <%=(65*multiplier)%>%;
	font-family: Verdana,Helvetica, sans-serif;
	background-color: #f7f7f7; 	
	border: 0;
	margin-left: 2em;
 }
</style>


<script language="JavaScript">

function showHideSection(sectionId) {
    if (document.getElementById(sectionId) != null) {
        if (document.getElementById(sectionId).style.display == "none") {
            document.getElementById(sectionId).style.display = "block";
            state = "display:block";
            if (document.getElementById(sectionId+"Img")) {
                document.getElementById(sectionId+"Img").src = "/ibm/console/com.ibm.ws.console.xdruntime/images/minus_sign.gif";
            }
        } else {
            document.getElementById(sectionId).style.display = "none";           
            state = "display:none";
            if (document.getElementById(sectionId+"Img")) {
                document.getElementById(sectionId+"Img").src = "/ibm/console/com.ibm.ws.console.xdruntime/images/plus_sign.gif";
            }
        }
        
		uriState = "secure/javascriptToSession.jsp?req=set&sessionVariable=com_ibm_ws_"+sectionId+"&variableValue="+state;
		setState = doXmlHttpRequest(uriState);
		setState = setState.substring(0,setState.indexOf("+endTransmission"));        
    }
}

function popUpLimitedWindow(winUrl) {
    var features = "height=500,width=600,alwaysLowered=0,alwaysRaised=0,channelmode=0,dependent=0,directories=0,fullscreen=0,hotkeys=1,location=0,menubar=0,resizable=1,scrollbars=1,status=0,titlebar=1,toolbar=0,z-lock=0";
    var parentWin = window.name;
    var newWin = open(winUrl, 'SupportingEvidence', features, parentWin);
}

</script>
<html:form action="<%=formAction%>" name="<%=formName%>" type="<%=formType%>">

<%
WorkSpace wksp = (WorkSpace)session.getAttribute(com.ibm.ws.console.core.Constants.WORKSPACE_KEY);
WorkClassCollectionForm wccf = (WorkClassCollectionForm)request.getSession().getAttribute("WorkClassCollectionForm");
boolean isAppDeployedOnZOS = ApplicationUtil.isAppDeployedOnZOS(wccf.getApplicationName(), wksp);
System.out.println("MJS:spConfigTab:isappDeployedOnZOS: " + isAppDeployedOnZOS);
int wcscope = -1;
int wcview = -1;
String labelext = "";
String expandID = "";
if (wccf != null) {
	// Retrieve the Scope and View for this collection.   This determines the layout of this page.
	wcview = wccf.getWCView();  // View is either Service or Routing Policy
	wcscope = wccf.getWCScope();  // Scope is either App, LRA, ODR
	
	if (wcscope == WorkClassConstants.WCSCOPE_ODR) {
		expandID = wccf.getNodeName()+"_"+wccf.getODRName();
	} else {
		if (wcview == WorkClassConstants.WCVIEW_ROUTING) {
			expandID = WorkClassXDUtil.normalizeAppName(wccf.getApplicationName());
		} else {
			expandID = wccf.getApplicationName();
		}
	}
	expandID = expandID+"_"+wcview;
	
	if (wcscope == WorkClassConstants.WCSCOPE_ODR) {
		if (wcview == WorkClassConstants.WCVIEW_ROUTING) {
			labelext = ".odr.routing";
		} else {
			labelext = ".odr.service";
		}
	} else {
		if (wcview == WorkClassConstants.WCVIEW_ROUTING) {
			labelext = ".routing";
		} else {
			labelext = "";
		}
	}
}
//System.out.println("labelext = " +labelext);    // Debug - Remove
//System.out.println("wcview = " +wcview);    // Debug - Remove
//System.out.println("wcscope = " +wcscope);    // Debug - Remove
%>

	<table border="0" cellpadding="3" cellspacing="1" width="100%" STYLE="margin-top:-1em">

		<% if (wcview == WorkClassConstants.WCVIEW_SERVICE && wcscope == WorkClassConstants.WCSCOPE_APP) { 
			String href = "/ibm/console/com.ibm.ws.console.policyconfiguration.forwardCmd.do?forwardName=serviceclasstopology.content.main"; %>
		<tr>
			<td class="table-text" scope="row" nowrap>
                  <a href="#" onclick="popUpLimitedWindow('<%=href%>')" onkeypress="popUpLimitedWindow('<%=href%>')">
	                  <img id="allSPsImg" SRC="<%=request.getContextPath()%>/com.ibm.ws.console.workclass/images/popup_icon.gif" alt="Open in new window" border="0" align="texttop" tabindex="1">
    	              <bean:message key="workclass.service.config.topologyLink" />
    	          </a>
			</td>
		</tr>
		<% } %>
<!--   
		<tr>
			<td class="table-text" scope="row" nowrap>
                  <a href="#"><img id="specificSPsImg" SRC="<%=request.getContextPath()%>/images/popup_icon.gif" alt="" border="0" align="texttop" tabindex="1"/>
                  View the service policies that are mapped to this application</A>
			</td>
		</tr>
-->			
		<tr>
			<td class="table-text" scope="row" nowrap>
			<% String labelkey = "workclass" +labelext +".config.description"; %>
				<bean:message key="<%=labelkey%>" />
			</td>
		</tr>
		<tr>
			<td class="navigation-button-section" scope="row" nowrap>
				<tiles:insert definition="workclass.content.main.buttons" flush="false">
				<% if (wcview == WorkClassConstants.WCVIEW_ROUTING) { 
						labelext = ".routing";
					} else {
						labelext = "";
					}%>
				<tiles:put name="labelext" value="<%=labelext%>" />
	    		</tiles:insert>
			</td>
		</tr>
		<%
		// LRA only supports IIOP WorkClasses
		if (wcscope != WorkClassConstants.WCSCOPE_LRA) {
		%>		
		<tr>
			<td class="table-text" scope="row" nowrap>
				<%
					String wcType = "http";				
					String expandGraphic = "/ibm/console/com.ibm.ws.console.xdruntime/images/plus_sign.gif";
					String expandState = (String)session.getAttribute("com_ibm_ws_"+expandID+wcType);
					if (expandState == null)
						expandState = "display:none";				
					else if (expandState.equals("display:block"))
						expandGraphic = "/ibm/console/com.ibm.ws.console.xdruntime/images/minus_sign.gif";
							
				%>								
				<a href="javascript:showHideSection('<%=expandID%><%=wcType%>')" class="tree">
			        <img id="<%=expandID%><%=wcType%>Img" border="0" align="middle" src="<%=expandGraphic%>" />
				    <bean:message key="workclass.requests.type1" arg0="HTTP" />
				</a>
		
				<div id="<%=expandID%><%=wcType%>" style="<%=expandState%>">						
				   	<tiles:insert definition="workclass.content.main.requests" flush="false">
			    		<tiles:put name="requestType" value="HTTP" />
	    			</tiles:insert>
				</div>
			</td>
		</tr>
		<%
		}
		// ODR only supports HTTP WorkClasses
		if (wcscope != WorkClassConstants.WCSCOPE_ODR && wcview == WorkClassConstants.WCVIEW_SERVICE  && !isAppDeployedOnZOS) {
		%>
		<tr>
			<td class="table-text" scope="row" nowrap>
				<%
					String wcType = "iiop";				
					String expandGraphic = "/ibm/console/com.ibm.ws.console.xdruntime/images/plus_sign.gif";
					String expandState = (String)session.getAttribute("com_ibm_ws_"+expandID+wcType);
					if (expandState == null)
						expandState = "display:none";				
					else if (expandState.equals("display:block"))
						expandGraphic = "/ibm/console/com.ibm.ws.console.xdruntime/images/minus_sign.gif";
							
				%>			
				<a href="javascript:showHideSection('<%=expandID%><%=wcType%>')" class="tree">
			        <img id="<%=expandID%><%=wcType%>Img" border="0" align="middle" src="<%=expandGraphic%>" />
				    <bean:message key="workclass.requests.type1" arg0="IIOP" />	
				</a>
	
				<div id="<%=expandID%><%=wcType%>" style="<%=expandState%>">						
				   	<tiles:insert definition="workclass.content.main.requests" flush="false">
				    	<tiles:put name="requestType" value="IIOP" />
				    </tiles:insert>
				</div>
			</td>
		</tr>
		<%
		}
		// LRA only supports IIOP WorkClasses
		// ODR only supports HTTP WorkClasses
		if (wcscope == WorkClassConstants.WCSCOPE_APP) {
		%>
		<tr>
			<td class="table-text" scope="row" nowrap>
				<%
					String wcType = "soap";				
					String expandGraphic = "/ibm/console/com.ibm.ws.console.xdruntime/images/plus_sign.gif";
					String expandState = (String)session.getAttribute("com_ibm_ws_"+expandID+wcType);
					if (expandState == null)
						expandState = "display:none";				
					else if (expandState.equals("display:block"))
						expandGraphic = "/ibm/console/com.ibm.ws.console.xdruntime/images/minus_sign.gif";
							
				%>			
				<a href="javascript:showHideSection('<%=expandID%><%=wcType%>')" class="tree">
			        <img id="<%=expandID%><%=wcType%>Img" border="0" align="middle" src="<%=expandGraphic%>" />
				    <bean:message key="workclass.requests.type1" arg0="SOAP" />
				</a>
	
				<div id="<%=expandID%><%=wcType%>" style="<%=expandState%>">						
				   	<tiles:insert definition="workclass.content.main.requests" flush="false">
			    		<tiles:put name="requestType" value="SOAP" />
				    </tiles:insert>
				</div>
			</td>
		</tr>
		<%
		}
		// LRA only supports IIOP WorkClasses
		// ODR only supports HTTP WorkClasses
		if (wcscope == WorkClassConstants.WCSCOPE_APP && wcview == WorkClassConstants.WCVIEW_SERVICE  && !isAppDeployedOnZOS) {
		%>
		<tr>
			<td class="table-text" scope="row" nowrap>
				<%
					String wcType = "jms";				
					String expandGraphic = "/ibm/console/com.ibm.ws.console.xdruntime/images/plus_sign.gif";
					String expandState = (String)session.getAttribute("com_ibm_ws_"+expandID+wcType);
					if (expandState == null)
						expandState = "display:none";				
					else if (expandState.equals("display:block"))
						expandGraphic = "/ibm/console/com.ibm.ws.console.xdruntime/images/minus_sign.gif";
							
				%>			
				<a href="javascript:showHideSection('<%=expandID%><%=wcType%>')" class="tree">
			        <img id="<%=expandID%><%=wcType%>Img" border="0" align="middle" src="<%=expandGraphic%>" />
				    <bean:message key="workclass.requests.type1" arg0="JMS" />
				</a>
	
				<div id="<%=expandID%><%=wcType%>" style="<%=expandState%>">						
				   	<tiles:insert definition="workclass.content.main.requests" flush="false">
			    		<tiles:put name="requestType" value="JMS" />
				    </tiles:insert>
				</div>
			</td>
		</tr>
		<%
		}
		%>		
		
		
	<br /><br />
	</table>
</html:form>
