// IBM Confidential OCO Source Material
// 5724-J34 (C) COPYRIGHT International Business Machines Corp. 2004, 2005
// The source code for this program is not published or otherwise divested
// of its trade secrets, irrespective of what has been deposited with the
// U.S. Copyright Office.

var populatorFunctions = new Object();
var iconFunctions = new Object();
var innerHTMLFunctions = new Object();
var linkFunctions = new Object();
var contentFunctions = new Object();
var parentFinderHelperFunctions = new Object();
var genericHandlers = new Object();
var popupFunctions = new Object(); //these methods populate the popup DIV, return true if the popup should be displayed
var initFunctions = new Object();
var menuCreators = new Object();

//Cells
populatorFunctions[ELEMENT_CELL] = cellPopulatorFunction;
iconFunctions[ELEMENT_CELL] = cellIconFunction;
linkFunctions[ELEMENT_CELL] = cellLinkFunction;
innerHTMLFunctions[ELEMENT_CELL] = cellInnerHTMLFunction;
contentFunctions[ELEMENT_CELL] = contentFromNameFunction;
parentFinderHelperFunctions[ELEMENT_CELL] = cellParentFinderHelperFunction;
menuCreators[ELEMENT_CELL] = cellMenuCreator;

//NodeGroups
populatorFunctions[ELEMENT_NODEGROUP] = nodeGroupPopulatorFunction;
iconFunctions[ELEMENT_NODEGROUP] = nodeGroupIconFunction;
innerHTMLFunctions[ELEMENT_NODEGROUP] = nodeGroupInnerHTMLFunction;
linkFunctions[ELEMENT_NODEGROUP] = nodeGroupLinkFunction;
contentFunctions[ELEMENT_NODEGROUP] = contentFromNameFunction;
parentFinderHelperFunctions[ELEMENT_NODEGROUP] = nodeGroupParentFinderHelperFunction;
popupFunctions[ELEMENT_NODEGROUP] = nodeGroupPopupFunction;
menuCreators[ELEMENT_NODEGROUP] = NodeGroupMenuCreator;

//External Node
populatorFunctions[ELEMENT_EXTERNAL_NODE] = externalNodePopulatorFunction;
iconFunctions[ELEMENT_EXTERNAL_NODE] = externalNodeIconFunction;
innerHTMLFunctions[ELEMENT_EXTERNAL_NODE] = externalNodeInnerHTMLFunction;
linkFunctions[ELEMENT_EXTERNAL_NODE] = externalNodeLinkFunction;
contentFunctions[ELEMENT_EXTERNAL_NODE] = contentFromNameFunction;
parentFinderHelperFunctions[ELEMENT_EXTERNAL_NODE] = commonParentFinderHelperFunction;
popupFunctions[ELEMENT_EXTERNAL_NODE] = externalNodePopupFunction;
//menuCreators[ELEMENT_EXTERNAL_NODE] = ExternalNodeMenuCreator;

//Nodes
populatorFunctions[ELEMENT_NODE] = nodePopulatorFunction;
iconFunctions[ELEMENT_NODE] = nodeIconFunction;
innerHTMLFunctions[ELEMENT_NODE] = nodeInnerHTMLFunction;
linkFunctions[ELEMENT_NODE] = nodeLinkFunction;
contentFunctions[ELEMENT_NODE] = contentFromNameFunction;
parentFinderHelperFunctions[ELEMENT_NODE] = commonParentFinderHelperFunction;
popupFunctions[ELEMENT_NODE] = nodePopupFunction;
menuCreators[ELEMENT_NODE] = NodeMenuCreator;

//Deployment Targets
populatorFunctions[ELEMENT_DEPLOYMENTTARGET] = depTargetPopulatorFunction;
iconFunctions[ELEMENT_DEPLOYMENTTARGET] = depTargetIconFunction;
innerHTMLFunctions[ELEMENT_DEPLOYMENTTARGET] = depTargetInnerHTMLFunction;
linkFunctions[ELEMENT_DEPLOYMENTTARGET] = depTargetLinkFunction;
contentFunctions[ELEMENT_DEPLOYMENTTARGET] = contentFromNameFunction;
parentFinderHelperFunctions[ELEMENT_DEPLOYMENTTARGET] = depTargetParentFinderHelperFunction;
popupFunctions[ELEMENT_DEPLOYMENTTARGET] = depTargetPopupFunction;
menuCreators[ELEMENT_DEPLOYMENTTARGET] = DTMenuCreator;

//Deployment Target Instances
populatorFunctions[ELEMENT_DEPLOYMENTTARGETINSTANCE] = depTargetInstancePopulatorFunction;
iconFunctions[ELEMENT_DEPLOYMENTTARGETINSTANCE] = depTargetInstanceIconFunction;
innerHTMLFunctions[ELEMENT_DEPLOYMENTTARGETINSTANCE] = depTargetInstanceInnerHTMLFunction;
linkFunctions[ELEMENT_DEPLOYMENTTARGETINSTANCE] = depTargetInstanceLinkFunction;
contentFunctions[ELEMENT_DEPLOYMENTTARGETINSTANCE] = contentFromNameFunction;
parentFinderHelperFunctions[ELEMENT_DEPLOYMENTTARGETINSTANCE] = depTargetInstanceParentFinderHelperFunction;
popupFunctions[ELEMENT_DEPLOYMENTTARGETINSTANCE] = depTargetInstancePopupFunction;
menuCreators[ELEMENT_DEPLOYMENTTARGETINSTANCE] = ServerInstanceMenuCreator;

//J2EE Modules
populatorFunctions[ELEMENT_J2EEMODULE] = j2eeModulePopulatorFunction;
iconFunctions[ELEMENT_J2EEMODULE] = j2eeModuleIconFunction;
innerHTMLFunctions[ELEMENT_J2EEMODULE] = j2eeModuleInnerHTMLFunction;
linkFunctions[ELEMENT_J2EEMODULE] = j2eeModuleLinkFunction;
contentFunctions[ELEMENT_J2EEMODULE] = j2eeModuleContentFunction;
parentFinderHelperFunctions[ELEMENT_J2EEMODULE] = j2eeModuleParentFinderHelperFunction;
popupFunctions[ELEMENT_J2EEMODULE] = j2eeModulePopupFunction;
menuCreators[ELEMENT_J2EEMODULE] = J2EEModuleMenuCreator;

//Applications
populatorFunctions[ELEMENT_APPLICATION] = applicationPopulatorFunction;
iconFunctions[ELEMENT_APPLICATION] = applicationIconFunction;
innerHTMLFunctions[ELEMENT_APPLICATION] = applicationInnerHTMLFunction;
linkFunctions[ELEMENT_APPLICATION] = applicationLinkFunction;
contentFunctions[ELEMENT_APPLICATION] = contentFromNameFunction;
parentFinderHelperFunctions[ELEMENT_APPLICATION] = applicationParentFinderHelperFunction;
popupFunctions[ELEMENT_APPLICATION] = applicationPopupFunction;
//menuCreators[ELEMENT_APPLICATION] = ApplicationMenuCreator;

//Applications Edition
populatorFunctions[ELEMENT_APPLICATION_EDITION] = applicationEditionPopulatorFunction;
iconFunctions[ELEMENT_APPLICATION_EDITION] = applicationEditionIconFunction;
innerHTMLFunctions[ELEMENT_APPLICATION_EDITION] = applicationEditionInnerHTMLFunction;
linkFunctions[ELEMENT_APPLICATION_EDITION] = applicationEditionLinkFunction;
contentFunctions[ELEMENT_APPLICATION_EDITION] = contentFromNameFunction;
parentFinderHelperFunctions[ELEMENT_APPLICATION_EDITION] = applicationEditionParentFinderHelperFunction;
popupFunctions[ELEMENT_APPLICATION_EDITION] = applicationEditionPopupFunction;
menuCreators[ELEMENT_APPLICATION_EDITION] = ApplicationEditionMenuCreator;

//Service Classes
populatorFunctions[ELEMENT_SERVICECLASS] = serviceClassPopulatorFunction;
iconFunctions[ELEMENT_SERVICECLASS] = serviceClassIconFunction;
innerHTMLFunctions[ELEMENT_SERVICECLASS] = serviceClassInnerHTMLFunction;
linkFunctions[ELEMENT_SERVICECLASS] = serviceClassLinkFunction;
contentFunctions[ELEMENT_SERVICECLASS] = contentFromNameFunction;
parentFinderHelperFunctions[ELEMENT_SERVICECLASS] = serviceClassParentFinderHelperFunction;
popupFunctions[ELEMENT_SERVICECLASS] = serviceClassPopupFunction;
menuCreators[ELEMENT_SERVICECLASS] = ServiceClassMenuCreator;

//Transaction Classes
populatorFunctions[ELEMENT_TRANSACTIONCLASS] = transactionClassPopulatorFunction;
iconFunctions[ELEMENT_TRANSACTIONCLASS] = transactionClassIconFunction;
innerHTMLFunctions[ELEMENT_TRANSACTIONCLASS] = transactionClassInnerHTMLFunction;
linkFunctions[ELEMENT_TRANSACTIONCLASS] = transactionClassLinkFunction;
contentFunctions[ELEMENT_TRANSACTIONCLASS] = contentFromNameFunction;
parentFinderHelperFunctions[ELEMENT_TRANSACTIONCLASS] = commonParentFinderHelperFunction;
menuCreators[ELEMENT_TRANSACTIONCLASS] = TransClassMenuCreator;

//Proxy
populatorFunctions[ELEMENT_PROXY] = proxyPopulatorFunction;
iconFunctions[ELEMENT_PROXY] = proxyIconFunction;
innerHTMLFunctions[ELEMENT_PROXY] = proxyInnerHTMLFunction;
linkFunctions[ELEMENT_PROXY] = proxyLinkFunction;
contentFunctions[ELEMENT_PROXY] = contentFromNameFunction;
parentFinderHelperFunctions[ELEMENT_PROXY] = proxyParentFinderHelperFunction;

//Specialty Servers
populatorFunctions[ELEMENT_SPECIALTYSERVER] = specServerPopulatorFunction;
iconFunctions[ELEMENT_SPECIALTYSERVER] = specServerIconFunction;
innerHTMLFunctions[ELEMENT_SPECIALTYSERVER] = specServerInnerHTMLFunction;
linkFunctions[ELEMENT_SPECIALTYSERVER] = specServerLinkFunction;
contentFunctions[ELEMENT_SPECIALTYSERVER] = specServerContentFunction;
parentFinderHelperFunctions[ELEMENT_SPECIALTYSERVER] = specServerParentFinderHelperFunction;
popupFunctions[ELEMENT_SPECIALTYSERVER] = specServerPopupFunction;
menuCreators[ELEMENT_SPECIALTYSERVER] = SpecServerMenuCreator;

//Specialty Server Instances
populatorFunctions[ELEMENT_SPECIALTYSERVERINSTANCE] = specServerInstancePopulatorFunction;
iconFunctions[ELEMENT_SPECIALTYSERVERINSTANCE] = specServerInstanceIconFunction;
innerHTMLFunctions[ELEMENT_SPECIALTYSERVERINSTANCE] = specServerInstanceInnerHTMLFunction;
linkFunctions[ELEMENT_SPECIALTYSERVERINSTANCE] = specServerInstanceLinkFunction;
contentFunctions[ELEMENT_SPECIALTYSERVERINSTANCE] = contentFromNameFunction;
parentFinderHelperFunctions[ELEMENT_SPECIALTYSERVERINSTANCE] = commonParentFinderHelperFunction;
popupFunctions[ELEMENT_SPECIALTYSERVERINSTANCE] = specServerInstancePopupFunction;
menuCreators[ELEMENT_SPECIALTYSERVERINSTANCE] = SpecServerInstanceMenuCreator;

//INIT Functions
initFunctions[PURPOSE_NODEGROUP_CENTRIC] = initNodeGroup;
initFunctions[PURPOSE_APPLICATION_CENTRIC] = initApplication;
initFunctions[PURPOSE_OPPOLICY_CENTRIC] = initServiceClass;

function initNodeGroup(cellElem){
	return initGeneric(PURPOSE_NODEGROUP_CENTRIC, cellElem);	
}
function initServiceClass(cellElem){
	return initGeneric(PURPOSE_OPPOLICY_CENTRIC, cellElem);	
}
function initApplication(cellElem){
	return initGeneric(PURPOSE_APPLICATION_CENTRIC, cellElem);	
}

// This function returns an array that contains matched type child nodes if
// it is not null.
function initGeneric(purpose, cellElem){
	clearSelectBox();
	closeOpenMenus();
	
	var rootElem = getRootNode(purpose, cellElem);
	// The returned rootElem is an array if it is not null.
	if (!rootElem){
		
	} else {
		
		var rootId = rootElem[0].getAttribute(ATTR_ID);
		
		//now get a list of all top level nodes, and populate the select box with them.
		var child;
		for (var i = 0; i < cellElem.childNodes.length; i++)
		{
			child = cellElem.childNodes.item(i);
			
			if (child.getAttribute(ATTR_TYPE) != ELEMENT_EXTERNAL_NODE)
         	{
               addToSelectBox(child.getAttribute(ATTR_NAME));		
         	}
		}
		setSelectBox(getRootSelection());
		
      return rootElem;
	}
}

function recallPreviousState(previousState)
{
	var previousState = "none";
	var a = 0;
	
	if (top.savedRTState != null)
	{
		previousState = top.savedRTState;
	
		for (a = 0; a < previousState.length; a++)
		{
			if (previousState[a].indexOf("NodeGroup_Cell") == -1)
			{
				if (nodeIndex[previousState[a]].parent.expanded == true)
					expandCompressNode(previousState[a]);
			}
			else
			{
				if (nodeIndex[previousState[a]].expanded == false)
					expandCompressNode(previousState[a]);
			}
		}		
	}
		
	return true;
}

function saveCurrentState()
{
	return(collectExpandedNodes());
}

//RootName
genericHandlers[ELEMENT_ROOTNAME] = new RootNameGenericHandler();

//////=====================================================================
//Applications

function applicationPopulatorFunction(elem, purpose, node){
	var changed = false;
	node.type = ELEMENT_APPLICATION;
	var tmp;
	
	tmp = elem.getAttribute(ATTR_NAME);
	if (tmp && node.name != tmp){
		changed = true;
	   node.name = tmp;
	}

	//tmp = elem.getAttribute(ATTR_ISAPPLRA);
	//if (tmp && node.isAppLRA != tmp) {
 	//	changed = true;
	//	node.isAppLRA = tmp;
	//}
	
	node.targetFrame = "graphFrame";	
	return changed;
}

function applicationIconFunction(node, purpose){
	//if (node.isLRA != null)
	//{
	//	if (node.isAppLRA.toUpperCase() == TRUE_IND)
	//	 	return {url:gridApplicationIcon, alt:GRID_APPLICATION_ICON_LABEL};
	//}
	
	return {url:appIcon, alt:APPLICATION_ICON_LABEL};	
}

function applicationInnerHTMLFunction(purpose){
	var html = getCommonInnerHtml(this, purpose);
	return html;
}
function applicationLinkFunction(){
	return LINK_THAT_DOES_NOTHING;
}
function applicationParentFinderHelperFunction(elem, purpose, parent){
	if (PURPOSE_APPLICATION_CENTRIC == purpose){
		var id, text;
		var type = elem.getAttribute(ATTR_TYPE);
		var ret = null;
		if (type == ELEMENT_J2EEMODULE)
		{
			ret = new Array();
			id = getJ2EEModulesID(parent);
			text = J2EE_MODULES;
			ret.push( {id:id, text:text} );
		}
		else if (type == ELEMENT_DEPLOYMENTTARGET){
			ret = new Array();
			id = getTargetMappingsID(parent);
			text = TARGET_MAPPINGS;
			ret.push( {id:id, text:text} );
			
			var dTType = elem.getAttribute(ATTR_DTTYPE);
			if (dTType == ELEMENT_DYNAMICCLUSTER)
				ret.push( {id:getDynamicClustersId(parent), text:DYNAMICCLUSTERS} );
			else if (dTType == ELEMENT_CLUSTER)
				ret.push( {id:getClustersId(parent), text:CLUSTERS} );
			else if (dTType == ELEMENT_APPSERVER)
				ret.push( {id:getServersId(parent), text:SERVER} );			
		}
	}
	return ret;		
}
function applicationPopupFunction(node, e){
	//var contents = new Array();

	//if (node.transactionClasses)
	//	contents.push(TRANSACTIONCLASSES + ": " + node.transactionClasses);
	//if (node.serviceClasses)
	//	contents.push(SERVICECLASSES + ": " + node.serviceClasses);

	//populatePopup(contents);	
	//return contents.length > 0;
	return false;
}
function getTargetMappingsID(parent){
	return "TargetMappings_" + parent.id;	
}
function getJ2EEModulesID(parent){
	return "J2EEModules_" + parent.id;	
}

function getApplicationEditionID(parent){
	return "APPEdition_" + parent.id;	
}

//////=====================================================================
//Application Editions

function applicationEditionPopulatorFunction(elem, purpose, node){
	var changed = false;
	node.type = ELEMENT_APPLICATION_EDITION;
	var tmp;
	

	tmp = elem.getAttribute(ATTR_TRANSACTIONCLASSES);
	if (tmp&& node.transactionClasses != tmp){
		changed = true;
		node.transactionClasses = tmp;
	}
	
	tmp = elem.getAttribute(ATTR_SERVICECLASSES);
	if (tmp && node.serviceClasses != tmp){
		changed = true;
		node.serviceClasses = tmp;
	}

	tmp = elem.getAttribute(ATTR_ISAPPLRA);
	if (tmp && node.isAppLRA != tmp) {
		changed = true;
		node.isAppLRA = tmp;
	}
	
	tmp = elem.getAttribute(ATTR_APPED_EDITION);
	if (tmp && node.appEdEdition != tmp) {
		changed = true;
		node.appEdEdition = tmp;
	}
		
	tmp = elem.getAttribute(ATTR_APPED_NAME_WO_EDITION);
	if (tmp && node.appEdNameWOEdition != tmp) {
		changed = true;
		node.appEdNameWOEdition = tmp;
	}

	tmp = elem.getAttribute(ATTR_NAME);
	if (tmp && node.name != tmp)
	{
		changed = true;
		
		if (node.appEdEdition) //if appEdEdition exists
		{
			if (node.appEdEdition == EDITION_BASE) //if it's the Base edition
		   		node.name = tmp + " (" + EDITION_BASE + ")";
		   	else
	   			node.name = node.appEdNameWOEdition + ' (' + node.appEdEdition + ")";
		}	
		else
		    node.name = tmp + " (" + EDITION_BASE + ")";
	}

	tmp = elem.getAttribute(ATTR_APPED_STATE);
	if (tmp && node.appEdState != tmp) {
		changed = true;
		node.appEdState = tmp;
	}
		

	// NOT sure this will get used, but it's available if it's useful		
	tmp = elem.getAttribute(ATTR_APPED_DTINSTANCES);
	if (tmp && node.appEdEDTInstances != tmp) {
		changed = true;
		node.appEdDTInstances = tmp;
	}	
	
	node.targetFrame = "graphFrame";	
	return changed;
}

function applicationEditionIconFunction(node, purpose){
	// if (node.isAppLRA.toUpperCase() == TRUE_IND)
	// 	return {url:gridApplicationIcon, alt:GRID_APPLICATION_ICON_LABEL};
	// else
	// 	return {url:appIcon, alt:APPLICATION_ICON_LABEL};	

       if (node.appEdState.toUpperCase() == "ACTIVE")
          return {url:activeAppEditionStateIcon, alt:ACTIVE_APPEDITION_STATE_ICON_LABEL};
       else if (node.appEdState.toUpperCase() == "ACTIVATION")
          return {url:activationAppEditionStateIcon, alt:ACTIVATION_APPEDITION_STATE_ICON_LABEL};
       else if (node.appEdState.toUpperCase() == "INACTIVE")
          return {url:inactiveAppEditionStateIcon, alt:INACTIVE_APPEDITION_STATE_ICON_LABEL};
       else if (node.appEdState.toUpperCase() == "DEACTIVATION")
          return {url:deactivationAppEditionStateIcon, alt:DEACTIVATION_APPEDITION_STATE_ICON_LABEL};
       else if (node.appEdState.toUpperCase() == "VALIDATE")
          return {url:validateAppEditionStateIcon, alt:VALIDATE_APPEDITION_STATE_ICON_LABEL};
       else if (node.appEdState.toUpperCase() == "VALIDATION")
          return {url:validationAppEditionStateIcon, alt:VALIDATION_APPEDITION_STATE_ICON_LABEL};
       else
          return {url:appIcon, alt:APPLICATION_ICON_LABEL};	
}

function applicationEditionInnerHTMLFunction(purpose){
	var html = getCommonInnerHtml(this, purpose);
	return html;
}
function applicationEditionLinkFunction(){
	return LINK_THAT_DOES_NOTHING;
}
function applicationEditionParentFinderHelperFunction(elem, purpose, parent){
	if (PURPOSE_APPLICATION_CENTRIC == purpose){
		var id, text;
		var type = elem.getAttribute(ATTR_TYPE);
		var ret = null;
		if (type == ELEMENT_J2EEMODULE){
			ret = new Array();
			id = getJ2EEModulesID(parent);
			text = J2EE_MODULES;
			ret.push( {id:id, text:text} );
		} else if (type == ELEMENT_DEPLOYMENTTARGET){
			ret = new Array();
			id = getTargetMappingsID(parent);
			text = TARGET_MAPPINGS;
			ret.push( {id:id, text:text} );
			
			var dTType = elem.getAttribute(ATTR_DTTYPE);
			if (dTType == ELEMENT_DYNAMICCLUSTER)
				ret.push( {id:getDynamicClustersId(parent), text:DYNAMICCLUSTERS} );
			else if (dTType == ELEMENT_CLUSTER)
				ret.push( {id:getClustersId(parent), text:CLUSTERS} );
			else if (dTType == ELEMENT_APPSERVER)
				ret.push( {id:getServersId(parent), text:SERVER} );			
		}
	}
	return ret;		
}
function applicationEditionPopupFunction(node, e){
	var contents = new Array();

	if (node.transactionClasses)
		contents.push(TRANSACTIONCLASSES + ": " + node.transactionClasses);
	if (node.serviceClasses)
		contents.push(SERVICECLASSES + ": " + node.serviceClasses);
	if (node.appEdDTInstances)
	 	contents.push(RUNNING_INSTANCES + ": " + node.appEdDTInstances);

	populatePopup(contents);	
	return contents.length > 0;
}



//////=====================================================================

//Proxies

function proxyPopulatorFunction(elem, purpose, node){
	var changed = false;
	node.type = ELEMENT_PROXY;
	
	var tmp = elem.getAttribute(ATTR_NAME);
	if (tmp && node.name != tmp){
		changed = true;
		node.name = tmp;
	}
	tmp = elem.getAttribute(ATTR_HASWSMM);
	if (tmp && node.haswsmm != tmp){
		changed = true;
		node.haswsmm = tmp;
	}
	
	node.targetFrame = "graphFrame";	
	return changed;
}

function proxyIconFunction(node, purpose){
	return {url:proxyIcon, alt:PROXY_ICON_LABEL};
}

function proxyInnerHTMLFunction(purpose){
	var html = getCommonInnerHtml(this, purpose) + getHasWsmmIcon(this, purpose);
	return html;
}

function proxyLinkFunction(node, purpose){
	return LINK_THAT_DOES_NOTHING;
}

function proxyParentFinderHelperFunction(elem, purpose, parent){	
}

function getHasWsmmIcon(node, purpose){
	if (node.hasWsmm && node.hasWsmm.toUpperCase() == TRUE_IND)
		return wsmmIcon;
	return "";	
}

function getProxiesID(parent){
	return "Proxies_" + parent.id;	
}


//////=====================================================================

//Transaction Classes

function transactionClassPopulatorFunction(elem, purpose, node){
	var changed = false;
	node.type = ELEMENT_TRANSACTIONCLASS;
	
	var tmp = elem.getAttribute(ATTR_NAME);
	if (tmp && node.name != tmp){
		changed = true;
		node.name = tmp;
	}
	
	var tmp = elem.getAttribute(ATTR_SERVICECLASS);
	if (tmp && node.serviceClass != tmp){
		changed = true;
		node.serviceClass = tmp;
	}
		
	node.targetFrame = "graphFrame";	
	return changed;
}

function transactionClassIconFunction(node, purpose){
	return {url:tcIcon, alt:TRANSCLASS_ICON_LABEL};
}

function transactionClassInnerHTMLFunction(purpose){
	var html = getCommonInnerHtml(this, purpose);
	return html;
}

function transactionClassLinkFunction(node, purpose){
	return LINK_THAT_DOES_NOTHING;
}

function transactionClassPopupFunction(node, e){
	var contents = new Array();
	
	populatePopup(contents);	
	return contents.length > 0;
}

//////=====================================================================

//Service Classes

function serviceClassPopulatorFunction(elem, purpose, node){
	var changed = false;
	node.type = ELEMENT_SERVICECLASS;
	
	var tmp = elem.getAttribute(ATTR_NAME);
	if (tmp && node.name != tmp){
		changed = true;
		node.name = tmp;
	}

	var tmp = elem.getAttribute(ATTR_GOALVALUE);
	if (tmp && node.goalValue != tmp){
		changed = true;
		node.goalValue = tmp;
	}
	var tmp = elem.getAttribute(ATTR_GOALPCT);
	if (tmp && node.goalPct != tmp){
		changed = true;
		node.goalPct = tmp;
	}
	var tmp = elem.getAttribute(ATTR_GOALTYPE);
	if (tmp && node.goalType != tmp){
		changed = true;
		node.goalType = tmp;
	}
	var tmp = elem.getAttribute(ATTR_IMPORTANCE);
	if (tmp && node.importance != tmp){
		changed = true;
		node.importance = tmp;
	}
	node.targetFrame = "graphFrame";	
	return changed;
}

function serviceClassIconFunction(node, purpose){
	return {url:scIcon, alt:SERVICECLASS_ICON_LABEL};
}

function serviceClassInnerHTMLFunction(purpose){
	var html = getCommonInnerHtml(this, purpose);
	return html;
}

function serviceClassLinkFunction(node, purpose){
	return LINK_THAT_DOES_NOTHING;
}
function serviceClassPopupFunction(node, e){
	var contents = new Array();
	if (node.goalValue && node.goalType!="4")
		contents.push(GOAL_VALUE + ": " + node.goalValue);
	if (node.goalPct)
		contents.push(GOAL_PCT + ": " + node.goalPct);
	if (node.goalType)
		contents.push(GOAL_TYPE + ": " + convertGoalTypeIntToString(node.goalType));
	if (node.importance && node.importance > 0)
		contents.push(IMPORTANCE + ": " + convertImportanceIntToString(node.importance));
	populatePopup(contents);	
	return contents.length > 0;
}

function convertImportanceIntToString(impt){
	var importance = "";
	if (impt >= "1" && impt < "15")
		importance = IMPORTANCE_HIGHEST;
	else if (impt >= "15" && impt < "35")
		importance = IMPORTANCE_HIGHER;
	else if (impt >= "35" && impt < "50")
		importance = IMPORTANCE_HIGH;
	else if (impt >= "50" && impt < "65")
	    importance = IMPORTANCE_MEDIUM;
	else if (impt >= "65" && impt < "85")
	    importance = IMPORTANCE_LOW;
	else if (impt >= "85" && impt < "99")
		importance = IMPORTANCE_LOWER;
	else if (impt >= "99")
	    importance = IMPORTANCE_LOWEST;
	
	return importance;
}

function convertGoalTypeIntToString(type){

	var goaltype = "";
	if (type == "4")
		goaltype = GOAL_TYPE_DISCRETIONARY;
	else if (type == "3")
		goaltype = GOAL_TYPE_PCT_RESPONSE_TIME;
	else if (type == "2")
		goaltype = GOAL_TYPE_AVG_RESPONSE_TIME;
	else if (type == "5")
		goaltype = GOAL_TYPE_QUEUETIME;
	
	return goaltype;
}
	
function serviceClassParentFinderHelperFunction(elem, purpose, parent){
	var type = elem.getAttribute(ATTR_TYPE);
	
	if (type == ELEMENT_DEPLOYMENTTARGET){
		id = getDepTargetID(parent);
		text = DEPLOYMENT_TARGETS;
		ret.push( {id:id, text:text} );
		
		var dTType = elem.getAttribute(ATTR_DTTYPE);
		if (dTType == ELEMENT_DYNAMICCLUSTER)
			ret.push( {id:getDynamicClustersId(parent), text:DYNAMICCLUSTERS} );
		else if (dTType == ELEMENT_CLUSTER)
			ret.push( {id:getClustersId(parent), text:CLUSTERS} );
		else if (dTType == ELEMENT_APPSERVER)
			ret.push( {id:getServersId(parent), text:SERVERS} );
	} 	
}

//////=====================================================================

//NODEGROUPS
function nodeGroupPopulatorFunction(elem, purpose, node){
	var changed = false;
	node.targetFrame = "graphFrame";
	
	var tmp = elem.getAttribute(ATTR_NAME);
	if (tmp && node.name != tmp){
		changed = true;
		node.name = tmp;
	}
		
	//var tmp = elem.getAttribute(ATTR_PLACEMENTCONTROLLER);
	//if (tmp && node.placementController != tmp){
	//	changed = true;
	//	node.placementController = tmp;
	//}	
		
	node.type = ELEMENT_NODEGROUP;
	return changed;
}
function nodeGroupIconFunction(node, purpose){
	if (node.children)
	{
		for(var x = 0; x < node.children.length; x++)
		{
			if (node.children[x].content == "Nodes")
			{
				var tmpNode = node.children[x];
				if (tmpNode.children)
				{
					for(var y = 0; y < tmpNode.children.length; y++)
					{
						if (tmpNode.children[y].children)
						{
							var tmpDetailNode = tmpNode.children[y];
							for (var z = 0; z < tmpDetailNode.children.length; z++)
							{
								if (tmpDetailNode.children[z].dTHealthSickInd == SICK_SERVER)
								{
									var ret = determineSickServerIcon(tmpDetailNode.children[z]);
									node.instanceIcon = nodegroupIcon;
									return ret;
								}
							}
						}
					}
				}
			}
		}
	}
	node.instanceIcon = "";
	return {url:nodegroupIcon, alt:""};
}

function nodeGroupInnerHTMLFunction(purpose){
	var html = getCommonInnerHtml(this, purpose);
	return html;
}
function nodeGroupLinkFunction(node, purpose){
	return chartCollectionUrl + "?new=" + node.name + "&scope=ng&name=" + node.name + "&subdomain=dc&metric=rt&type=line&yaxis2=none&filter=none";
}
function nodeGroupParentFinderHelperFunction(elem, purpose, parent){
	var id, text;
	var type = elem.getAttribute(ATTR_TYPE);
	var ret = new Array();
	if (type == ELEMENT_NODE){
		id = getNodesID(parent);
		text = NODES;
		ret.push( {id:id, text:text} );
	} else if (type == ELEMENT_DEPLOYMENTTARGET){
		id = getDepTargetID(parent);
		text = DEPLOYMENT_TARGETS;
		ret.push( {id:id, text:text} );
		
		var dTType = elem.getAttribute(ATTR_DTTYPE);
		if (dTType == ELEMENT_DYNAMICCLUSTER)
			ret.push( {id:getDynamicClustersId(parent), text:DYNAMICCLUSTERS} );
		else if (dTType == ELEMENT_CLUSTER)
			ret.push( {id:getClustersId(parent), text:CLUSTERS} );
		else if (dTType == ELEMENT_APPSERVER)
			ret.push( {id:getServersId(parent), text:APPSERVERS} );
	} else if (type == ELEMENT_PROXY){
		var id, text;
		var ret = new Array();
		id = getProxiesID(parent);
		text = PROXIES;
		ret.push( {id:id, text:text} );			
	} else if (type == ELEMENT_SPECIALTYSERVER){
		id = getSpecialtyServersId(parent);
		text = SPECIALTY_SERVERS;
		ret.push( {id:id, text:text} );

		var SSType = elem.getAttribute(ATTR_SSTYPE);
		if (SSType == ELEMENT_PROXYSERVER)
			ret.push( {id:getProxiesId(parent), text:PROXYSERVERS} );
		else if (SSType == ELEMENT_WEBSERVER)
			ret.push( {id:getWebServersId(parent), text:WEBSERVERS} );
		else if (SSType == ELEMENT_JMSSERVER)
			ret.push( {id:getJMSServersId(parent), text:JMSSERVERS} );
		else if (SSType == ELEMENT_GENERICSERVER)
			ret.push( {id:getGenericServersId(parent), text:GENERICSERVERS} );
		else if (SSType == ELEMENT_ODRSERVER)
			ret.push( {id:getODRServersId(parent), text:ODRSERVERS} );
      else if (SSType == ELEMENT_DBSERVER)
         ret.push( {id:getDBServersId(parent), text:DBSERVERS} );
			//ret.push( {id:getODRServersId(parent), text:odr_icon_label} );
	}
	return ret;
}


function nodeGroupPopupFunction(node, e)
{
	var contents = new Array();
   var firstTime = 1;
	
	if (node.children)
	{
		for(var x = 0; x < node.children.length; x++)
		{
			if (node.children[x].content == "Nodes")
			{
				var tmpNode = node.children[x];
				var sickestServer = determineSickestServerForNode(tmpNode);

            if (sickestServer != null)
            {
               if (firstTime = 1)
               {
                  contents.push(SICK_SERVER_HEALTH_SUMMARY + " - " + SICK_SERVER_HEALTH_SUMMARY_SEVERE);
                  firstTime = 0;
               }

               contents.push(">" + SICK_SERVER_HEALTH_NODE + "=" + sickestServer.nodeName);
               contents.push("->" + SICK_SERVER_HEALTH_SERVER + "=" + sickestServer.name);

               var detail = sickestServer.dTConditionDetail[0];

               var typeIndex = detail[0].toString().indexOf(" ");
               var type = detail[0].toString().substring(typeIndex+1);
               contents.push("-> " + type); // the condition type

               contents.push(determineConditionSeverity(sickestServer.dTMaxSeverityCondition, "3"));
            }
			}
		}
	}	
	populatePopup(contents);	
	return contents.length > 0;
}


function getDynamicClustersId(parent){
	return "DynamicClusters_" + parent.id;
}
function getClustersId(parent){
	return "Clusters_" + parent.id;
}
function getServersId(parent){
	return "Servers_" + parent.id;
}
function getNodesID(parent){
	return "Nodes_" + parent.id;	
}
function getDepTargetID(parent){
	return "DepTargets_" + parent.id;
}
function getSpecialtyServersId(parent){
	return "SpecialtyServers_" + parent.id;
}
function getProxiesId(parent){
	return "Proxies_" + parent.id;
}
function getWebServersId(parent){
	return "WebServers_" + parent.id;
}
function getJMSServersId(parent){
	return "JMSServers_" + parent.id;
}
function getGenericServersId(parent){
	return "GenericServers_" + parent.id;
}
function getODRServersId(parent){
	return "ODRServers_" + parent.id;
}
function getDBServersId(parent){
   return "DBServers_" + parent.id;
}

//////=====================================================================

//NODES

function nodePopulatorFunction(elem, purpose, node){
	var changed = false;
	node.type = ELEMENT_NODE;
	
	var tmp = elem.getAttribute(ATTR_NAME);
	if (tmp && node.name != tmp){
		changed = true;
		node.name = tmp;
	}

	tmp = elem.getAttribute(ATTR_HASHMM);
	if (tmp && node.hasHMM != tmp){
		changed = true;
		node.hasHMM = tmp;
	}
		
	tmp = elem.getAttribute(ATTR_VERSION);
	if (tmp && node.version != tmp){
		changed = true;
		node.version = tmp;
	}
	
	tmp = elem.getAttribute(ATTR_NODEGROUPNAME);
    if (tmp && node.nodeGroupName != tmp){
         changed = true;
		node.nodeGroupName = tmp;
     }

	tmp = elem.getAttribute(ATTR_MAINTMODE);
	if (tmp && node.maintMode != tmp){
		changed = true;
		node.maintMode = tmp;
	}
		
	tmp = elem.getAttribute(ATTR_CPU_USAGE);
	if (tmp && node.cpuUsage != tmp){
		changed = true;
		node.cpuUsage = tmp;
	}

	tmp = elem.getAttribute(ATTR_HASPLACEMENT);
	if (tmp && node.hasPlacement != tmp){
		changed = true;
		node.hasPlacement = tmp;
	}	
	
	tmp = elem.getAttribute(ATTR_DWLMCONTROLLERS);
	if (tmp != null && tmp != undefined){
		changed = true;
		if (tmp == "")
			node.dwlmDcs = null;	
		else
			node.dwlmDcs = tmp.split(",");
	}
	
	tmp = elem.getAttribute(ATTR_HASARFM);
	if (tmp != null && tmp != undefined)
	{
		changed = true;
		node.hasARFM = tmp;
	}

	tmp = elem.getAttribute(ATTR_HASWP);
	if (tmp != null && tmp != undefined)
	{
		changed = true;
		node.hasWP = tmp;
	}

	tmp = elem.getAttribute(ATTR_HASSCHEDULER);
	if (tmp != null && tmp != undefined)
	{
		changed = true;
		node.hasScheduler = tmp;
	}

	tmp = elem.getAttribute(ATTR_HASBALANCER);
	if (tmp != null && tmp != undefined)
	{
		changed = true;
		node.hasBalancer = tmp;
	}
	
	tmp = elem.getAttribute(ATTR_IS_DB_NODE);
	if (tmp != null && tmp != undefined)
	{
		changed = true;
		node.isDBNode = tmp;
	}
	
	tmp = elem.getAttribute(ATTR_WPMANAGEDCELL);
	if (tmp != null && tmp != undefined)
	{
		changed = true;
		node.wpManagedCell = tmp;
	}
	
	tmp = elem.getAttribute(ATTR_NODESTATE);
	if (tmp != null && tmp != undefined)
	{
		changed = true;
		node.nodeState = tmp;
	}
		
	node.targetFrame = "graphFrame";
	return changed;
}

function nodeIconFunction(node, purpose){
	if (node.children)
	{
		for(var x = 0; x < node.children.length; x++)
		{
			if (node.children[x].dTHealthSickInd == SICK_SERVER)
			{
				var ret = determineSickServerIcon(node.children[x]);
				return ret;
			}
		}
	}
	
	if (MAINTENANCE_MODE_ON == node.maintMode )
	{
		if (node.nodeState == NODE_STATE_GRID)
			return {url:gridNodeMaintIcon, alt:GRID_NODE_MAINT_ICON_LABEL};
		else if (node.nodeState == NODE_STATE_TRANSITION_TO_GRID)
			return {url:gridNodeTransitionMaintIcon, alt:TRANS_TO_GRID_NODE_MAINT_ICON_LABEL};
		else if (node.nodeState == NODE_STATE_TRANSITION_TO_WEB)
			return {url:webNodeTransitionMaintIcon, alt:TRANS_TO_J2EE_NODE_MAINT_ICON_LABEL};
		else
			return{url:maintModeIcon, alt:MAINTMODE_ICON_LABEL};
	}	
	else
	{
		if (node.isDBNode.toUpperCase() == TRUE_IND) //db node can not be in maint mode
			return {url:dbServerIcon, alt:DB_NODE_ICON_LABEL};
		else
		{
			if (node.nodeState == NODE_STATE_GRID)
				return {url:gridNodeIcon, alt:GRID_NODE_ICON_LABEL};
			else if (node.nodeState == NODE_STATE_TRANSITION_TO_GRID)
				return {url:gridNodeTransitionIcon, alt:TRANS_TO_GRID_NODE_ICON_LABEL};
			else if (node.nodeState == NODE_STATE_TRANSITION_TO_WEB)
				return {url:webNodeTransitionIcon, alt:TRANS_TO_J2EE_NODE_ICON_LABEL};
			else
				return {url:nodeIcon, alt:NODE_ICON_LABEL};
		}
	}
}

function nodeInnerHTMLFunction(purpose){
	var html = getCommonInnerHtml(this, purpose) + "<br/><span style='margin-left:3.5em'>" + getVersionInfo(this) + getCpuInfo(this, purpose) + getProvIcons(this, purpose) + getHasPlacementIcon(this, purpose) + getHasHmmIcon(this, purpose) + getDwlmIcons(this, purpose) + getHasARFMIcon(this, purpose) + getHasWorkProfilerIcon(this, purpose) + getHasSchedulerIcon(this, purpose) + getHasBalancerIcon(this, purpose) + "</span>";
	return html;
}


function getVersionInfo(node){
	if (node.version)
		return " (" + node.version + ") ";
	return "";	
}

function getHasPlacementIcon(node, purpose){
	if (node.hasPlacement && node.hasPlacement.toUpperCase() == TRUE_IND){		
		return getTabbableIcon(node, purpose, '<img border="0" src="' + placementIcon + '" title="" alt="'+APC_ICON_LABEL+'" onMouseOver="displaySingleStringPopup(event, APC_ICON_LABEL);" onMouseOut="hidePopup();">', APC_ICON_LABEL);	
	}
	return "";
}

function getHasWorkProfilerIcon(node, purpose){
	if (node.hasWP && node.hasWP.toUpperCase() == TRUE_IND){		
		return getTabbableIcon(node, purpose, '<img border="0" src="' + workProfilerIcon + '" title="" alt="'+WP_ICON_LABEL + ' - ' + WP_MANAGEDCELL_LABEL + ': ' + node.wpManagedCell+'" onMouseOver="displaySingleStringPopup(event, WP_ICON_LABEL + \' - \' + WP_MANAGEDCELL_LABEL + \': \' + \''+node.wpManagedCell+'\');" onMouseOut="hidePopup();">', WP_ICON_LABEL + " - " + WP_MANAGEDCELL_LABEL + ": " + node.wpManagedCell);	
	}
	return "";
}

function getHasARFMIcon(node, purpose){
	if (node.hasARFM && node.hasARFM.toUpperCase() == TRUE_IND){		
		return getTabbableIcon(node, purpose, '<img border="0" src="' + arfmIcon + '" title="" alt="'+ARFM_ICON_LABEL+'" onMouseOver="displaySingleStringPopup(event, ARFM_ICON_LABEL);" onMouseOut="hidePopup();">', ARFM_ICON_LABEL);	
	}
	return "";
}

function getHasBalancerIcon(node, purpose){
	if (node.hasBalancer && node.hasBalancer.toUpperCase() == TRUE_IND){		
		return getTabbableIcon(node, purpose, '<img border="0" src="' + balancerIcon + '" title="" alt="'+ BALANCER_ICON_LABEL+'" onMouseOver="displaySingleStringPopup(event, BALANCER_ICON_LABEL);" onMouseOut="hidePopup();">', BALANCER_ICON_LABEL);	
	}
	return "";
}

function getHasSchedulerIcon(node, purpose){
	if (node.hasScheduler && node.hasScheduler.toUpperCase() == TRUE_IND){		
		return getTabbableIcon(node, purpose, '<img border="0" src="' + schedulerIcon + '" title="" alt="'+SCHEDULER_ICON_LABEL+'" onMouseOver="displaySingleStringPopup(event, SCHEDULER_ICON_LABEL);" onMouseOut="hidePopup();">', SCHEDULER_ICON_LABEL);	
	}
	return "";
}

function getDwlmIcons(node, purpose){
	var ret = "";
	if (node.dwlmDcs){
		var dcName;
		var array = new Array();
		array.push(DWLM_ICON_LABEL);	
		for (var i = 0; i < node.dwlmDcs.length; i++){
			array.push(node.dwlmDcs[i]);			
		}
		var stringifiedArray = stringifyArray(array);	
		var iconAltText = DWLM_ICON_LABEL + ": " + array.join(", ");
		ret = getTabbableIcon(node, purpose, '<img border="0" src="' + dwlmIcon + '" alt="' + iconAltText + '" onMouseOver="displayPopupFromList(event, ['+stringifiedArray+']);" onMouseOut="hidePopup();">', null, stringifiedArray);
	}
	return ret;
}

function stringifyArray(array){
	if (array.length < 1)
		return "";
	var ret = "'" + array[0] + "'";
	
	for (var i = 1; i < array.length; i++){
		ret += ", '";
		ret += array[i];
		ret += "'";		
	}	
	return ret;
}

function getHasHmmIcon(node, purpose){
	if (node.hasHMM && node.hasHMM.toUpperCase() == TRUE_IND){		
		return getTabbableIcon(node, purpose, '<img border="0" src="' + hmmIcon + '" title="" alt="'+HMM_ICON_LABEL+'" onMouseOver="displaySingleStringPopup(event, HMM_ICON_LABEL);" onMouseOut="hidePopup();">', HMM_ICON_LABEL);	
	}
	return "";
}

function nodeLinkFunction(node, purpose){
	//return "/DisplayNodeGroupMemberProperties.do?refId=" + name + "&cameFrom=rt";
	 return LINK_THAT_DOES_NOTHING; //returning "" will make the node not selectable and disable
}
function nodePopupFunction(node, e){
	var numChildren = 0;
	var state;
	for(var x = 0; x < node.children.length; x++)
	{
		if(node.children[x].state == STATE_RUNNING)
			numChildren++;
	}
	var contents = new Array();
	contents.push(RUNNING_INSTANCES + ": " + numChildren);
	
	if (node.children)
	{
		var first = 1;
		for(var x = 0; x < node.children.length; x++)
		{
			if (node.children[x].dTHealthSickInd == SICK_SERVER)
			{
				if (first) //Pop the summary banner the first time thru
				{
					first = 0;
					contents.push(SICK_SERVER_HEALTH_SUMMARY);
				}
					
				contents.push(">" + SICK_SERVER_HEALTH_SERVER + "=" + node.children[x].name);
				contents.push("- " + SICK_SERVER_HEALTH_COUNT + "=" + node.children[x].dTConditionDetail.length);
				contents.push(determineConditionSeverity(node.children[x].dTMaxSeverityCondition, "2"));
			}
		}
	}
	
	populatePopup(contents);	
	return contents.length > 0;
}


function displayCPUPopup(e)
{
	if(!e)
	e = event;
	
	if(!provisioningPopup) return; //none exists...return before we get errors
	
	hideProvisioningPopup();
	
	populateProvisioningPopup([CPU_ICON_LABEL]);
	if(!placePopup(e))
	return;
	showProvisioningPopup();
}
function getProvIcons(node, purpose)
{
	var provSrc;
	var deprovSrc;
	var deprovEventHandlers = "";
	var provEventHandlers = "";
	
	var deprovEventHandlerString = ' onMouseOver="displayProvisioningPopup(\'' + node.id + '\', \'stopping\', event);" onMouseOut="hideProvisioningPopup();" ';
	var provEventHandlerString = ' onMouseOver="javascript:displayProvisioningPopup(\'' + node.id + '\', \'starting\', event);" onMouseOut="hideProvisioningPopup();" ';
	
	var stopping = false;
	var starting = false;

	//evaluate children, see if we should have either a green or red P up.
	for(var x = 0; x < node.children.length; x++)
	{
		if(node.children[x].state == "starting")
			starting = true;
		else if(node.children[x].state == "stopping")
			stopping = true;
	}
	if(stopping)
	{
		deprovSrc = deprovIcon;
		deprovEventHandlers = deprovEventHandlerString;
	}
	else
	{
		if (nodeWithCurrentPopup == node && "stopping" == currentProvPopupState )
			hideProvisioningPopup();
		deprovSrc = null;
	}
	
	if(starting)
	{
		provSrc = provIcon;
		provEventHandlers = provEventHandlerString;
	}
	else
	{
		if (nodeWithCurrentPopup == node && "starting" == currentProvPopupState)
			hideProvisioningPopup();
		
		provSrc = null;
	}
	var html = "";
	if (provSrc != null)
		html = getTabbableIcon(node, purpose, '<img border="0" alt="'+STARTING_SERVER_INSTANCE+'" src="' + provSrc + '" align="top" ' + provEventHandlers + '>');
	if (deprovSrc != null)
		html += getTabbableIcon(node, purpose, '<img border="0" alt="'+STOPPING_SERVER_INSTANCE+'" src="' + deprovSrc + '" align="top" ' + deprovEventHandlers + '>');
	return html;
}

function getCpuInfo(node, purpose)
{
	var cpuUsageText = ERROR;
   var html = "";
	if (node && node.cpuUsage)
	{
		if (node.cpuUsage == CPU_USAGE_UNKNOWN)
			cpuUsageText = "?";
		else if (node.cpuUsage == CPU_USAGE_ERROR)
			cpuUsageText = ERROR;
		else if (node.cpuUsage == "undefined")
		{
			node.cpuUsage = CPU_USAGE_ERROR;
			cpuUsageText = ERROR;
		}		
		else
			cpuUsageText = node.cpuUsage + "%";

      var textToDisplay = CPU_UTILIZATION + ': ' + cpuUsageText;

      html = getTabbableIcon(node, purpose, '<img border="0" src="/ibm/console/com.ibm.ws.console.xdruntime/images/pct/' + node.cpuUsage + '.jpg" style="margin-left:4px; margin-right:0px;" id="PERCENT_' + node.id + '"  onMouseOver="displayCPUPopup(event)" onMouseOut="hidePopup()" title="" alt="'+textToDisplay+ '">', textToDisplay);
	}
	
	return html;
}

var TAB_ICON_END = '</a>';
function getTabbableIcon(node, purpose, src, singlePopupLine, stringifiedArray){
	var TAB_ICON_BEGIN;
	if (singlePopupLine && singlePopupLine.length > 0) {
               singlePopupLine = singlePopupLine.replace(/'/g,"\\'"); // defect 322366
		TAB_ICON_BEGIN = '<a href="javascript:void 0;" onFocus="displaySingleStringPopupOnFocus(\'' + singlePopupLine + '\', this);" onBlur="hidePopup();">';
	} else if (stringifiedArray)
		TAB_ICON_BEGIN = '<a href="javascript:void 0;" onFocus="displayPopupFromListOnFocus(['+stringifiedArray+'], this);" onBlur="hidePopup();">';
	else
		TAB_ICON_BEGIN = '<a href="javascript:void 0;" onFocus="displayPopupOnFocus(\'' + node.id + '\', this, \'' + node.type + '\', \'' + purpose + '\');" onBlur="hidePopup();">';
	return TAB_ICON_BEGIN + src + TAB_ICON_END;
}


//////=====================================================================

//EXTERNAL NODES

function externalNodePopulatorFunction(elem, purpose, node){
	var changed = false;
	node.type = ELEMENT_NODE;
	
	var tmp = elem.getAttribute(ATTR_NAME);
	if (tmp && node.name != tmp){
		changed = true;
		node.name = tmp;
	}

//	tmp = elem.getAttribute(ATTR_VERSION);
//	if (tmp && node.version != tmp){
//		changed = true;
//		node.version = tmp;
//	}

	tmp = elem.getAttribute(ATTR_CPU_USAGE);
	if (tmp && node.cpuUsage != tmp){
		changed = true;
		node.cpuUsage = tmp;
	}
	
//	tmp = elem.getAttribute(ATTR_NODESTATE);
//	if (tmp != null && tmp != undefined)
//	{
//		changed = true;
//		node.nodeState = tmp;
//	}
		
	node.targetFrame = "graphFrame";
	return changed;
}

function externalNodeIconFunction(node, purpose){
	return {url:nodeIcon, alt:NODE_ICON_LABEL};
	
}

function externalNodeInnerHTMLFunction(purpose){
	var html = getCommonInnerHtml(this, purpose) + getCpuInfo(this, purpose);
	return html;
}

function externalNodeLinkFunction(node, purpose){
	 return LINK_THAT_DOES_NOTHING; //returning "" will make the node not selectable and disable
}
function externalNodePopupFunction(node, e){
	var numChildren = 0;
	var state;

	var contents = new Array();

//	for(var x = 0; x < node.children.length; x++)
//	{
//		if(node.children[x].state == STATE_RUNNING)
//			numChildren++;
//	}
//	contents.push(RUNNING_INSTANCES + ": " + numChildren);
	
	populatePopup(contents);	
	return contents.length > 0;
}


//////=====================================================================
//CELL
function cellPopulatorFunction(elem, purpose, node){
        var changed = false;
        node.targetFrame = "graphFrame";

        var tmp = elem.getAttribute(ATTR_NAME);
        if (tmp && node.name != tmp){
                changed = true;
                node.name = tmp;
        }

        node.type = ELEMENT_CELL;

        return changed;
}

function cellIconFunction(node, purpose){
	return {url:cellIcon, alt:""};
}

function cellLinkFunction(node, purpose){
}

function cellMenuCreator(id, level) {
}

function cellInnerHTMLFunction(purpose){
        var html = getCommonInnerHtml(this, purpose);
        return html;
}

function cellParentFinderHelperFunction(elem, purpose, parent){
	var id, text;
	var type = elem.getAttribute(ATTR_TYPE);
	var ret = null;
	if ((PURPOSE_NODEGROUP_CENTRIC == purpose) && (type == ELEMENT_NODEGROUP)) {
		ret = new Array();
		id = getNodeGroupID(parent);
		text = NODEGROUPS;
		ret.push( {id:id, text:text} );
	} else if ((PURPOSE_NODEGROUP_CENTRIC == purpose) && (type == ELEMENT_EXTERNAL_NODE)) {
		ret = new Array();
		id = getExternalNodeID(parent);
		text = EXTERNAL_NODES;
		ret.push( {id:id, text:text} );
		} else if ((PURPOSE_APPLICATION_CENTRIC == purpose) && (type == ELEMENT_APPLICATION)) {
		ret = new Array();
		id = getApplicationID(parent);
		text = APPLICATIONS;
		ret.push( {id:id, text:text} );
	} else if ((PURPOSE_OPPOLICY_CENTRIC == purpose) && (type == ELEMENT_SERVICECLASS)) {
		ret = new Array();
		id = getServiceClassID(parent);
		text = SERVICECLASSES;
		ret.push( {id:id, text:text} );
	}
        return ret;
}

function getNodeGroupID(parent){
        return "NodeGroup_" + parent.id;
}

function getExternalNodeID(parent){
        return "ExternalNode_" + parent.id;
}

function getApplicationID(parent){
        return "Application_" + parent.id;
}

function getServiceClassID(parent){
        return "ServiceClass_" + parent.id;
}

//////=====================================================================

//Deployment Targets


function depTargetPopulatorFunction(elem, purpose, node){
	var changed = false;
	node.type = ELEMENT_DEPLOYMENTTARGET;

	var  tmp = elem.getAttribute(ATTR_NAME);
	if (tmp && node.name != tmp){
		changed = true;
		node.name = tmp;
	}
	tmp = elem.getAttribute(ATTR_STATE);
	if (tmp && node.state != tmp){
		changed = true;
		node.state = tmp;
	}
	tmp = elem.getAttribute(ATTR_DTTYPE);
	if (tmp && node.dTType != tmp){
		changed = true;
		node.dTType = tmp;
	}
	tmp = elem.getAttribute(ATTR_CONCURRENTREQUESTS);	
	if (tmp && node.concurrentRequests != tmp){
		changed = true;
		node.concurrentRequests = tmp;
	}
	tmp = elem.getAttribute(ATTR_NODEGROUPNAME);	
	if (tmp && node.nodeGroupName != tmp){
		changed = true;
		node.nodeGroupName = tmp;
	}
	tmp = elem.getAttribute(ATTR_NODENAME);	
	if (tmp && node.nodeName != tmp){
		changed = true;
		node.nodeName = tmp;
	}
			
	node.targetFrame = "graphFrame";	
	return changed;
}

function depTargetIconFunction(node, purpose){
	var dTType = node.dTType;
	
	if (dTType == ELEMENT_DYNAMICCLUSTER)
		return {url:dynamicClusterIcon, alt:DYNAMICCLUSTER_ICON_LABEL};
	else if (dTType == ELEMENT_APPSERVER)
		return {url:serverIcon, alt:SERVER_ICON_LABEL};
	else if (dTType == ELEMENT_CLUSTER)
		return {url:clusterIcon, alt:CLUSTER_ICON_LABEL};
	return {url:BLANK_ICON, alt:""};
}

function depTargetInnerHTMLFunction(purpose){
	var html = getCommonInnerHtml(this, purpose);
	return html;
}

function depTargetLinkFunction(node, purpose){
	var name = node.name;
	var type = node.dTType;
	if (type == ELEMENT_DYNAMICCLUSTER && name)
		return chartCollectionUrl + "?new=" + name + "&scope=dc&name=" + name + "&subdomain=sc&metric=rt&type=line&yaxis2=none&filter=none";
	else
		return LINK_THAT_DOES_NOTHING;
}
function depTargetContentFunction(node, purpose){
	return node.name;
}
function depTargetParentFinderHelperFunction(elem, purpose, parent){
	var id, text;
	var type = elem.getAttribute(ATTR_TYPE);
	var ret = null;
	if (type == ELEMENT_J2EEMODULE){
		ret = new Array();
		id = getRunningModulesID(parent);
		text = RUNNING_MODULES;
		ret.push({id:id, text:text});
	}
	return ret;
}
function getRunningModulesID(parent){
	return "RunningModules_" + parent.id;	
}
function depTargetPopupFunction(node, e, purpose){
	var contents = new Array();
	if (node.nodeGroupName)
		contents.push(NODEGROUP + ": " + node.nodeGroupName);
	else
		return false;
	populatePopup(contents);
	return contents.length > 0;
}

//////=====================================================================

//Deployment Target Instances

function depTargetInstancePopulatorFunction(elem, purpose, node){
	var changed = false;
	node.type = ELEMENT_DEPLOYMENTTARGETINSTANCE;
	
	var tmp = elem.getAttribute(ATTR_NAME);
	if (tmp && node.name != tmp){
		changed = true;
		node.name = tmp;
	}
	tmp = elem.getAttribute(ATTR_STATE);
	if (tmp && node.state != tmp){
		changed = true;
		node.state = tmp;
	}
	tmp = elem.getAttribute(ATTR_WEIGHT);
	if (tmp && node.weight != tmp){
		changed = true;
		node.weight = tmp;
	}
	tmp = elem.getAttribute(ATTR_PID);	
	if (tmp && node.pid != tmp){
		changed = true;
		node.pid = tmp;
	}
	
	tmp = elem.getAttribute(ATTR_NODENAME);	
	if (tmp && node.nodeName != tmp){
		changed = true;
		node.nodeName = tmp;
	}
	
	tmp = elem.getAttribute(ATTR_SICK_HEALTH);
	if (tmp && node.dTHealthSickInd != tmp){
		changed = true;
		node.dTHealthSickInd = tmp;
	}

	tmp = elem.getAttribute(ATTR_AUTOMATED_CONDITION);
	if (tmp && node.dTHasAutomatedCondition != tmp){
		changed = true;
		node.dTHasAutomatedCondition = tmp;
	}
		
	tmp = elem.getAttribute(ATTR_SUPERVISED_CONDITION);
	if (tmp && node.dTHasSupervisedCondition != tmp){
		changed = true;
		node.dTHasSupervisedCondition = tmp;
	}
	
	tmp = elem.getAttribute(ATTR_MAX_SEVERITY_CONDITION);
	if (tmp && node.dTMaxSeverityCondition != tmp){
		changed = true;
		node.dTMaxSeverityCondition = tmp;
	}
	
	tmp = elem.getAttribute(ATTR_CONDITION_DETAIL);
	if (tmp && node.dTConditionDetail != tmp)
	{
		changed = true;
		var conditionDetailsGrouped = tmp.split("~"); //could be more than 1 condition

		if (conditionDetailsGrouped.length)
		{
			var conditionDetails = new Array(conditionDetailsGrouped.length);
			for (var x=0; x < conditionDetailsGrouped.length; x++)
			{			
				conditionDetails[x] = conditionDetailsGrouped[x].toString().split(", ");
			}	
	
			node.dTConditionDetail = conditionDetails;
		}
	}
	
	node.targetFrame = "graphFrame";
	return changed;
}

function depTargetInstanceParentFinderHelperFunction(elem, purpose, parent){
	var id, text;
	var type = elem.getAttribute(ATTR_TYPE);
	var ret = new Array();
	if (type == ELEMENT_J2EEMODULE)
	{
  		id = "J2EEMODPARENT_" + parent.id;
		text = RUNNING_MODULES;
		ret.push({id:id, text:text});
	}
	return ret;
}

function depTargetInstanceIconFunction(node, purpose){
	if (node.dTHealthSickInd == SICK_SERVER)
	{
		var ret = determineSickServerIcon(node);
		node.instanceIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/jasmInstanceIcon_" + node.state + ".gif";
		return ret;
	}
	node.instanceIcon = "";
	return {url:"/ibm/console/com.ibm.ws.console.xdruntime/images/jasmInstanceIcon_" + node.state + ".gif", alt:INSTANCESTATE_ICON_LABEL};
}

function depTargetInstanceInnerHTMLFunction(purpose){
	var html = getCommonInnerHtml(this, purpose);
	return html;
}

function depTargetInstanceLinkFunction(node, purpose){
	var name = node.name;
	var type = node.dTType;
	if (type == ELEMENT_DYNAMICCLUSTER && name)
		return chartCollectionUrl + "?new=" + name + "&scope=dc&name=" + name + "&subdomain=sc&metric=rt&type=line&yaxis2=none&filter=none";
	else
		return LINK_THAT_DOES_NOTHING;
}
function depTargetInstancePopupFunction(node, e){
	var contents = new Array();
	if (node.pid)
		contents.push(PID + ": " + node.pid);
	if (node.weight)
		contents.push(DWLM_WEIGHT + ": " + node.weight);
	//if (node.nodeName)
	//	contents.push(NODE + ": " + node.nodeName);
	
	if (node.gridJobs)
		contents.push(GRID_JOBS + ": " + node.gridJobs);	
	
	if (node.dTHealthSickInd == SICK_SERVER)
	{
		for (var a=0; a < node.dTConditionDetail.length; a++)
		{
			var detail = node.dTConditionDetail[a];
				
			contents.push("Health Detail " + (a+1) + " of " + node.dTConditionDetail.length);			
			var typeIndex = detail[0].toString().indexOf(" ");
			var type = detail[0].toString().substring(typeIndex+1);
			contents.push("- " + type); // the condition type
			//contents.push("- " + specifics[0].toString()); // the condition type
				
			contents.push(determineConditionSeverity(detail[3].toString(), "1")); // severity			

			contents.push("- " + detail[2].toString()); // the condition detail					
		}	
	}
	
	populatePopup(contents);
	return contents.length > 0;
}


//////=====================================================================

//Specialty Servers

function specServerPopulatorFunction(elem, purpose, node){
	var changed = false;
	node.type = ELEMENT_SPECIALTYSERVER;

	var  tmp = elem.getAttribute(ATTR_NAME);
	if (tmp && node.name != tmp){
		changed = true;
		node.name = tmp;
	}
	tmp = elem.getAttribute(ATTR_STATE);
	if (tmp && node.state != tmp){
		changed = true;
		node.state = tmp;
	}
	tmp = elem.getAttribute(ATTR_SSTYPE);
	if (tmp && node.SSType != tmp){
		changed = true;
		node.SSType = tmp;
	}
	tmp = elem.getAttribute(ATTR_SSSUBTYPE);
	if (tmp && node.SSSubType != tmp) {
		changed = true;
		node.SSSubType = tmp;
	}
	tmp = elem.getAttribute(ATTR_CONCURRENTREQUESTS);	
	if (tmp && node.concurrentRequests != tmp){
		changed = true;
		node.concurrentRequests = tmp;
	}
	tmp = elem.getAttribute(ATTR_NODEGROUPNAME);	
	if (tmp && node.nodeGroupName != tmp){
		changed = true;
		node.nodeGroupName = tmp;
	}
	tmp = elem.getAttribute(ATTR_NODENAME);	
	if (tmp && node.nodeName != tmp){
		changed = true;
		node.nodeName = tmp;
	}
	node.targetFrame = "graphFrame";	
	return changed;
}

function specServerIconFunction(node, purpose){
	var SSType = node.SSType;
	if (SSType == ELEMENT_PROXYSERVER)
		return {url:proxyserverIcon, alt:PROXY_ICON_LABEL};
	else if (SSType == ELEMENT_WEBSERVER)
		return {url:webserverIcon, alt:WEBSERVER_ICON_LABEL};
	else if (SSType == ELEMENT_GENERICSERVER)
		return {url:genericserverIcon, alt:GENERICSERVER_ICON_LABEL};
    else if (SSType == ELEMENT_JMSSERVER)
		return {url:jmsserverIcon, alt:JMSSERVER_ICON_LABEL};
	else if (SSType == ELEMENT_ODRSERVER)
		return {url:proxyserverIcon, alt:ODR_ICON_LABEL};
	else if (SSType == ELEMENT_DBSERVER)
		return {url:dbServerIcon, alt:DBSERVER_ICON_LABEL};
	
	return {url:BLANK_ICON, alt:""};
}

function specServerInnerHTMLFunction(purpose){
	var html = getCommonInnerHtml(this, purpose);
	return html;
}

function specServerLinkFunction(node, purpose){
	var name = node.name;
	var type = node.SSType;
	return LINK_THAT_DOES_NOTHING;
}
function specServerContentFunction(node, purpose){
	return node.name + " (" + node.nodeName + ")";
}
function specServerParentFinderHelperFunction(elem, purpose, parent){
	var id, text;
	var type = elem.getAttribute(ATTR_TYPE);
	var ret = null;
	//if (type == ELEMENT_J2EEMODULE){
	//	ret = new Array();
	//	id = getRunningModulesID(parent);
	//	text = RUNNING_MODULES;
	//	ret.push({id:id, text:text});
	//}
	return ret;
}
function specServerPopupFunction(node, e, purpose){
	var contents = new Array();
	if (node.SSType == ELEMENT_DBSERVER)
	{
		if (node.SSSubType == DBSERVER_TYPE_DB2)
			contents.push(DBSERVER_TYPE_DB2_LABEL + " " + DBSERVER_ICON_LABEL);
		else if (node.SSSubType == DBSERVER_TYPE_ORACLE)
			contents.push(DBSERVER_TYPE_ORACLE_LABEL + " " + DBSERVER_ICON_LABEL);

      if (node.pid)
            contents.push(PID +": " + node.pid);
	}

	populatePopup(contents);
	return contents.length > 0;
}
//////=====================================================================

//Specialty Server Instances

function specServerInstancePopulatorFunction(elem, purpose, node){
	var changed = false;
	node.type = ELEMENT_SPECIALTYSERVERINSTANCE;
	
	var tmp = elem.getAttribute(ATTR_NAME);
	if (tmp && node.name != tmp){
		changed = true;
		node.name = tmp;
	}
	tmp = elem.getAttribute(ATTR_STATE);
	if (tmp && node.state != tmp){
		changed = true;
		node.state = tmp;
	}
	tmp = elem.getAttribute(ATTR_SSTYPE);
	if (tmp && node.SSType != tmp){
		changed = true;
		node.SSType = tmp;
	}
	tmp = elem.getAttribute(ATTR_SSSUBTYPE);
	if (tmp && node.SSSubType != tmp){
		changed = true;
		node.SSSubType = tmp;
	}	
	tmp = elem.getAttribute(ATTR_PORT);
	if (tmp && node.port != tmp){
		changed = true;
		node.port = tmp;
	}
	tmp = elem.getAttribute(ATTR_PID);	
	if (tmp && node.pid != tmp){
		changed = true;
		node.pid = tmp;
	}
	tmp = elem.getAttribute(ATTR_NODENAME);	
	if (tmp && node.nodeName != tmp){
		changed = true;
		node.nodeName = tmp;
	}
	node.targetFrame = "graphFrame";	
	return changed;
}

function specServerInstanceIconFunction(node, purpose){
	return {url:"/ibm/console/com.ibm.ws.console.xdruntime/images/jasmInstanceIcon_" + node.state + ".gif", alt:INSTANCESTATE_ICON_LABEL};
}

function specServerInstanceInnerHTMLFunction(purpose){
	var html = getCommonInnerHtml(this, purpose);
	return html;
}

function specServerInstanceLinkFunction(node, purpose){
	var name = node.name;
	var type = node.SSType;
	return LINK_THAT_DOES_NOTHING;
}
function specServerInstancePopupFunction(node, e){
	var contents = new Array();
	var SSType = node.SSType;
	if (SSType == ELEMENT_PROXYSERVER)
		contents.push(SSTYPE +": " + PROXY_ICON_LABEL);
	else if (SSType == ELEMENT_WEBSERVER)
		contents.push(SSTYPE +": " +WEBSERVER_ICON_LABEL);
	else if (SSType == ELEMENT_GENERICSERVER)
		contents.push(SSTYPE +": " +GENERICSERVER_ICON_LABEL);
    else if (SSType == ELEMENT_JMSSERVER)
		contents.push(SSTYPE +": " +JMSSERVER_ICON_LABEL);
	else if (SSType == ELEMENT_ODRSERVER)
		contents.push(SSTYPE +": " + ODR_ICON_LABEL);
	else if (SSType == ELEMENT_DBSERVER)
	{
		if (node.SSSubType == DBSERVER_TYPE_DB2)
			contents.push(DBSERVER_TYPE_DB2_LABEL + " " + DBSERVER_ICON_LABEL);
		else if (node.SSSubType == DBSERVER_TYPE_ORACLE)
			contents.push(DBSERVER_TYPE_ORACLE_LABEL + " " + DBSERVER_ICON_LABEL);
		else
			contents.push(SSTYPE +": " + DBSERVER_ICON_LABEL);
	}
	else
		contents.push(SSTYPE +": ?");
	if (node.pid)
		contents.push(PID +": " + node.pid);
	if (node.nodeName)
		contents.push(NODE +": " + node.nodeName);
	populatePopup(contents);
	return contents.length > 0;
}
//////=====================================================================

//J2EE Module

function j2eeModulePopulatorFunction(elem, purpose, node){
	var changed = false;
	node.type = ELEMENT_J2EEMODULE;
	
	var tmp = elem.getAttribute(ATTR_NAME);
	if (tmp && node.name != tmp){
		changed = true;
		node.name = tmp;
	}

	tmp = elem.getAttribute(ATTR_SERVICECLASSES);
	if (tmp && node.serviceClasses != tmp){
		changed = true;
		node.serviceClasses = tmp;
	}

	tmp = elem.getAttribute(ATTR_TRANSACTIONCLASSES);
	if (tmp && node.transClasses != tmp){
		changed = true;
		node.transClasses = tmp;
	}
	
	tmp = elem.getAttribute(ATTR_APPLICATIONNAME);	
	if (tmp && node.appName != tmp){
		changed = true;
		node.appName = tmp;
	}

	tmp = elem.getAttribute(ATTR_APPED_EDITION);
	if (tmp && node.appEdEdition != tmp) {
		changed = true;
		node.appEdEdition = tmp;
	}
		
	tmp = elem.getAttribute(ATTR_APPED_NAME_WO_EDITION);
	if (tmp && node.appEdNameWOEdition != tmp) {
		changed = true;
		node.appEdNameWOEdition = tmp;
	}

	node.targetFrame = "graphFrame";	
	return changed;
}

function j2eeModuleIconFunction(node, purpose){
	return {url:j2eeModuleIcon, alt:J2EEMODULE_ICON_LABEL};
}

function j2eeModuleInnerHTMLFunction(purpose){
var html = getCommonInnerHtml(this, purpose) + getProvIcons(this);
	return html;
}

function j2eeModuleLinkFunction(node, purpose){
	return LINK_THAT_DOES_NOTHING;
}
function j2eeModulePopupFunction(node, e, purpose){
	var contents = new Array();
	
	if (node.serviceClasses)
			contents.push(SERVICECLASSES + ": " + node.serviceClasses);
	if (node.transClasses)
			contents.push(TRANSACTIONCLASSES + ": " + node.transClasses);
	
	if (PURPOSE_APPLICATION_CENTRIC == purpose){
		var numChildren = 0;
		for(var x = 0; x < node.children.length; x++)
		{
			if(node.children[x].state == STATE_RUNNING)
				numChildren++;
		}		
		contents.push(RUNNING_INSTANCES + ": " + numChildren);
	}
	
 	populatePopup(contents);	
	return contents.length > 0;
}

function j2eeModuleParentFinderHelperFunction(elem, purpose, parent){
	var id, text;
	var type = elem.getAttribute(ATTR_TYPE);
	var ret = new Array();
	if (type == ELEMENT_DEPLOYMENTTARGETINSTANCE){
		id = getJ2EEModuleInstanceID(parent);
		text = DEPLOYED_IN;
		ret.push( {id:id, text:text} );
	}
	return ret;
}

function j2eeModuleContentFunction(node, purpose){

	var appEd = "";
	
	if (purpose == PURPOSE_OPPOLICY_CENTRIC)
	{
		if (node.appEdEdition != null)
			appEd = node.appEdNameWOEdition + " (" + node.appEdEdition + ")";
		else
			appEd = node.appName + " (" + EDITION_BASE + ")";

		return node.name + " (" + appEd + ")";	
	}
	else if (purpose == PURPOSE_NODEGROUP_CENTRIC)
		return node.name + " (" + node.appName + ")";	
	else
		return node.name;
}

function getJ2EEModuleInstanceID(parent){
	return "J2EEModuleInstance_" + parent.id;
}

//////=====================================================================
//GENERAL METHODS  ========================================================

function determineConditionSeverity(sev, type)
{
	var retString;
	var severity;
	var severityText = "- " + SICK_SERVER_HEALTH_SEVERITY + "=";
	
	if (type == "1")
	{
		//passed as "severity=60" format
		var sevIndex = sev.indexOf("=");
		severity = sev.substring(sevIndex+1);
	}
	else if (type == "2")
	{
		severity = sev;
		severityText = "- " + SICK_SERVER_HEALTH_MAX_SEVERITY + "=";
	}
	else if (type == "3")
	{
		severity = sev;
		severityText = "-> " + SICK_SERVER_HEALTH_MAX_SEVERITY + "=";
	}
			
	if (severity == SICK_SEVERITY_FATAL)
		retString = severityText + SICK_SERVER_ERROR_FATAL;
	else if (severity == SICK_SEVERITY_CRITICAL)
		retString = severityText + SICK_SERVER_ERROR_CRITICAL;
	else if (severity == SICK_SEVERITY_SEVERE)
		retString = severityText + SICK_SERVER_ERROR_SEVERE;
	else if (severity == SICK_SEVERITY_MINOR)
		retString = severityText + SICK_SERVER_ERROR_MINOR;
	else //default Warning ** //else if (severity == SICK_SEVERITY_WARNING)
		retString = severityText + SICK_SERVER_ERROR_WARNING;
	//else if (severity == SICK_SEVERITY_HARMLESS)
	//	retString = severityText + "Harmless";
	//else //default Information is not populated
	//	retString = severityText + "Information";
			
	return (retString);
}

function determineSickestServerForNode(node)
{
	//node is the Node level node, so dig for the children
	if (node.children)
	{
		var condition;
		for(var y = 0; y < node.children.length; y++)
		{
			if (node.children[y].children && node.children[y].children.length)
			{
				var tmpDetailNode = node.children[y];
            var grabIt = 0;

            //Go through the severities...spinning the sick servers looking for the 1st hit condition...it will be the sickest
            for (var x = 0; x < 5; x++)
            {
               if (x == 0)
                  condition = SICK_SEVERITY_FATAL;
               else if (x == 1)
                  condition = SICK_SEVERITY_CRITICAL;
               else if (x == 2)
                  condition = SICK_SEVERITY_SEVERE;
               else if (x == 3)
                  condition = SICK_SEVERITY_MINOR;
               else if (x == 4)
                  condition = SICK_SEVERITY_WARNING;

               for (var z = 0; z < tmpDetailNode.children.length; z++)
   				{
	   				if (tmpDetailNode.children[z].dTHealthSickInd == SICK_SERVER)
		   			{
			   			if (tmpDetailNode.children[z].dTMaxSeverityCondition == condition)
				   			grabIt = 1;

                     if (grabIt)
                     {
                        return (tmpDetailNode.children[z]);
                     }
			   		}
				   }
            }
			}
		}
	}
	return null; //should not get here		
}

function determineSickServerIcon(node)
{
	var retVal;
	var partialURI;
	
	//determine the severity and get the Partial URI to build the icon location string	
	if (node.dTMaxSeverityCondition == SICK_SEVERITY_FATAL)
		partialURI = sickFatalIconPartialURI;
	else if (node.dTMaxSeverityCondition == SICK_SEVERITY_CRITICAL)
		partialURI = sickCriticalIconPartialURI;
	else if (node.dTMaxSeverityCondition == SICK_SEVERITY_SEVERE)
		partialURI = sickSevereIconPartialURI;
	else if (node.dTMaxSeverityCondition == SICK_SEVERITY_MINOR)
		partialURI = sickMinorIconPartialURI;
	else if (node.dTMaxSeverityCondition == SICK_SEVERITY_WARNING)
		partialURI = sickWarningIconPartialURI;
	else if (node.dTMaxSeverityCondition == SICK_SEVERITY_HARMLESS)
		partialURI = sickHarmlessIconPartialURI;
	else //default Information if not populated
		partialURI = sickInformationIconPartialURI;
	
	if (node.dTHasAutomatedCondition == TRUE_IND)  // it's automated
	{
		retVal = {url:partialURI + sickAutoURISuffix, alt:SICK_SERVER_AUTO_ICON_LABEL};
	}
	else //must be supervised
	{
		retVal = {url:partialURI + sickSupervisedURISuffix, alt:SICK_SERVER_SUPR_ICON_LABEL};
	}
	
	return retVal;
}


function getSpecialNodeInnerHtml(purpose)
{
	var html = getCommonInnerHtml(this, purpose);
	return html;
}

function getCommonInnerHtml(node, purpose)
{
	var html="";
	if (node.level > 1)
		html += getExpanderIcon(node);
	html += getIconAndContent(node, purpose);
	return html;
}

function contentFromNameFunction(node, purpose){
	return node.name;
}

function findParentNode(elem, purpose, parent){
	var type = elem.getAttribute(ATTR_TYPE);
	var ret = parent;
	var helper = parentFinderHelperFunctions[parent.type];
	var infoArray = helper(elem, purpose, parent); //this is an array, index 0 is the first level, 1 is the second, etc.
	if (infoArray && infoArray.length > 0) {
		var info;
		for (var i = 0; i < infoArray.length; i++){
			info = infoArray[i];
			var node = nodeIndex[info.id];
			if (!node) {// doesn't exist, we need to create it.
				node = addItem(purpose, parent, "", "", info.text, "", info.id, getSpecialNodeInnerHtml, TYPE_LABEL);
			}
			parent = node;			
		}
		ret = node;		
		var currNode;
		for (var i = infoArray.length - 2; i >= 0; i--){ // we don't set the padding on the bottom most one, because it hasn't had its child added yet.  If we create multiple at once, though - the top n-1 can have their padding set.
			currNode = nodeIndex[infoArray[i].id];
			if (currNode)
				currNode.setPadding(currNode.layer);		
		}
	}
	
		
	return ret;
}

//parent finder functions accept (among other things) a node parameter, which represents the entity
	//which is the logical parent of the child node being added.  The method then returns the actual node in the
	//tree which is to be the parent of the created node.  For instance, when adding a Dynamic Cluster to a NodeGroup, the
	//node group is the logical parent.  However, a special "Dynamic Clusters" node is the actual parent of the new node.
	//RETURNS: an object with two properties: id and text - id is the id of the node that will be the parent, and text is
	//the text which should be used for that node's content (if a new node must be created)
	
//this returns null, which means to use the parent passed in
function commonParentFinderHelperFunction(elem, purpose, parent){
	return null;
}


//GENERIC HANDLER classes:
//these classes are intended to handle XML nodes that don't correspond to types that get populated into the visible tree.
function RootNameGenericHandler(){
	this.add = function(elem){
		var name = elem.getAttribute(ATTR_NAME);
		if (name)
			addToSelectBox(name);
	};	
	
	this.update = function(elem){
		//this shouldn't get called.
	};	
	
	this.remove = function(elem){
		var name = elem.getAttribute(ATTR_NAME);
		if (name)
			removeFromSelectBox(name);
	};		
}


///////////////POPUP MENU STUF========================================================================

//we need to override the default onclick handler for the document in the case that:
//the click is right button, and the target is menuable.

function isMenuAble(node){
	//nodes & nodegroups
	if (node.type == ELEMENT_NODE || node.type == ELEMENT_NODEGROUP)
		return true;
	
	//server instances
	if (node.type == ELEMENT_DEPLOYMENTTARGETINSTANCE)
		return true;
		
	//applications & J2EE Modules
	if (node.type == ELEMENT_APPLICATION_EDITION || node.type == ELEMENT_J2EEMODULE)
		return true;
	
	//transaction classes & service classes
	if (node.type == ELEMENT_SERVICECLASS || node.type == ELEMENT_TRANSACTIONCLASS)
		return true;
		
	//dynamic clusters
	if (node.type == ELEMENT_DEPLOYMENTTARGET)
		return true;

	//specialy servers
	if (node.type == ELEMENT_SPECIALTYSERVER)
		return true;

	//specialy servers instance
	if (node.type == ELEMENT_SPECIALTYSERVERINSTANCE)
		return true;

	return false;
}

function handleMouseDownEvent(e){
	if (!e)
		e = event;
	
	var targetId = getTargetId(e);
	if (!targetId || !divIndex[targetId]){
		for (var menuId in menuIndex)
			menuIndex[menuId].closeIt();
	}
}

function createMenuOnEvent(e, id){
	if (!e)
		e = event;
	e.cancelBubble=true;

	if(e.pageX != undefined)
		createMenu(e.pageX + 10, e.pageY, id);
	else if(e.clientX != undefined)
		createMenu(e.clientX + 10, e.clientY, id);	
}

function createMenuOnFocus(targetObj, id){
	var x = targetObj.offsetLeft + targetObj.offsetWidth;
	var y = targetObj.offsetTop;
	createMenu(x + 10, y, id);	
}

function createMenu(x, y, id){
	var node = nodeIndex[id];
	if (!node)	
		return;
	
	var type = node.type;
	if (!type)
		return;
		
	var constructor = menuCreators[type];
	if (!constructor)
		return;
		
	var menuCreator = new constructor(id, 0);	
	var menu = menuCreator.create();
	if (menu)
		menu.display(x, y);
}


//id: the id of one of the nodes in the topology tree (stored in nodeIndex).  This ID is reused as the ID of the corresponding menu.
function NodeMenuCreator(id, level){
	this.level = level;
	this.id = id;
	
	this.create = function(){
		if (menuIndex[id]) return;
		var node = nodeIndex[id];
		if (!node) return;
		
		var name = "NodeMenu";
		var contents = new Object();
		
		var menuAction;
		var menuAction1;

        var subChartNode = id + "_NODECHARTS";

        // sub menus for different chart types
        var menuCreatorNode = new NodeChartMenuCreator(subChartNode, level+1, node.name, node.isDBNode);
        var subMenuNode = new SubMenu(menuCreatorNode, subChartNode);
        contents[CHART_LINK] = subMenuNode;

		if (userIsOperator || userIsAdministrator){
			if (node.maintMode == MAINTENANCE_MODE_ON){
				menuAction = new MenuAction(getUnSetMaintModeUrl(node.name));
				contents[UNSET_MAINTENANCE_MODE] = menuAction;
			}else{
				menuAction = new MenuAction(getSetMaintModeUrl(node.name));
				menuAction1 = new MenuAction(getSetMaintModeLeaveProcessUrl(node.name));
				contents[SET_MAINTENANCE_MODE] = menuAction;
				contents[MAINT_MODE_LEAVE_PROC] = menuAction1;
				//contents["Set Maintenance Mode, Leave Processes Running"] = menuAction1;
			}
		}
		
		menuAction = new MenuAction(getNodeConfigPanelUrl(node.name, node.nodeName), parent.name);
		contents[GO_TO_CONFIG_PANEL] = menuAction;
		
		var menu = new Menu(contents, name, "ROOT", level);
		return menu;
	};
}


function NodeChartMenuCreator(id, level, cName, isDBNode){
	this.level = level;
	this.id = id;
	this.cName = cName;
	this.isDBNode = isDBNode;
	
	this.create = function(){
		if (menuIndex[id]) return;
		
		var name = "NodeChartMenu";
		var contents = new Object();
		
		var menuAction;

		if (this.isDBNode.toUpperCase() == TRUE_IND)
		{
	        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=dbnode&name=" + this.cName + "&subdomain=dbsrv&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
    	    contents[CHART_LINK_NONE] = menuAction;
		}
		else
		{			
	        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=node&name=" + this.cName + "&subdomain=srv&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
    	    contents[APPSERVERS] = menuAction;

	        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=node&name=" + this.cName + "&subdomain=modinst&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
    	    contents[J2EE_MODULES] = menuAction;

        	menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=node&name=" + this.cName + "&subdomain=none&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        	contents[CHART_LINK_NONE] = menuAction;
		}
		
		var menu = new Menu(contents, name, id, level);
		return menu;
	};
}
////////////////////////////////////////////////////////

function NodeGroupMenuCreator(id, level){
	this.level = level;
	this.id = id;
	
	this.create = function(){
		if (menuIndex[id]) return;
				
		var node = nodeIndex[id];
		if (!node) return;
		
		var name = "NodeGroupMenu";
		var contents = new Object();
						
		var menuAction;

        var subChartNG = id + "_NGCHARTS";
		 				
        // sub menus for different chart types
        var menuCreatorNG = new NGChartMenuCreator(subChartNG, level+1, node.name);
        var subMenuNG = new SubMenu(menuCreatorNG, subChartNG);
        contents[CHART_LINK] = subMenuNG;

		
		menuAction = new MenuAction(getNodeGroupConfigPanelUrl(node.name, node.nodeName), parent.name);
		contents[GO_TO_CONFIG_PANEL] = menuAction;
		
		if (node.children)
		{
			for(var x = 0; x < node.children.length; x++)
			{
				if (node.children[x].content == "Nodes")
				{
					var tmpNode = node.children[x];
					var sickestServer = determineSickestServerForNode(tmpNode);

            		if (sickestServer != null)
            		{
            			menuAction = new MenuAction("javascript:expandCompressNode('"+node.id+"');expandCompressNode('"+sickestServer.parent.parent.id+"');expandCompressNode('"+sickestServer.parent.id+"');");
            			contents[SHOW_SICK_SERVER] = menuAction;           			
            		}
				}
			}
		}	
		
		
		
		
		var menu = new Menu(contents, name, "ROOT", level);
		return menu;
	};
}

function NGChartMenuCreator(id, level, cName){
	this.level = level;
	this.id = id;
	this.cName = cName;
	
	this.create = function(){
		if (menuIndex[id]) return;
		
		var name = "NGChartMenu";
		var contents = new Object();
		
		var menuAction;

        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=ng&name=" + this.cName + "&subdomain=node&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        contents[NODES] = menuAction;

        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=ng&name=" + this.cName + "&subdomain=dc&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        contents[DYNAMICCLUSTERS] = menuAction;

        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=ng&name=" + this.cName + "&subdomain=none&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        contents[CHART_LINK_NONE] = menuAction;

		
		var menu = new Menu(contents, name, id, level);
		return menu;
	};
}
//id: the id of one of the nodes in the topology tree (stored in nodeIndex).  This ID is reused as the ID of the corresponding menu.
function SpecServerMenuCreator(id, level){
	this.level = level;
	this.id = id;
	
	this.create = function(){
		if (menuIndex[id]) return;
		var node = nodeIndex[id];
		if (!node) return;
		
		var name = "DCMenu";
		var contents = new Object();
		
		var menuAction;
		var subId = id + "_OPMODES";
		
		/*
		SpecialyServer PopUp:
PopUps for Specialty Server:
Goto Configuration Panel
Open Chart
		*/
		
				
		if (node.SSType == ELEMENT_ODRSERVER)
		{
			menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=odr&name=" + node.name + "&subdomain=none&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
			contents[CHART_LINK_NONE] = menuAction;
		}
		else if (node.SSType == ELEMENT_PROXYSERVER)
		{
			menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=proxy&name=" + node.name + "&subdomain=none&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
			contents[CHART_LINK_NONE] = menuAction;
		}
		if (node.SSType == ELEMENT_DBSERVER)
		{
			menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=dbsrv&name=" + node.name + "&subdomain=none&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
			contents[CHART_LINK_NONE] = menuAction;
		}

		menuAction = new MenuAction(getSpecialtyServerConfigPanelUrl(node.name, node.nodeName, node.SSType), parent.name);
		contents[GO_TO_CONFIG_PANEL] = menuAction;			

		var menu = new Menu(contents, name, "ROOT", level);
		return menu;
	};
}

//id: the id of one of the nodes in the topology tree (stored in nodeIndex).  This ID is reused as the ID of the corresponding menu.
function DTMenuCreator(id, level){
	this.level = level;
	this.id = id;
	
	this.create = function(){
		if (menuIndex[id]) return;
		var node = nodeIndex[id];
		if (!node) return;
		
		var name = "DCMenu";
		var contents = new Object();
		
		var menuAction;
		var subId = id + "_OPMODES";
        var subChartDC = id + "_DCCHARTS";
        var subChartCLSTR = id + "_CLSTRCHARTS";
        var subChartSRV = id + "_SRVCHARTS";
		
		/*
		DeploymentTarget PopUp:
        PopUps for DCluster, Cluster, AppServer:
        Goto Configuration Panel
        Open Chart
		*/
		
		
		if (node.dTType == ELEMENT_DYNAMICCLUSTER){
			if (userIsOperator || userIsAdministrator){
				var menuCreator = new OpModeMenuCreator(subId, level+1, node.name, node.nodeGroupName);
				var subMenu = new SubMenu(menuCreator, subId);
				contents[SET_OPERATION_MODE] = subMenu;
			}

            // sub menus for different chart types
            var menuCreatorDC = new DCChartMenuCreator(subChartDC, level+1, node.name);
            var subMenuDC = new SubMenu(menuCreatorDC, subChartDC);
            contents[CHART_LINK] = subMenuDC;

			menuAction = new MenuAction(getDCConfigPanelUrl(node.name, node.nodeGroupName), parent.name);
			contents[GO_TO_CONFIG_PANEL] = menuAction;

		} else if (node.dTType == ELEMENT_CLUSTER){
			menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=clstr&name=" + node.name + "&subdomain=sc&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
			contents[CHART_LINK] = menuAction;

            // sub menus for different chart types
            var menuCreatorCLSTR = new CLSTRChartMenuCreator(subChartCLSTR, level+1, node.name);
            var subMenuCLSTR = new SubMenu(menuCreatorCLSTR, subChartCLSTR);
            contents[CHART_LINK] = subMenuCLSTR;

		
			menuAction = new MenuAction(getClusterConfigPanelUrl(node.name), parent.name);
			contents[GO_TO_CONFIG_PANEL] = menuAction;
		} else if (node.dTType == ELEMENT_APPSERVER){
			//menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=srv&name=" + node.nodeName + ":"+node.name + "&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
			//contents[CHART_LINK] = menuAction;

            // sub menus for different chart types
            var menuCreatorSRV = new SRVChartMenuCreator(subChartSRV, level+1, node);
            var subMenuSRV = new SubMenu(menuCreatorSRV, subChartSRV);
            contents[CHART_LINK] = subMenuSRV;

		
			menuAction = new MenuAction(getServerInstanceConfigPanelUrl(node.name, node.nodeName), parent.name);
			contents[GO_TO_CONFIG_PANEL] = menuAction;			
		}
		
		var menu = new Menu(contents, name, "ROOT", level);
		return menu;
	};
}

//id: the id of one of the nodes in the topology tree (stored in nodeIndex).  This ID is reused as the ID of the corresponding menu.
function OpModeMenuCreator(id, level, dcName, ngName){
	this.level = level;
	this.id = id;
	this.dcName = dcName;
	this.ngName = ngName;
	
	this.create = function(){
		if (menuIndex[id]) return;
		
		var name = "OpModeMenu";
		var contents = new Object();
		
		var menuAction;
		menuAction = new MenuAction(getChangeOperationModeUrl(this.dcName, this.ngName, OPCODE_MANUAL));
		contents[OPMODE_MANUAL] = menuAction;		

		menuAction = new MenuAction(getChangeOperationModeUrl(this.dcName, this.ngName, OPCODE_SUPERVISED));
		contents[OPMODE_SUPERVISED] = menuAction;		

		menuAction = new MenuAction(getChangeOperationModeUrl(this.dcName, this.ngName, OPCODE_ON_DEMAND));
		contents[OPMODE_ON_DEMAND] = menuAction;		
		
		var menu = new Menu(contents, name, id, level);
		return menu;
	};
}

function DCChartMenuCreator(id, level, dcName){
	this.level = level;
	this.id = id;
	this.dcName = dcName;
	
	this.create = function(){
		if (menuIndex[id]) return;
		
		var name = "DCChartMenu";
		var contents = new Object();
		
		var menuAction;

        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=dc&name=" + this.dcName + "&subdomain=srv&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        contents[APPSERVERS] = menuAction;

        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=dc&name=" + this.dcName + "&subdomain=sc&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        contents[SERVICECLASSES] = menuAction;
 	
        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=dc&name=" + this.dcName + "&subdomain=tc&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        contents[TRANSACTIONCLASSES] = menuAction;

        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=dc&name=" + this.dcName + "&subdomain=none&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        //contents[CHART_LINK_NONE] = menuAction;
        // This shows the instance name as the chart menu option
        contents[CHART_LINK_NONE] = menuAction;

		
		var menu = new Menu(contents, name, id, level);
		return menu;
	};
}

function CLSTRChartMenuCreator(id, level, cName){
	this.level = level;
	this.id = id;
	this.cName = cName;
	
	this.create = function(){
		if (menuIndex[id]) return;
		
		var name = "CLSTRChartMenu";
		var contents = new Object();
		
		var menuAction;

        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=clstr&name=" + this.cName + "&subdomain=srv&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        contents[APPSERVERS] = menuAction;

        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=clstr&name=" + this.cName + "&subdomain=sc&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        contents[SERVICECLASSES] = menuAction;
 	
        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=clstr&name=" + this.cName + "&subdomain=tc&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        contents[TRANSACTIONCLASSES] = menuAction;

        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=clstr&name=" + this.cName + "&subdomain=none&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        contents[CHART_LINK_NONE] = menuAction;

		
		var menu = new Menu(contents, name, id, level);
		return menu;
	};
}

function SRVChartMenuCreator(id, level, cnode){
	this.level = level;
	this.id = id;
	//this.node = cnode;
	
	this.create = function(){
		if (menuIndex[id]) return;
		
		var name = "CLSTRChartMenu";
		var contents = new Object();
		
		var menuAction;

        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=srv&name=" + cnode.nodeName + ":"+cnode.name + "&subdomain=sc&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        //menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=srv&name=" + this.cName + "&subdomain=modinst&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        contents[SERVICECLASSES] = menuAction;

        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=srv&name=" + cnode.nodeName + ":"+cnode.name + "&subdomain=tc&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        //menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=srv&name=" + this.cName + "&subdomain=modinst&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        contents[TRANSACTIONCLASSES] = menuAction;


        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=srv&name=" + cnode.nodeName + ":"+cnode.name + "&subdomain=modinst&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        //menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=srv&name=" + this.cName + "&subdomain=modinst&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        contents[J2EE_MODULES] = menuAction;

        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=srv&name=" + cnode.nodeName + ":"+cnode.name + "&subdomain=none&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        //menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=srv&name=" + this.cName + "&subdomain=none&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        contents[CHART_LINK_NONE] = menuAction;

		
		var menu = new Menu(contents, name, id, level);
		return menu;
	};
}




//id: the id of one of the serverInstance in the topology tree (stored in nodeIndex).  This ID is reused as the ID of the corresponding menu.
function ServerInstanceMenuCreator(id, level){
	this.level = level;
	this.id = id;
	
	this.create = function(){
		if (menuIndex[id]) return;
		var node = nodeIndex[id];
		if (!node) return;
		
		var name = "ServerInstanceMenu";
		var contents = new Object();
		
		var menuAction;

        var subChartSRV = id + "_SRVCHARTS";

		//menuAction = new MenuAction(chartCollectionUrl + '?new=true&scope=srv&name='+ node.nodeName + ":" + node.name+ '&subdomain=none&metric=rt&type=line&yaxis2=none&filter=none', GRAPH_FRAME);
		//contents[CHART_LINK] = menuAction;

            // sub menus for different chart types
            var menuCreatorSRV = new SRVChartMenuCreator(subChartSRV, level+1, node);
            var subMenuSRV = new SubMenu(menuCreatorSRV, subChartSRV);
            contents[CHART_LINK] = subMenuSRV;


		if (userIsOperator || userIsAdministrator){
			menuAction = new MenuAction(getStopServerInstanceUrl(node.name, node.nodeName));
			contents[STOP] = menuAction;
		
			menuAction = new MenuAction(getSmartStopServerInstanceUrl(node.name, node.nodeName));
			contents[SMART_STOP] = menuAction;		
		}
		
		menuAction = new MenuAction(getServerLogsUrl(node.nodeName, node.name), parent.name);
		contents[SERVERLOGS] = menuAction;		
				
		if (node.dTType == ELEMENT_DYNAMICCLUSTER && node.name){
			menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=dc&name=" + node.name + "&subdomain=sc&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
			contents[CHART_LINK] = menuAction;

			menuAction = new MenuAction(getServerInstanceConfigPanelUrl(node.name, node.nodeName), parent.name);
			contents[GO_TO_CONFIG_PANEL] = menuAction;				
		} else if (node.dTType == ELEMENT_APPSERVER && node.name){
			//menuAction = new MenuAction(chartCollectionUrl + '?new=true&scope=srv&name='+ node.nodeName + ":" + node.name+ '&subdomain=app&metric=rt&type=line&yaxis2=none&filter=none', GRAPH_FRAME);
			//contents[CHART_LINK] = menuAction;

            // sub menus for different chart types
            var menuCreatorSRV = new SRVChartMenuCreator(subChartSRV, level+1, node);
            var subMenuSRV = new SubMenu(menuCreatorSRV, subChartSRV);
            contents[CHART_LINK] = subMenuSRV;

			
			menuAction = new MenuAction(getServerInstanceConfigPanelUrl(node.name, node.nodeName), parent.name);
			contents[GO_TO_CONFIG_PANEL] = menuAction;					
		}
		
		if (node.dTHealthSickInd == SICK_SERVER)
		{
			menuAction = new MenuAction(getRuntimeTasksUrl(), "_parent");
			contents[SHOW_RUNTIME_TASKS] = menuAction;
			//contents["Show Task Detail"] = menuAction;
		}
			
		var menu = new Menu(contents, name, "ROOT", level);
		return menu;
	};
}	

//id: the id of one of the serverInstance in the topology tree (stored in nodeIndex).  This ID is reused as the ID of the corresponding menu.
function SpecServerInstanceMenuCreator(id, level){
	this.level = level;
	this.id = id;
	
	this.create = function(){
		if (menuIndex[id]) return;
		var node = nodeIndex[id];
		if (!node) return;
		
		var name = "SpecServerInstanceMenu";
		var contents = new Object();
		
		var menuAction;

        var subChartSRV = id + "_SRVCHARTS";

		//menuAction = new MenuAction(chartCollectionUrl + '?new=true&scope=srv&name='+ node.nodeName + ":" + node.name+ '&subdomain=none&metric=rt&type=line&yaxis2=none&filter=none', GRAPH_FRAME);
		//contents[CHART_LINK] = menuAction;

		if (userIsOperator || userIsAdministrator){
			menuAction = new MenuAction(getStopServerInstanceUrl(node.name, node.nodeName));
			contents[STOP] = menuAction;
		
			menuAction = new MenuAction(getSmartStopServerInstanceUrl(node.name, node.nodeName));
			contents[SMART_STOP] = menuAction;		
		}
		
		menuAction = new MenuAction(getServerLogsUrl(node.nodeName, node.name), parent.name);
		contents[SERVERLOGS] = menuAction;		


		if (node.dTType == ELEMENT_DYNAMICCLUSTER && node.name){
			menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=dc&name=" + node.name + "&subdomain=sc&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
			contents[CHART_LINK] = menuAction;

			menuAction = new MenuAction(getServerInstanceConfigPanelUrl(node.name, node.nodeName), parent.name);
			contents[GO_TO_CONFIG_PANEL] = menuAction;					
		} else if (node.dTType == ELEMENT_APPSERVER && node.name){
			//menuAction = new MenuAction(chartCollectionUrl + '?new=true&scope=srv&name='+ node.nodeName + ":" + node.name+ '&subdomain=app&metric=rt&type=line&yaxis2=none&filter=none', GRAPH_FRAME);
			//contents[CHART_LINK] = menuAction;

            // sub menus for different chart types
            var menuCreatorSRV = new SRVChartMenuCreator(subChartSRV, level+1, node);
            var subMenuSRV = new SubMenu(menuCreatorSRV, subChartSRV);
            contents[CHART_LINK] = subMenuSRV;

			
			menuAction = new MenuAction(getServerInstanceConfigPanelUrl(node.name, node.nodeName), parent.name);
			contents[GO_TO_CONFIG_PANEL] = menuAction;		
		}
		
		var menu = new Menu(contents, name, "ROOT", level);
		return menu;
	};
}

//id: the id of one of the serverInstance in the topology tree (stored in nodeIndex).  This ID is reused as the ID of the corresponding menu.
function ApplicationMenuCreator(id, level){
	this.level = level;
	this.id = id;
	
	this.create = function(){
		if (menuIndex[id]) return;
		var node = nodeIndex[id];
		if (!node) return;
		
		var name = "ApplicationMenu";
		var contents = new Object();
		var menuAction;
						
		if (node.name >= EDITION_BASE) //if it's base, use the app name w/o edition or base suffix
			menuAction = new MenuAction(chartCollectionUrl + '?new=true&scope=app&name='+ node.appEdNameWOEdition + '&metric=rt&type=line&yaxis2=none&filter=none', GRAPH_FRAME);
		else
			menuAction = new MenuAction(chartCollectionUrl + '?new=true&scope=app&name='+ node.name+ '&metric=rt&type=line&yaxis2=none&filter=none', GRAPH_FRAME);
		
		contents[CHART_LINK] = menuAction;

		if (node.name >= EDITION_BASE) //if it's base, use the app name w/o edition or base suffix
			menuAction = new MenuAction(getAppConfigPanelUrl(node.appEdNameWOEdition), parent.name);
		else
			menuAction = new MenuAction(getAppConfigPanelUrl(node.name), parent.name);

		contents[GO_TO_CONFIG_PANEL] = menuAction;
	
		if (userIsConfigurator || userIsAdministrator){
			menuAction = new MenuAction(getServiceClassConfigPanelUrl(node.serviceClasses), parent.name);
			contents[CONFIG_SERVICE_CLASS] = menuAction;
		}
			
		var menu = new Menu(contents, name, "ROOT", level);
		return menu;
	};
}	

//id: the id of one of the serverInstance in the topology tree (stored in nodeIndex).  This ID is reused as the ID of the corresponding menu.
function ApplicationEditionMenuCreator(id, level){
	this.level = level;
	this.id = id;
	
	this.create = function(){
		if (menuIndex[id]) return;
		var node = nodeIndex[id];
		if (!node) return;
		
		var name = "ApplicationEditionMenu";
		var contents = new Object();
		var menuAction;
        var subChartMOD = id + "_APPEDCHARTS";

        // sub menus for different chart types
        var menuCreatorMOD = new APPEDChartMenuCreator(subChartMOD, level+1, node);
        var subMenuMOD = new SubMenu(menuCreatorMOD, subChartMOD);
        contents[CHART_LINK] = subMenuMOD;

		if (node.name >= EDITION_BASE) //if it's base, use the app name w/o edition or base suffix
			menuAction = new MenuAction(getAppConfigPanelUrl(node.appEdNameWOEdition), parent.name);
		else
			menuAction = new MenuAction(getAppConfigPanelUrl(node.name), parent.name);

		contents[GO_TO_CONFIG_PANEL] = menuAction;
	
		if (userIsConfigurator || userIsAdministrator){
			menuAction = new MenuAction(getServiceClassConfigPanelUrl(node.serviceClasses), parent.name);
			contents[CONFIG_SERVICE_CLASS] = menuAction;
		}
						
		var menu = new Menu(contents, name, "ROOT", level);
		return menu;
	};
}	

function APPEDChartMenuCreator(id, level, cnode){
	this.level = level;
	this.id = id;
	//this.node = cnode;
	
	this.create = function(){
		if (menuIndex[id]) return;
		
		var name = "APPEDChartMenu";
		var contents = new Object();
		var edName;
		var menuAction;
		
		if (node.name >= EDITION_BASE) //if it's base, use the app name w/o edition or base suffix
			edName = cnode.appEdNameWOEdition;
		else
			edName = cnode.name;
			
		//menuAction = new MenuAction(chartCollectionUrl + '?new=true&scope=sc&name='+ node.name+ '&metric=rt&type=line&yaxis2=none&filter=none', GRAPH_FRAME);

        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=app&name=" + edName + "&subdomain=modInst&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        contents[J2EE_MODULES] = menuAction;

        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=app&name=" + edName + "&subdomain=sc&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        contents[SERVICECLASSES] = menuAction;

        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=app&name=" + edName + "&subdomain=tc&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
       contents[TRANSACTIONCLASSES] = menuAction;

        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=app&name=" + edName + "&subdomain=dc&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
       	contents[DYNAMICCLUSTERS] = menuAction;

        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=app&name=" + edName + "&subdomain=none&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        contents[CHART_LINK_NONE] = menuAction;
		
		var menu = new Menu(contents, name, id, level);
		return menu;
	};
}


//id: the id of one of the serverInstance in the topology tree (stored in nodeIndex).  This ID is reused as the ID of the corresponding menu.
function J2EEModuleMenuCreator(id, level){
	this.level = level;
	this.id = id;
	
	this.create = function(){
		if (menuIndex[id]) return;
		var node = nodeIndex[id];
		if (!node) return;
		
		var name = "J2EEModuleMenu";
		var contents = new Object();
		
		var menuAction;
        var subChartMOD = id + "_MODCHARTS";

        // sub menus for different chart types
        var menuCreatorMOD = new MODChartMenuCreator(subChartMOD, level+1, node);
        var subMenuMOD = new SubMenu(menuCreatorMOD, subChartMOD);
        contents[CHART_LINK] = subMenuMOD;

		if (node.appEdEdition == null) //if it's base, use the app name w/o base suffix
			menuAction = new MenuAction(getAppConfigPanelUrl(node.appEdNameWOEdition), parent.name);
		else
			menuAction = new MenuAction(getAppConfigPanelUrl(node.appEdNameWOEdition + '-edition' + node.appEdEdition), parent.name);
		
		contents[GO_TO_CONFIG_PANEL] = menuAction;
		
		if (userIsConfigurator || userIsAdministrator){
			menuAction = new MenuAction(getServiceClassConfigPanelUrl(node.serviceClasses), parent.name);
			contents[CONFIG_SERVICE_CLASS] = menuAction;
		}
						
		var menu = new Menu(contents, name, "ROOT", level);
		return menu;
	};
}

function MODChartMenuCreator(id, level, cnode){
	this.level = level;
	this.id = id;
	//this.cName = cName;
	
	this.create = function(){
		if (menuIndex[id]) return;
		
		var name = "MODChartMenu";
		var contents = new Object();
		
		var menuAction;
		
		if (cnode.appEdEdition == null)  //if it's base, use the app name w/o base suffix
		{
			// (old way) menuAction = new MenuAction(chartCollectionUrl + '?new=true&scope=mod&name=' + node.appName + ':' + node.name+ '&metric=rt&type=line&yaxis2=none&filter=none', GRAPH_FRAME);
			menuAction = new MenuAction(chartCollectionUrl + '?new=true&scope=mod&name=' + cnode.appEdNameWOEdition + ':' + cnode.name+ '&subdomain=sc&metric=rt&type=line&yaxis2=none&filter=none', GRAPH_FRAME);
        	contents[SERVICECLASSES] = menuAction;
			menuAction = new MenuAction(chartCollectionUrl + '?new=true&scope=mod&name=' + cnode.appEdNameWOEdition + ':' + cnode.name+ '&subdomain=tc&metric=rt&type=line&yaxis2=none&filter=none', GRAPH_FRAME);
    	    contents[TRANSACTIONCLASSES] = menuAction;
			menuAction = new MenuAction(chartCollectionUrl + '?new=true&scope=mod&name=' + cnode.appEdNameWOEdition + ':' + cnode.name+ '&subdomain=none&metric=rt&type=line&yaxis2=none&filter=none', GRAPH_FRAME);
	        contents[CHART_LINK_NONE] = menuAction;
	    }
	    else
	    {
	    	// (old way) menuAction = new MenuAction(chartCollectionUrl + '?new=true&scope=mod&name=' + node.appEdNameWOEdition + '-edition' + node.appEdEdition + ':' + node.name+ '&metric=rt&type=line&yaxis2=none&filter=none', GRAPH_FRAME);
			menuAction = new MenuAction(chartCollectionUrl + '?new=true&scope=mod&name=' + cnode.appEdNameWOEdition + '-edition' + cnode.appEdEdition + ':' + cnode.name+ '&subdomain=sc&metric=rt&type=line&yaxis2=none&filter=none', GRAPH_FRAME);
        	contents[SERVICECLASSES] = menuAction;
			menuAction = new MenuAction(chartCollectionUrl + '?new=true&scope=mod&name=' + cnode.appEdNameWOEdition + '-edition' + cnode.appEdEdition + ':' + cnode.name+ '&subdomain=tc&metric=rt&type=line&yaxis2=none&filter=none', GRAPH_FRAME);
    	    contents[TRANSACTIONCLASSES] = menuAction;
			menuAction = new MenuAction(chartCollectionUrl + '?new=true&scope=mod&name=' + cnode.appEdNameWOEdition + '-edition' + cnode.appEdEdition + ':' + cnode.name+ '&subdomain=none&metric=rt&type=line&yaxis2=none&filter=none', GRAPH_FRAME);
	        contents[CHART_LINK_NONE] = menuAction;
	    }
	   		
		var menu = new Menu(contents, name, id, level);
		return menu;
	};
}


//id: the id of one of the serverInstance in the topology tree (stored in nodeIndex).  This ID is reused as the ID of the corresponding menu.
function TransClassMenuCreator(id, level){
	this.level = level;
	this.id = id;
	
	this.create = function(){
		if (menuIndex[id]) return;
		var node = nodeIndex[id];
		if (!node) return;
		
		var name = "TransClassMenu";
		var contents = new Object();
		
		var menuAction;
        var subChartMOD = id + "_TRANCLASSCHARTS";

        // sub menus for different chart types
        var menuCreatorMOD = new TRANCLASSChartMenuCreator(subChartMOD, level+1, node);
        var subMenuMOD = new SubMenu(menuCreatorMOD, subChartMOD);
        contents[CHART_LINK] = subMenuMOD;
		

		if (userIsConfigurator || userIsAdministrator){
			menuAction = new MenuAction(getServiceClassConfigPanelUrl(node.serviceClass), parent.name);
			contents[CONFIG_SERVICE_CLASS] = menuAction;
		}		
			
		var menu = new Menu(contents, name, "ROOT", level);
		return menu;
	};
}	

function TRANCLASSChartMenuCreator(id, level, cnode){
	this.level = level;
	this.id = id;
	//this.node = cnode;
	
	this.create = function(){
		if (menuIndex[id]) return;
		
		var name = "TRANSCLASSChartMenu";
		var contents = new Object();
		
		var menuAction;
		
		//menuAction = new MenuAction(chartCollectionUrl + '?new=true&scope=tc&name='+ node.name+ '&metric=rt&type=line&yaxis2=none&filter=none', GRAPH_FRAME);

        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=tc&name=" + cnode.name + "&subdomain=dc&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        contents[DYNAMICCLUSTERS] = menuAction;

        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=tc&name=" + cnode.name + "&subdomain=srv&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        contents[APPSERVERS] = menuAction;

        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=tc&name=" + cnode.name + "&subdomain=mod&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
       contents[J2EE_MODULES] = menuAction;

        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=tc&name=" + cnode.name + "&subdomain=none&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        contents[CHART_LINK_NONE] = menuAction;

		
		var menu = new Menu(contents, name, id, level);
		return menu;
	};
}


//id: the id of one of the serverInstance in the topology tree (stored in nodeIndex).  This ID is reused as the ID of the corresponding menu.
function ServiceClassMenuCreator(id, level){
	this.level = level;
	this.id = id;
	
	this.create = function(){
		if (menuIndex[id]) return;
		var node = nodeIndex[id];
		if (!node) return;
		
		var name = "ServiceClassMenu";
		var contents = new Object();
		
		var menuAction;
        var subChartMOD = id + "_SRVCLASSCHARTS";

        // sub menus for different chart types
        var menuCreatorMOD = new SRVCLASSChartMenuCreator(subChartMOD, level+1, node);
        var subMenuMOD = new SubMenu(menuCreatorMOD, subChartMOD);
        contents[CHART_LINK] = subMenuMOD;
			
		menuAction = new MenuAction(getServiceClassConfigPanelUrl(node.name), parent.name);
		contents[GO_TO_CONFIG_PANEL] = menuAction;
				
		var menu = new Menu(contents, name, "ROOT", level);
		return menu;
	};
}	

function SRVCLASSChartMenuCreator(id, level, cnode){
	this.level = level;
	this.id = id;
	//this.node = cnode;
	
	this.create = function(){
		if (menuIndex[id]) return;
		
		var name = "SRVCLASSChartMenu";
		var contents = new Object();
		
		var menuAction;
		
		//menuAction = new MenuAction(chartCollectionUrl + '?new=true&scope=sc&name='+ node.name+ '&metric=rt&type=line&yaxis2=none&filter=none', GRAPH_FRAME);

        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=sc&name=" + cnode.name + "&subdomain=dc&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        contents[DYNAMICCLUSTERS] = menuAction;

        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=sc&name=" + cnode.name + "&subdomain=srv&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        contents[APPSERVERS] = menuAction;

        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=sc&name=" + cnode.name + "&subdomain=tc&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
       contents[TRANSACTIONCLASSES] = menuAction;

         menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=sc&name=" + cnode.name + "&subdomain=mod&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
       	contents[J2EE_MODULES] = menuAction;

        menuAction = new MenuAction(chartCollectionUrl + "?new=true&scope=sc&name=" + cnode.name + "&subdomain=none&metric=rt&type=line&yaxis2=none&filter=none", GRAPH_FRAME);
        contents[CHART_LINK_NONE] = menuAction;
		
		var menu = new Menu(contents, name, id, level);
		return menu;
	};
}


function getSetMaintModeUrl(nodeName){
	return getBackgroundUrl(topologyActionUrl + "?rn=" + getRandomNum() + "&action=maintMode&setTo=on&leaveProcess=false&nodeName=" + nodeName);	
}
function getSetMaintModeLeaveProcessUrl(nodeName){
	return getBackgroundUrl(topologyActionUrl + "?rn=" + getRandomNum() + "&action=maintMode&setTo=on&leaveProcess=true&nodeName=" + nodeName);	
}
function getUnSetMaintModeUrl(nodeName){
	return getBackgroundUrl(topologyActionUrl + "?rn=" + getRandomNum() + "&action=maintMode&setTo=off&nodeName=" + nodeName);	
}
function getEnablePlacementUrl(nodeGroupName){
	return getBackgroundUrl(topologyActionUrl + "?rn=" + getRandomNum() + "&action=placement&setTo=on&nodeGroupName=" + nodeGroupName);
}
function getDisablePlacementUrl(nodeGroupName){
	return getBackgroundUrl(topologyActionUrl + "?rn=" + getRandomNum() + "&action=placement&setTo=off&nodeGroupName=" + nodeGroupName);	
}	
function getChangeOperationModeUrl(dcName, ngName, newOpMode){
	return getBackgroundUrl(topologyActionUrl + "?rn=" + getRandomNum() + "&action=operationMode&setTo="+newOpMode+"&dcName="+dcName+"&ngName="+ngName);	
}
function getStopServerInstanceUrl(serverInstanceName, nodeName){
	return getBackgroundUrl(topologyActionUrl + "?rn=" + getRandomNum() + "&action=serverMgmt&op=stop&siName=" + serverInstanceName + "&nodeName=" + nodeName);	
}
function getSmartStopServerInstanceUrl(serverInstanceName, nodeName){
	return getBackgroundUrl(topologyActionUrl + "?rn=" + getRandomNum() + "&action=serverMgmt&op=smartStop&siName=" + serverInstanceName + "&nodeName=" + nodeName);	
}


//config URLs
function getServerLogsUrl(nodeName, instanceName){
	return topologyActionUrl + "?rn=" + getRandomNum() + "&action=config&targ=sl&nodeName="+nodeName+"&instanceName="+instanceName;
}

function getRuntimeTasksUrl(){
	return navigationUrl + "?forwardName=taskmanagement.content.main";
}

function getConfigJ2EEModuleUrl(modName){
	return topologyActionUrl + "?rn=" + getRandomNum() + "&action=config&targ=j2eeMod&modName="+modName;	
}
function getNodeGroupConfigPanelUrl(nodeGroupName){
	return topologyActionUrl + "?rn=" + getRandomNum() + "&action=config&targ=nodegroup&ngName="+nodeGroupName;	
}
function getNodeConfigPanelUrl(nodeName){
	return topologyActionUrl + "?rn=" + getRandomNum() + "&action=config&targ=node&nodeName="+nodeName;
}
function getServerInstanceConfigPanelUrl(serverInstanceName, nodeName, servertype){
	return topologyActionUrl + "?rn=" + getRandomNum() + "&action=config&targ=si&nodeName="+nodeName+"&siname="+serverInstanceName;
}
function getSpecialtyServerConfigPanelUrl(specialtyServerName, nodeName, servertype){
	return topologyActionUrl + "?rn=" + getRandomNum() + "&action=config&targ=sp&nodeName="+nodeName+"&spname="+specialtyServerName+"&serverType="+servertype;
}
function getDCConfigPanelUrl(dcName, ngName){
	return topologyActionUrl + "?rn=" + getRandomNum() + "&action=config&targ=dc&ngName="+ngName+"&dcName="+dcName;
}
function getClusterConfigPanelUrl(clName){
	return topologyActionUrl + "?rn=" + getRandomNum() + "&action=config&targ=cl&clName="+clName;
}
function getAppConfigPanelUrl(appName){
	return topologyActionUrl + "?rn=" + getRandomNum() + "&action=config&targ=app&appName="+appName;
}
function getServiceClassConfigPanelUrl(scName){
       if (typeof(scName) == "undefined")
         scName = "";
	return topologyActionUrl + "?rn=" + getRandomNum() + "&action=config&targ=sc&scName="+scName;
}

function getRandomNum(){
	return Math.random();	
}

function getBackgroundUrl(url){
	return "javascript:executeBackgroundUrl('" + url + "');";		
}

var actionInterval = null;

function resetcursor(timeout){
	window.clearTimeout(actionInterval);
	var httpconn = httpConnectors.backgroundUrl;
		
	if (timeout=="TIMEOUT"){
		 displayMessage(OPERATION_TIMED_OUT);		
		 document.body.style.cursor="default";
		 document.getElementById("progress").style.display = "none";	
		 actionInterval = null;	
	} else if (httpconn.readyState == 4){
		 var xmlDoc = httpconn.responseXML;
		 var msg = OPERATION_FAILED;
		 var elem = xmlDoc.documentElement;
		 if (elem){
			 var retCode = elem.getAttribute("returnCode");
		 	 displayMessage(retCode);
		 }
		 document.body.style.cursor="default";
		 document.getElementById("progress").style.display = "none";	
		 actionInterval = null;
	}
}

function displayMessage(retCode){
	var innerHtml;
	if( retCode == "SUCCESS"){
		innerHtml = '<span class="validation-warn-info"><img alt="'+INFORMATION+'" align="baseline" height="16" width="16" src="/ibm/console/images/Information.gif"/>' + OPERATION_SUCCEEDED + '</span>';
	} else if (retCode == "INSUFFICIENT_RIGHTS"){
		innerHtml = '<span class="validation-warn-info"><img alt="'+WARNING+'" align="baseline" height="16" width="16" src="/ibm/console/images/Warning.gif"/>' + USER_HAS_INSUFFICIENT_RIGHTS  + '</span>';
	} else if (retCode == "MAINT_MODE_PROC_FAILED"){
		innerHtml = '<span class="validation-warn-info"><img alt="'+WARNING+'" align="baseline" height="16" width="16" src="/ibm/console/images/Warning.gif"/>' + OPERATION_MAINT_MODE_PROC_FAILED  + '</span>';
	} else if (retCode == "INVALID_REFRESH") {
		//innerHtml = '<span class="validation-warn-info"><img alt="'+WARNING+'" align="baseline" height="16" width="16" src="/ibm/console/images/Warning.gif"/>' + INVALID_REFRESH_RATE  + '</span>';
		innerHtml = '<span class="validation-warn-info"><img alt="'+WARNING+'" align="baseline" height="16" width="16" src="/ibm/console/images/Warning.gif"/>' + "Invalid refresh rate provided, please try again" + '</span>';
	} else if (retCode == OPERATION_TIMED_OUT){
		innerHtml = '<span class="validation-warn-info"><img alt="'+ERROR+'" align="baseline" height="16" width="16" src="/ibm/console/images/Error.gif"/>' + OPERATION_TIMED_OUT  + '</span>';
   } else if (retCode == OPERATION_IN_PROGRESS){
		innerHtml = '<span class="validation-warn-info"><img alt="'+ERROR+'" align="baseline" height="16" width="16" src="/ibm/console/images/Error.gif"/>' + OPERATION_IN_PROGRESS  + '</span>';
   } else {
		innerHtml = '<span class="validation-error"><img alt="'+ERROR+'" align="baseline" height="16" width="16" src="/ibm/console/images/Error.gif"/>' + OPERATION_FAILED + '</SPAN>';
	}
	var msgBox = document.getElementById("TOPOLOGY_MESSAGE_BOX");
	msgBox.innerHTML = innerHtml
	var msgBoxMain = document.getElementById("TOPOLOGY_MESSAGE_BOX_MAIN");
	msgBoxMain.style.display="block";	
}			
			
function hideMessageBox(){
	var msgBox = document.getElementById("TOPOLOGY_MESSAGE_BOX_MAIN");
	msgBox.style.display="none";		
}

function executeBackgroundUrl(url){
	if (actionInterval != null){
		displayMessage(OPERATION_IN_PROGRESS);
		return;
	}
	
	var httpconn = getHTTPConnector('backgroundUrl', resetcursor);	
	if(httpconn)
	{
		try
		{
			document.body.style.cursor="wait";
			var prog = document.getElementById("progress");
			//menuClickY and menuClickX are global vars set in popupMenus.js whenever a menu is clicked.
			prog.style.top = menuClickY;
         prog.style.left = menuClickX;
         prog.style.display = 'block';
         httpconn.open('GET', url, true); //false means "synchronous"
         actionInterval = window.setTimeout("resetcursor('TIMEOUT');", ACTION_TIME_OUT);
			httpconn.send(null);			
		}
		catch(e)
		{
		   alert('exception: ' + e.message);
		}
	}
}

