// IBM Confidential OCO Source Material
// 5724-J34 (C) COPYRIGHT International Business Machines Corp. 2004, 2005
// The source code for this program is not published or otherwise divested
// of its trade secrets, irrespective of what has been deposited with the
// U.S. Copyright Office.

var ELEMENT_NODEGROUP = "NodeGroup";
var ELEMENT_ROOTNAME = "RootName";
var ELEMENT_NODE = "Node";
var ELEMENT_EXTERNAL_NODE = "ExternalNode";
var ELEMENT_DYNAMICCLUSTER = "DynamicCluster";
var ELEMENT_DYNAMICCLUSTERINSTANCE = "DCInstance";
var ELEMENT_DEPLOYMENTTARGET = "DeploymentTarget";
var ELEMENT_J2EEMODULE = "J2EEModule";
var ELEMENT_DELETE = "Delete";
var ELEMENT_ADD = "Add";
var ELEMENT_CHANGE = "Change";
var ELEMENT_DEPLOYMENTTARGETINSTANCE = "DeploymentTargetInstance";
var ELEMENT_BLANK = "Blank";
var ELEMENT_CELL = "Cell";
var ELEMENT_SERVER = "Server";
var ELEMENT_CLUSTER = "Cluster";
var ELEMENT_APPLICATION = "Application";
var ELEMENT_APPLICATION_EDITION = "ApplicationEdition";
var ELEMENT_SERVICECLASS = "ServiceClass";
var ELEMENT_TRANSACTIONCLASS = "TransactionClass";
var ELEMENT_PROXY = "Proxy";
var ELEMENT_SPECIALTYSERVER = "SpecialtyServer";
var ELEMENT_SPECIALTYSERVERINSTANCE = "SpecialtyServerInstance";
var ELEMENT_APPSERVER = "AppServer";
var ELEMENT_JMSSERVER = "JMSServer";
var ELEMENT_WEBSERVER = "WebServer";
var ELEMENT_GENERICSERVER = "GenericServer";
var ELEMENT_PROXYSERVER = "ProxyServer";
var ELEMENT_ODRSERVER = "ODRServer";
var ELEMENT_DBSERVER = "DBServer";
var MODULES = "Modules";

var ATTR_APPLICATIONNAME = "appName";
var ATTR_NAME = "name";
var ATTR_WEIGHT = "weight";
var ATTR_CONCURRENTREQUESTS = "concurrentRequests";
var ATTR_STATE = "state";
var ATTR_TYPE = "type";
var ATTR_ID = "id";
var ATTR_OP_CODE = "opCode";
var ATTR_CPU_USAGE = "cpuUsage";
var ATTR_MAINTMODE = "maintMode";
var ATTR_DTTYPE = "deploymentTargetType";
var ATTR_PID = "pid";
var ATTR_CELLNAME = "cellName";
var ATTR_NODENAME = "nodeName";
var ATTR_NODEGROUPNAME = "nodeGroupName";
var ATTR_DEPTARGETNAME = "depTargetName";
var ATTR_DEPTARGETINSTANCENAME = "depTargetInstanceName";
var ATTR_TRANSACTIONCLASSES = "transactionClasses";
var ATTR_SERVICECLASSES = "serviceClasses";
var ATTR_SERVICECLASS = "serviceClass";
var ATTR_IMPORTANCE = "importance";
var ATTR_GOALVALUE = "goalValue";
var ATTR_GOALTYPE = "goalType";
var ATTR_GOALPCT = "goalPct";
var ATTR_HASPLACEMENT = "hasPlacement";
var ATTR_HASBALANCER = "hasBalancer";
var ATTR_HASSCHEDULER = "hasScheduler";
var ATTR_HASWSMM = "hasWsmm";
var ATTR_HASHMM = "hasHMM";
var ATTR_PLACEMENTCONTROLLER = "placementController";
var ATTR_PURPOSE = "purpose";
var ATTR_VERSION = "version";
var ATTR_DWLMCONTROLLERS = "dwlmDcs";
var ATTR_SSTYPE = "specialtyServerType";
var ATTR_SSSUBTYPE = "specialtyServerSubType";
var ATTR_PORT = "port";
var ATTR_WSTYPE = "wstype";
var ATTR_QUEUENAMES = "queueNames";	
var ATTR_SICK_HEALTH = "isSick";
var ATTR_AUTOMATED_CONDITION = "hasAutomatedCondition";
var ATTR_SUPERVISED_CONDITION = "hasSupervisedCondition";
var ATTR_MAX_SEVERITY_CONDITION = "maxSeverityCondition";
var ATTR_CONDITION_DETAIL = "conditionDetail";
var ATTR_HASARFM = "hasARFM";
var ATTR_HASWP   = "hasWP";
var ATTR_WPMANAGEDCELL = "wpManagedCell";
var ATTR_NODESTATE = "nodeState";
var ATTR_ISAPPLRA = "isAppLRA";
var ATTR_GRID_JOBS = "gridJobs";
var ATTR_APPED_EDITION = "appEdEdition";
var ATTR_APPED_STATE = "appEdState";
var ATTR_APPED_NAME_WO_EDITION = "appEdNameWOEdition";
var ATTR_APPED_DTINSTANCES = "appEdDTInstances";
var ATTR_IS_DB_NODE = "isDBNode";
var DBSERVER_TYPE_DB2 = "DB2";
var DBSERVER_TYPE_ORACLE = "Oracle";

var EDITION_BASE = "Base";

var TYPE_LABEL = "label";

var STATE_STOPPED="stopped";
var STATE_STARTING="starting";
var STATE_STOPPING="stopping";
var STATE_RUNNING="running";
	
//PURPOSES (Try to keep these short because they will be used in string comparisons
var PURPOSE_NODEGROUP_CENTRIC = "ngc";
var PURPOSE_APPLICATION_CENTRIC = "ac";	
var PURPOSE_OPPOLICY_CENTRIC = "oc";
var PURPOSE_INIT = "init";
var DEFAULT_PURPOSE = PURPOSE_NODEGROUP_CENTRIC;

var MAINTENANCE_MODE_ON = "on";
var PLACEMENT_CONTROLLER_ON = "on";

//SICK Server stuff
var SICK_SERVER = "SICK";
var HEALTHY_SERVER = "HEALTHY";
var TRUE_IND = "TRUE";
var FALSE_IND = "FALSE";
var SICK_SEVERITY_FATAL       = "70";
var SICK_SEVERITY_CRITICAL    = "60";
var SICK_SEVERITY_SEVERE      = "50";
var SICK_SEVERITY_MINOR       = "40";
var SICK_SEVERITY_WARNING     = "30";
var SICK_SEVERITY_HARMLESS    = "20";
var SICK_SEVERITY_INFORMATION = "10"; 

var SICK_CONDITION_AGE = 1;
var SICK_CONDITION_WORKLOAD = 2;
var SICK_CONDITION_RESPONSETIME = 3;
var SICK_CONDITION_MEMORY = 4;

var SICK_REACTION_MODE_DETECT_ONLY = 1;
var SICK_REACTION_MODE_SUPERVISED = 2;
var SICK_REACTION_MODE_AUTOMATIC = 3;

var NODE_STATE_GRID = "grid";
var NODE_STATE_WEB = "web"; //j2ee normal mode
var NODE_STATE_TRANSITION_TO_WEB = "trans_to_web";
var NODE_STATE_TRANSITION_TO_GRID = "trans_to_grid";

var MOUSE_BUTTON_RIGHT = 2;

var OPCODE_MANUAL = 1;
var OPCODE_SUPERVISED = 2;
var OPCODE_ON_DEMAND = 3;

var ACTION_TIME_OUT = 1000 * 60; //one minute

var GRAPH_FRAME = "graphFrame";
var BLANK_ICON = "";
var BLANK_INNER_HTML = "";
var LINK_THAT_DOES_NOTHING = ""; //"javascript:function(){return false;}";
var UNASSIGNED_NODEGROUP = "Unassigned";

var CPU_USAGE_UNKNOWN = "na";
var CPU_USAGE_ERROR = "cpuError";


	
//icons
var cellIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/cell.gif";
var nodegroupIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/node_groups.gif";
var proxyserverIcon = "/ibm/console/images/ApplicationServer.gif";
var webserverIcon = "/ibm/console/images/ApplicationServer.gif";
var genericserverIcon = "/ibm/console/images/ApplicationServer.gif";
var jmsserverIcon = "/ibm/console/images/ApplicationServer.gif";
var dynamicClusterIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/dcIcon.gif";
var serverIcon = "/ibm/console/images/ApplicationServer.gif";
var clusterIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/clusterIcon.gif";
var j2eeModuleIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/rmIcon.gif";
var nodeIcon = "/ibm/console/images/Node.gif";
var maintModeIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/maintModeIcon.gif";
var gridApplicationIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/gridApplication.gif";
var gridNodeIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/gridNode.gif";
var gridNodeMaintIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/gridNode_maint.gif";
var gridNodeTransitionIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/j2ee_to_grid.gif";
var gridNodeTransitionMaintIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/j2ee_to_grid_maint.gif";
var webNodeTransitionIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/grid_to_j2ee.gif";
var webNodeTransitionMaintIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/grid_to_j2ee_maint.gif";
var arfmIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/arfmController.gif";
var workProfilerIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/workProfiler.gif";
var balancerIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/balancer.gif";
var schedulerIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/scheduler.gif";
var dbServerIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/dbServerIcon.gif";
var dbServerRunningIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/dbServerRunningIcon.gif";
var dbServerStoppedIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/dbServerStoppedIcon.gif";

var activeAppEditionStateIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/active.gif";
var activationAppEditionStateIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/activating.gif";
var inactiveAppEditionStateIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/inactive.gif";
var deactivationAppEditionStateIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/deactivating.gif";
var validateAppEditionStateIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/validate.gif";
var validationAppEditionStateIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/validating.gif";

// Partial URI's for sick server icons 
// .... can be appended with suffix uri's below for action required type
var sickFatalIconPartialURI = "/ibm/console/com.ibm.ws.console.xdruntime/images/fatal";
var sickCriticalIconPartialURI = "/ibm/console/com.ibm.ws.console.xdruntime/images/critical";
var sickSevereIconPartialURI = "/ibm/console/com.ibm.ws.console.xdruntime/images/severe";
var sickMinorIconPartialURI = "/ibm/console/com.ibm.ws.console.xdruntime/images/least-severe";
var sickWarningIconPartialURI = "/ibm/console/com.ibm.ws.console.xdruntime/images/warning";
var sickHarmlessIconPartialURI = "/ibm/console/com.ibm.ws.console.xdruntime/images/harmless";
var sickInformationIconPartialURI = "/ibm/console/com.ibm.ws.console.xdruntime/images/information";
var sickAutoURISuffix = "-auto.gif";
var sickManualURISuffix = "-manual.gif";
var sickSupervisedURISuffix = "-sup.gif";

var scIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/service_class.gif";
var tcIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/transaction_class.gif";
var appIcon = "/ibm/console/images/Application.gif";
var proxyIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/ondemand_router.gif";
var dwlmIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/dwlmController.gif";
var wsmmIcon = "/ibm/console/images/file.gif";
var hmmIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/healthIcon.gif";
var placementIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/placement_contrl.gif";
var BLANK_EXPANDER_ICON = "/ibm/console/com.ibm.ws.console.xdruntime/images/blank_expander.gif";
