<%-- IBM Confidential OCO Source Material --%>
<%-- 5724-J34 (C) COPYRIGHT International Business Machines Corp. 2004, 2005 --%>
<%-- The source code for this program is not published or otherwise divested --%>
<%-- of its trade secrets, irrespective of what has been deposited with the --%>
<%-- U.S. Copyright Office. --%>

<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/tiles.tld" prefix="tiles" %>
<%@ taglib uri="/WEB-INF/ibmcommon.tld" prefix="ibmcommon" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ page import="java.util.List,java.util.Iterator"%>

<tiles:useAttribute name="rootImage" classname="java.lang.String" />
<tiles:useAttribute name="rootName" classname="java.lang.String" />
<tiles:useAttribute name="graphFrameName" classname="java.lang.String"/>
<tiles:useAttribute name="graphJSP" classname="java.lang.String"/>

<ibmcommon:detectLocale/>

<html:html locale="true">
<head>

<jsp:include page = "/secure/layouts/browser_detection.jsp" flush="true"/>

<style>
.percentbar{margin-left:10px;}
.provisioningSpan{color:green;}
.deprovisioningSpan{color:red;}
</style>

<script type="text/javascript" language="JavaScript" src="<%=request.getContextPath()%>/com.ibm.ws.console.xdruntime/popupMenus.js"></script>
<script type="text/javascript" language="JavaScript" src="<%=request.getContextPath()%>/com.ibm.ws.console.xdruntime/topologyConstants.js"></script>
<script type="text/javascript" language="JavaScript" src="<%=request.getContextPath()%>/com.ibm.ws.console.xdruntime/xdruntime.js"></script>
<script type="text/javascript" language="JavaScript" src="<%=request.getContextPath()%>/com.ibm.ws.console.xdruntime/aptree.js"></script>
<script type="text/javascript" language="JavaScript" src="<%=request.getContextPath()%>/com.ibm.ws.console.xdruntime/runtimeTopologyMethods.js"></script>
<script type="text/javascript" language="JavaScript" src="<%=request.getContextPath()%>/com.ibm.ws.console.xdruntime/runtimeTopology.js"></script>
<script type="text/javascript" language="JavaScript" src="<%=request.getContextPath()%>/scripts/menu_functions.js"></script>

<% 
String cellName = ((com.ibm.ws.sm.workspace.RepositoryContext)session.getAttribute(com.ibm.ws.console.core.Constants.CURRENTCELLCTXT_KEY)).getName();
String cacheRefreshURL = response.encodeURL("/ibm/console/TopologyAction?action=cacheRefresh");

String userIsConfigurator = "true";
String userIsOperator = "true";
String userIsMonitor = "true";
String userIsAdministrator = "true";

org.apache.struts.util.MessageResources resources = (org.apache.struts.util.MessageResources)application.getAttribute(org.apache.struts.action.Action.MESSAGES_KEY);

if (com.ibm.ws.security.core.SecurityContext.isSecurityEnabled()){
	userIsConfigurator = (request.isUserInRole("configurator")) ? "true" : "false";
	userIsOperator = (request.isUserInRole("operator")) ? "true" : "false";
	userIsMonitor = (request.isUserInRole("monitor")) ? "true" : "false";
	userIsAdministrator = (request.isUserInRole("administrator")) ? "true" : "false";
}
%>
<%!
String escape(String str){
	if (str == null)
		return str;
	return str.replaceAll("'", "\\\\'");
}

String getString(String key, org.apache.struts.util.MessageResources msgs, HttpServletRequest request){
	String str = msgs.getMessage(request.getLocale(), key);
	return escape(str);
}
%>
<script>
var requestScope = '<%=(String)request.getSession().getAttribute("scope")%>';
var requestName = '<%=(String)request.getSession().getAttribute("name")%>';
var requestMetric = '<%=(String)request.getSession().getAttribute("metric")%>';
var requestSet = '<%=(String)request.getSession().getAttribute("set")%>';

var userIsConfigurator = <%=userIsConfigurator%>;
var userIsOperator = <%=userIsOperator%>;
var userIsMonitor = <%=userIsMonitor%>;
var userIsAdministrator = <%=userIsAdministrator%>;

var dataRequestUrl = '<%=response.encodeURL("/ibm/console/XDRuntimeData")%>'; 
var displayNodeGroupUrl = '<%= response.encodeURL("/ibm/console/runtimeTopology.do")%>';
var chartCollectionUrl = '<%=response.encodeURL("/ibm/console/ChartsCollection.do")%>';
var topologyActionUrl = '<%=response.encodeURL("/ibm/console/TopologyAction")%>';
var navigationUrl = '<%=response.encodeURL("/ibm/console/navigatorCmd.do")%>';

var CELLNAME = '<%=cellName%>';
var NODES = '<%=getString("nodes", resources, request)%>';
var EXTERNAL_NODES = '<%=getString("unmanaged.nodes", resources, request)%>';
var NODEGROUP = '<%=getString("nodegroup", resources, request)%>';
var APPLICATION = '<%=getString("application", resources, request)%>';
var ERROR = '<%=getString("error.msg.error", resources, request)%>';
var INFORMATION = '<%=getString("error.msg.information", resources, request)%>';
var WARNING = '<%=getString("error.msg.warning", resources, request)%>';
var CLUSTERS = '<%=getString("clusters", resources, request)%>';
var DYNAMICCLUSTERS = '<%=getString("dynamic.clusters", resources, request)%>';
var SERVERS = '<%=getString("servers", resources, request)%>';
var APPSERVERS = '<%=getString("app.servers", resources, request)%>';
var WEBSERVERS = '<%=getString("web.servers", resources, request)%>';
var JMSSERVERS = '<%=getString("jms.servers", resources, request)%>';
var GENERICSERVERS = '<%=getString("generic.servers", resources, request)%>';
var PROXYSERVERS = '<%=getString("proxy.servers", resources, request)%>';
var ODRSERVERS = '<%=getString("odr.servers", resources, request)%>';
var DBSERVERS = '<%=getString("db.servers", resources, request)%>';
var NODEGROUPS = '<%=getString("treeList.nodegroups", resources, request)%>';
var APPLICATIONS = '<%=getString("applications", resources, request)%>';

var OPPOLICY = '<%=getString("op.policy", resources, request)%>';
var PID = '<%=getString("pid", resources, request)%>';
var PORT = '<%=getString("port", resources, request)%>';
var SSTYPE = '<%=getString("sstype", resources, request)%>';
var QUEUES = '<%=getString("queues", resources, request)%>';
var STARTING = '<%=getString("starting", resources, request)%>';
var STOPPING = '<%=getString("stopping", resources, request)%>';
var RUNNING_INSTANCES = '<%=getString("running.instances", resources, request)%>';
var DWLM_WEIGHT = '<%=getString("dwlm.weight", resources, request)%>';
var NODE = '<%=getString("node", resources, request)%>';
var STOPPING_SERVER_INSTANCE = '<%=getString("stopping.server.instance", resources, request)%>';
var STARTING_SERVER_INSTANCE = '<%=getString("starting.server.instance", resources, request)%>';
var TARGET_MAPPINGS = '<%=getString("target.mappings", resources, request)%>';
var DEPLOYMENT_TARGETS = '<%=getString("deployment.targets", resources, request)%>';
var SPECIALTY_SERVERS = '<%=getString("specialty.servers", resources, request)%>';
var RUNNING_MODULES = '<%=getString("running.modules", resources, request)%>';
var J2EE_MODULES = '<%=getString("j2ee.modules", resources, request)%>';
var GOAL_TYPE = '<%=getString("goal.type", resources, request)%>';
var GOAL_TYPE_AVG_RESPONSE_TIME = '<%=getString("GOAL_TYPE_AVG_RESPONSE_TIME", resources, request)%>';
var GOAL_TYPE_PCT_RESPONSE_TIME = '<%=getString("GOAL_TYPE_PCT_RESPONSE_TIME", resources, request)%>';
var GOAL_TYPE_DISCRETIONARY = '<%=getString("GOAL_TYPE_DISCRETIONARY", resources, request)%>';
var GOAL_TYPE_QUEUETIME = '<%=getString("GOAL_TYPE_QUEUETIME", resources, request)%>';
var GOAL_PCT = '<%=getString("goal.pct", resources, request)%>';
var GOAL_VALUE = '<%=getString("goal.value", resources, request)%>';
var IMPORTANCE = '<%=getString("importance", resources, request)%>';
var IMPORTANCE_HIGHEST = '<%=getString("IMPORTANCE_HIGHEST", resources, request)%>';
var IMPORTANCE_LOWEST = '<%=getString("IMPORTANCE_LOWEST", resources, request)%>';
var IMPORTANCE_MEDIUM = '<%=getString("IMPORTANCE_MEDIUM", resources, request)%>';
var IMPORTANCE_HIGHER = '<%=getString("IMPORTANCE_HIGHER", resources, request)%>';
var IMPORTANCE_HIGH = '<%=getString("IMPORTANCE_HIGH", resources, request)%>';
var IMPORTANCE_LOW = '<%=getString("IMPORTANCE_LOW", resources, request)%>';
var IMPORTANCE_LOWER = '<%=getString("IMPORTANCE_LOWER", resources, request)%>';
var IMPORTANCE_NONE = '<%=getString("IMPORTANCE_NONE", resources, request)%>';
var PROXIES = '<%=getString("proxies", resources, request)%>';
var SET_OPERATION_MODE = '<%=getString("set.operation.mode", resources, request)%>';
var SET_MAINTENANCE_MODE = '<%=getString("set.maintenance.mode", resources, request)%>';
var UNSET_MAINTENANCE_MODE = '<%=getString("unset.maintenance.mode", resources, request)%>';
var ENABLE_PLACEMENT_CONTROLLER = '<%=getString("enable.placement.controller", resources, request)%>';
var DISABLE_PLACEMENT_CONTROLLER = '<%=getString("disable.placement.controller", resources, request)%>';
var STOP = '<%=getString("stop", resources, request)%>';
var SMART_STOP = '<%=getString("smart.stop", resources, request)%>';
var OPMODE_MANUAL = '<%=getString("opmode.manual", resources, request)%>';
var OPMODE_SUPERVISED = '<%=getString("opmode.supervised", resources, request)%>';
var OPMODE_ON_DEMAND = '<%=getString("opmode.ondemand", resources, request)%>';
var GO_TO_CONFIG_PANEL = '<%=getString("goto.config.panel", resources, request)%>';
var CHART_LINK = '<%=getString("chart.link", resources, request)%>';
var CHART_LINK_NONE = '<%=getString("chart.link.none", resources, request)%>';

var DEPLOYED_IN= '<%=getString("running.in", resources, request)%>';
var TRANSACTIONCLASSES = '<%=getString("transaction.classes", resources, request)%>';
var SERVICECLASSES = '<%=getString("service.classes", resources, request)%>';
var CONFIG_SERVICE_CLASSES = '<%=getString("config.serviceclasses", resources, request)%>';
var CONFIG_SERVICE_CLASS = '<%=getString("config.serviceclass", resources, request)%>';
var OPERATION_SUCCEEDED = '<%=getString("operation.succeeded", resources, request)%>';
var OPERATION_FAILED = '<%=getString("topologymenu.operation.failed", resources, request)%>';
var OPERATION_TIMED_OUT = '<%=getString("menuoperation.timed.out", resources, request)%>';
var OPERATION_IN_PROGRESS = '<%=getString("operation.inprogress", resources, request)%>';
var USER_HAS_INSUFFICIENT_RIGHTS = '<%=getString("user.has.insufficient.rights", resources, request)%>';
var OPERATION_MAINT_MODE_PROC_FAILED = '<%=getString("operation.maint.mode.proc.failed", resources, request)%>';
var DYNAMIC_CLUSTER = '<%=getString("dynamiccluster.icon.label", resources, request)%>';
var APC_ICON_LABEL = '<%=getString("apc.icon.label", resources, request)%>';
var HMM_ICON_LABEL = '<%=getString("hmm.icon.label", resources, request)%>';
var CPU_ICON_LABEL = '<%=getString("cpu.icon.label", resources, request)%>';
var CPU_UTILIZATION = '<%=getString("cpu.icon.label", resources, request)%>';
var TRANSCLASS_ICON_LABEL = '<%=getString("transclass.icon.label", resources, request)%>';
var SERVICECLASS_ICON_LABEL = '<%=getString("serviceclass.icon.label", resources, request)%>';
var NODEGROUP_ICON_LABEL = '<%=getString("nodegroup.icon.label", resources, request)%>';
var NODE_ICON_LABEL = '<%=getString("node.icon.label", resources, request)%>';
var EXTERNAL_NODE_ICON_LABEL = '<%=getString("unmanaged.nodes.icon.label", resources, request)%>';
var DB_NODE_ICON_LABEL = '<%=getString("dbnode.icon.label", resources, request)%>';
var DWLM_ICON_LABEL = '<%=getString("label.dwlm.controller", resources, request)%>';
var PROXY_ICON_LABEL = '<%=getString("proxy.icon.label", resources, request)%>';
var ODR_ICON_LABEL = '<%=getString("odr.icon.label", resources, request)%>';
var DBSERVER_ICON_LABEL = '<%=getString("dbserver.icon.label", resources, request)%>';
var DYNAMICCLUSTER_ICON_LABEL = '<%=getString("dynamiccluster.icon.label", resources, request)%>';
var CLUSTER_ICON_LABEL = '<%=getString("cluster.icon.label", resources, request)%>';
var SERVER_ICON_LABEL = '<%=getString("server.icon.label", resources, request)%>';
var WEBSERVER_ICON_LABEL = '<%=getString("webserver.icon.label", resources, request)%>';
var JMSSERVER_ICON_LABEL = '<%=getString("jmsserver.icon.label", resources, request)%>';
var GENERICSERVER_ICON_LABEL = '<%=getString("genericserver.icon.label", resources, request)%>';
var SERVERINSTANCE_ICON_LABEL = '<%=getString("serverinstance.icon.label", resources, request)%>';
var APPLICATION_ICON_LABEL = '<%=getString("application.icon.label", resources, request)%>';
var MAINTMODE_ICON_LABEL = '<%=getString("maintmode.icon.label", resources, request)%>';
var GRID_NODE_ICON_LABEL = '<%=getString("grid.node.icon.label", resources, request)%>';
var GRID_NODE_MAINT_ICON_LABEL = '<%=getString("grid.node.maint.icon.label", resources, request)%>';
var TRANS_TO_GRID_NODE_ICON_LABEL = '<%=getString("trans.to.grid.node.icon.label", resources, request)%>';
var TRANS_TO_GRID_NODE_MAINT_ICON_LABEL = '<%=getString("trans.to.grid.node.maint.icon.label", resources, request)%>';
var TRANS_TO_J2EE_NODE_ICON_LABEL = '<%=getString("trans.to.j2ee.node.icon.label", resources, request)%>';
var TRANS_TO_J2EE_NODE_MAINT_ICON_LABEL = '<%=getString("trans.to.j2ee.node.maint.icon.label", resources, request)%>';
var INSTANCESTATE_ICON_LABEL = '<%=getString("instancestate.icon.label", resources, request)%>';
var J2EEMODULE_ICON_LABEL = '<%=getString("j2eemodule.icon.label", resources, request)%>';
var SERVER='<%=getString("server.icon.label", resources, request)%>';
var SERVERLOGS = '<%=getString("show.server.logs", resources, request)%>';
var ALL_LABEL = '<%=getString("label.all", resources, request)%>';
var SICK_SERVER_SUPR_ICON_LABEL = '<%=getString("health.supervised.icon.label", resources, request)%>';
var SICK_SERVER_AUTO_ICON_LABEL = '<%=getString("health.automated.icon.label", resources, request)%>';
var SICK_SERVER_MAN_ICON_LABEL = '<%=getString("health.manual.icon.label", resources, request)%>';
var GRID_APPLICATION_ICON_LABEL = '<%=getString("grid.application.icon.label", resources, request)%>';
var ARFM_ICON_LABEL = '<%=getString("arfm.icon.label", resources, request)%>';
var BALANCER_ICON_LABEL = '<%=getString("balancer.icon.label", resources, request)%>';
var SCHEDULER_ICON_LABEL = '<%=getString("scheduler.icon.label", resources, request)%>';

var WP_ICON_LABEL = '<%=getString("wp.icon.label", resources, request)%>';
var WP_MANAGEDCELL_LABEL = '<%=getString("wp.managed.cell.icon.label", resources, request)%>';
var ACTIVE_APPEDITION_STATE_ICON_LABEL = '<%=getString("active.appedition.state.icon.label", resources, request)%>';
var ACTIVATION_APPEDITION_STATE_ICON_LABEL = '<%=getString("activation.appedition.state.icon.label", resources, request)%>';
var INACTIVE_APPEDITION_STATE_ICON_LABEL = '<%=getString("inactive.appedition.state.icon.label", resources, request)%>';
var DEACTIVATION_APPEDITION_STATE_ICON_LABEL = '<%=getString("deactivation.appedition.state.icon.label", resources, request)%>';
var VALIDATE_APPEDITION_STATE_ICON_LABEL = '<%=getString("validate.appedition.state.icon.label", resources, request)%>';
var VALIDATION_APPEDITION_STATE_ICON_LABEL = '<%=getString("validation.appedition.state.icon.label", resources, request)%>';

var SHOW_RUNTIME_TASKS='<%=getString("menu.show.runtime.tasks", resources, request)%>';
var SHOW_SICK_SERVER='<%=getString("menu.show.sickest.server", resources, request)%>';
var MAINT_MODE_LEAVE_PROC='<%=getString("menu.maint.leave.process", resources, request)%>';
var INVALID_REFRESH_RATE='<%=getString("error.invalid.refresh", resources, request)%>';
var SICK_SERVER_HEALTH_SUMMARY = '<%=getString("sick.server.health.summary", resources, request)%>';
var SICK_SERVER_HEALTH_SUMMARY_SEVERE = '<%=getString("sick.server.health.summary.most.severe", resources, request)%>';
var SICK_SERVER_HEALTH_NODE = '<%=getString("sick.server.health.node", resources, request)%>';
var SICK_SERVER_HEALTH_SERVER = '<%=getString("sick.server.health.server", resources, request)%>';
var SICK_SERVER_HEALTH_COUNT = '<%=getString("sick.server.health.count", resources, request)%>';
var SICK_SERVER_HEALTH_SEVERITY = '<%=getString("sick.server.health.severity", resources, request)%>';
var SICK_SERVER_HEALTH_MAX_SEVERITY = '<%=getString("sick.server.health.max.severity", resources, request)%>';
var SICK_SERVER_ERROR_FATAL = '<%=getString("sick.server.health.error.fatal", resources, request)%>';
var SICK_SERVER_ERROR_CRITICAL = '<%=getString("sick.server.health.error.critical", resources, request)%>';
var SICK_SERVER_ERROR_SEVERE = '<%=getString("sick.server.health.error.severe", resources, request)%>';
var SICK_SERVER_ERROR_MINOR = '<%=getString("sick.server.health.error.minor", resources, request)%>';
var SICK_SERVER_ERROR_WARNING = '<%=getString("sick.server.health.error.warning", resources, request)%>';

var DBSERVER_TYPE_DB2_LABEL = '<%=getString("dbserver.type.db2", resources, request)%>';
var DBSERVER_TYPE_ORACLE_LABEL = '<%=getString("dbserver.type.oracle", resources, request)%>';

var rootNameHeaders = new Object();
rootNameHeaders[PURPOSE_NODEGROUP_CENTRIC] = NODEGROUP;
rootNameHeaders[PURPOSE_APPLICATION_CENTRIC] = APPLICATION;
rootNameHeaders[PURPOSE_OPPOLICY_CENTRIC] = OPPOLICY;

var graphFrameName = '<%=graphFrameName%>';
var graphJSP = '<%=graphJSP%>';

function cacheRefreshHandler(e){
	if(!e) 
		e=event; 
	menuClickX=e.clientX; 
	menuClickY=e.clientY;
	executeBackgroundUrl('<%=cacheRefreshURL%>');
}
</script>
</head>

<BODY CLASS="topology-view">



<!--create the drop down box for selection of the node group to show-->


<script>
var legend;
function displayLegend(e){
        if (!e)
                e = event;

        legend = document.getElementById("legend");
        var x, y;

        if (e.pageX){
                x = e.pageX;
                y = e.pageY;
        }else if (e.clientX){
                x = e.clientX + 10;
                y = e.clientY;
        }
        if (legend.style){
                legend.style.top = y;
                legend.style.left = x;
        } else {
                legend.top = y;
                legend.left = x;
        }
        if (legend.style){
                legend.style.visibility = "visible";
        } else {
                legend.visibility = "show";
        }
}
function hideLegend(){
        if (legend.style){
                legend.style.visibility = "hidden";
        } else {
                legend.visibility = "hide";
        }
        legend.display="none";
}


</script>
<!--
<div onMouseOver="displayLegend(event);" onMouseOut="hideLegend();" align="left" style="border-style:solid; border-color:#800000; border-width:2; font-weight:bold; color:#800000; padding:2px; width:50">
	<center>Legend</center>
</div>

<br><br>

<div id="legend" style="z-index:2; position:absolute; top:70; left:70; visibility:hidden; background-color:white; border-color:#800000; border-style:solid; border-width:3;">
<center><b>Legend</b></center><br>
<table cellspacing=1 style="border-color:white; background-color:lightcoral; color:black; font-size:8pt; font-weight:bold; border-style:solid; border-width:2;" border=0 cellpadding=2 cellspacing=2>
	<tr>
	<td><img src="/ibm/console/com.ibm.ws.console.xdruntime/images/jasmInstanceIcon_running.gif"></td>
	<td>Running</td>	
	</tr>
	<tr>
	<td><img src="/ibm/console/com.ibm.ws.console.xdruntime/images/jasmInstanceIcon_starting.gif"></td>
	<td>Starting</td>		
	</tr>
	<tr>
	<td><img src="/ibm/console/com.ibm.ws.console.xdruntime/images/jasmInstanceIcon_stopping.gif"></td>
	<td>Stopping</td>	
	</tr>
	<tr>
	<td><img src="/ibm/console/com.ibm.ws.console.xdruntime/images/jasmInstanceIcon_stopped.gif"></td>
	<td>Stopped</td>		
	</tr>
	<tr>
	<td><img src="/ibm/console/com.ibm.ws.console.xdruntime/images/jasmIcon_ready.gif"></td>
	<td>Ready</td>		
	</tr>
	<tr>
	<td><img src="/ibm/console/com.ibm.ws.console.xdruntime/images/jasmIcon_active.gif"></td>
	<td>Active</td>				
	</tr>
	<tr>
	<td><img src="/ibm/console/com.ibm.ws.console.xdruntime/images/provIcon.gif"></td>
	<td>Provisioning</td>				
	</tr>
	<tr>
	<td><img src="/ibm/console/com.ibm.ws.console.xdruntime/images/deprovIcon.gif"></td>
	<td>De-provisioning</td>				
	</tr>

</table>
</div>
-->

<script type="text/javascript" language="JavaScript1.2">

setShowExpanders(true);
setExpandDepth(1);
setKeepState(false);
setShowHealth(false);

var thispage = document.location.href;
if (thispage.indexOf("perspective=tab.topology") > -1) {
        setInTable(true);
}
else {
        setInTable(false);
}

setTargetFrame("detail");
openFolder = "<%=request.getContextPath()%>/images/open_folder.gif";
closedFolder = "<%=request.getContextPath()%>/images/closed_folder.gif";
plusIcon = "<%=request.getContextPath()%>/images/lplus.gif";
minusIcon = "<%=request.getContextPath()%>/images/lminus.gif";
blankIcon = "<%=request.getContextPath()%>/images/blank20.gif";


</script>
<div id="TOPOLOGY_MESSAGE_BOX_MAIN" style="display:none; border-width:1px; border-style:solid; border-color:black;">
	<table style="background-color:white;" width="100%" cellspacing="0" cellpadding="2">
		<tr>
			<td class="validation-header" align="left">
				<bean:message key="runtime.messages"/>
			</td>
			<td class="validation-header" align="right">
				<a href="javascript:hideMessageBox();">
					<img src="/ibm/console/com.ibm.ws.console.xdruntime/images/messages_close.gif" height="10" width="10" border="0" align="baseline">
				</a>
			</td>
		</tr>
		<tr>
			<td class="table-text" colspan="2" >
				<div id="TOPOLOGY_MESSAGE_BOX">
				</div>
			</td>
		</tr>
	</table>
</div>
<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0">
    <TR>
    <TD style="background-color:#f6f6f6;padding-top:1em" WIDTH="1">&nbsp;</TD>
    <TD CLASS="table-text">
<div id="mainContent"></div><br>
<div id="timestamp"></div>
    </TD>
    </TR>
</TABLE>
<br><br>
<div id="cacheRefresh" style="width:100%; text-align:right;">
<a href="javascript:void 0;" onClick="cacheRefreshHandler(event)" onKeyPress="cacheRefreshHandler(event)"><bean:message key="force.data.update"/></a>
</div>

<script>

function getFirstCellData(){
	if (parent.topologyTop.selectBox)
		getCellData(PURPOSE_INIT);
	else
		window.setTimeout("getFirstCellData();", 500);//wait half a second, try again.
}

var rootDiv = document.getElementById("mainContent");
createProvisioningPopup();
getFirstCellData();

</script>

</body>
</html:html>
