@REM THIS PRODUCT CONTAINS RESTRICTED MATERIALS OF IBM
@REM 5724-J34, 5655-P28  (C) COPYRIGHT International Business Machines Corp., 2005, 2006
@REM All Rights Reserved * Licensed Materials - Property of IBM
@REM US Government Users Restricted Rights - Use, duplication or disclosure
@REM restricted by GSA ADP Schedule Contract with IBM Corp.

@setlocal
@echo off
call "%~dp0setupCmdLine.bat"

SET PATH=%WAS_PATH%

REM ensure user is calling wpfStubUtil properly in the following manner:
REM wpfStubUtil.cmd -ear D_WPFKeyBasedPartitionSample.ear -jar WPFKeyBasedPartitionEJB.jar 
REM -class com/ibm/websphere/wpf/ejb/WPFKeyBasedPartition.class -temp \temp [optional flags and classpaths]

if NOT '%1'=='-ear' goto usage
if NOT '%3'=='-jar' goto usage
if NOT '%5'=='-class' goto usage
if NOT '%7'=='-temp' goto usage

mkdir %8

REM %8\%4 for rmic, executes in local directory of program, vs. tempdir
REM %4 for javac so has reference to the partition key class


if NOT '%9'=='-stubUpdateClasspath' goto skip
shift
SET CP=%9
SET CLASSPATH=%JAVA_HOME%\lib\tools.jar;%WAS_HOME%\lib\j2ee.jar;.;%WAS_HOME%\lib\wpf.jar;%7;%7\%3;%CP%;%CLASSPATH%
goto java
:skip
SET CLASSPATH=%JAVA_HOME%\lib\tools.jar;%WAS_HOME%\lib\j2ee.jar;.;%WAS_HOME%\lib\wpf.jar;%8;%8\%4;%CLASSPATH%

:java
%JAVA_HOME%\bin\java "-Djava.home=%JAVA_HOME%" "-Dwas.install.root=%WAS_HOME%" com.ibm.ws.wpf.WPFStubUtil %*
goto exit

:usage
ECHO You must call wpfStubUtil with the following options in the correct order:
ECHO "wpfStubUtil -ear <earname> -jar <jarname> -class <classname> -temp <temp working directory> [optional flags: -stubUpdateClasspath <classpath> -verbose -stubDebug -keep -rmicextclasspath <classpath> -extdirs <javac extdirs>]"
ECHO "NOTE: The -stubUpdateClasspath command is optional, but if it is used it must be the first argument after the temp working directory"
:exit
@endlocal
