##
## removeMarker.py
## Remove the 'execute' Marker
##

import sys

import java.io.File as JavaFile

##
# Counter Location
##
def counterLocation():
    # return wasHome + "/properties/version/install.xd/backup.operationalpolicy"
    return wasHome + counterLoc

##--------------------
# Main
##--------------------

global traceON
global wasHome
global counterLoc

traceON = 0

if len(sys.argv) < 2:
    print "Two Parameters, <WAS_HOME> and <COUNTER_DIR>, are REQUIRED."
    print "Please retry with the parameters specified."
else:
    wasHome = sys.argv[0]
    counterLoc = sys.argv[1]

    if len(sys.argv) == 3:
        traceON = sys.argv[2]

    try:
        markerFilePath = "%s/execute" % counterLocation()
        marker = JavaFile(markerFilePath)

        if marker.exists():
            if marker.delete():
                print "Marker Deleted."
            else:
                print "Failed to Remove Marker."
        else:
            print "Marker Does NOT Exists."
    except Exception, e:
        print "Exception: %s" % e
        print sys.exc_info()
        print "Exit Script."
