CONNECT TO POSTINGS;


CREATE SCHEMA POSTINGSSCHEMA;



------------------------------------------------

-- DDL Statements for table "POSTINGSSCHEMA"."ACCOUNT"

------------------------------------------------

 

 CREATE TABLE "POSTINGSSCHEMA"."ACCOUNT"  (

		  "ACCOUNTID" VARCHAR(250) NOT NULL , 

		  "OVERDRAFTPROTECTION" DOUBLE , 

		  "OVERDRAFTUSED" DOUBLE , 

		  "BALANCE" DOUBLE )   

		 IN "USERSPACE1" ; 



-- DDL Statements for primary key on Table "POSTINGSSCHEMA"."ACCOUNT"



ALTER TABLE "POSTINGSSCHEMA"."ACCOUNT" 

	ADD CONSTRAINT "PK_ACCOUNT" PRIMARY KEY

		("ACCOUNTID");







------------------------------------------------

-- DDL Statements for table "POSTINGSSCHEMA"."DATACREATIONBEAN"

------------------------------------------------

 

 CREATE TABLE "POSTINGSSCHEMA"."DATACREATIONBEAN"  (

		  "JOBID" VARCHAR(250) NOT NULL , 

		  "STEPID" VARCHAR(250) NOT NULL )   

		 IN "USERSPACE1" ; 



-- DDL Statements for primary key on Table "POSTINGSSCHEMA"."DATACREATIONBEAN"



ALTER TABLE "POSTINGSSCHEMA"."DATACREATIONBEAN" 

	ADD CONSTRAINT "PK_DATACREATIONBE1" PRIMARY KEY

		("JOBID",

		 "STEPID");







------------------------------------------------

-- DDL Statements for table "POSTINGSSCHEMA"."POSTINGACCOUNTDATA"

------------------------------------------------

 

 CREATE TABLE "POSTINGSSCHEMA"."POSTINGACCOUNTDATA"  (

		  "JOBID" VARCHAR(250) NOT NULL , 

		  "STEPID" VARCHAR(250) NOT NULL )   

		 IN "USERSPACE1" ; 



-- DDL Statements for primary key on Table "POSTINGSSCHEMA"."POSTINGACCOUNTDATA"



ALTER TABLE "POSTINGSSCHEMA"."POSTINGACCOUNTDATA" 

	ADD CONSTRAINT "PK_POSTINGACCOUNT2" PRIMARY KEY

		("JOBID",

		 "STEPID");




------------------------------------------------

-- DDL Statements for table "POSTINGSSCHEMA"."OVERDRAFTACCOUNTPOSTING"

------------------------------------------------

 

 CREATE TABLE "POSTINGSSCHEMA"."OVERDRAFTACCOUNTPOSTING"  (

		  "JOBID" VARCHAR(250) NOT NULL , 

		  "STEPID" VARCHAR(250) NOT NULL )   

		 IN "USERSPACE1" ; 



-- DDL Statements for primary key on Table "POSTINGSSCHEMA"."OVERDRAFTACCOUNTPOSTING"



ALTER TABLE "POSTINGSSCHEMA"."OVERDRAFTACCOUNTPOSTING" 

	ADD CONSTRAINT "PK_OVERDRAFTACC2" PRIMARY KEY

		("JOBID",

		 "STEPID");
                 
                 
                 
                 

