-- Scriptfile to create a Cloudscape database for Long Running Scheduler. This script
-- can be modified if needed to change the name of database or name of the Schema used. Default
-- database name is LRSCHED and default schema name is LRSSCHEMA.
-- The script will produce the long running scheduler cloudscape database in the directory 
-- from which it is invoked.
-- Process This script in the ij command line processor.  
-- Example:  
-- java -Djava.ext.dirs=C:/WebSPhere/AppServer/cloudscape/lib -Dij.protocol=jdbc:db2j: com.ibm.db2j.tools.ij MigrateLRSCHEDTablesCloudscape.ddl

CONNECT 'jdbc:db2j:LRSCHED;create=false';


------------------------------------------------

-- DDL Statements for table "LRSSCHEMA"."JOBSTATUS"

------------------------------------------------

ALTER TABLE "LRSSCHEMA"."JOBSTATUS" 

	ADD "STARTTIME" VARCHAR(250)
	
	ADD "REQUESTID" VARCHAR(250)
	;
 

------------------------------------------------

-- DDL Statements for table "LRSSCHEMA"."RECURRINGREQUEST"

------------------------------------------------

 

 CREATE TABLE "LRSSCHEMA"."RECURRINGREQUEST"  (

		  "REQUESTID" VARCHAR(250) NOT NULL , 

		  "JOBNAME" VARCHAR(250) NOT NULL , 

		  "STARTTIME" VARCHAR(250) NOT NULL , 

		  "INTERVAL" VARCHAR(250) NOT NULL ,
		   
		  "SUBMITTER" VARCHAR(32),

		  "STATUS" INTEGER, 

		  "FIELD1" INTEGER, 

		  "FIELD2" VARCHAR(250) )   

		 ; 



-- DDL Statements for primary key on Table "LRSSCHEMA"."RECURRINGREQUEST"



ALTER TABLE "LRSSCHEMA"."RECURRINGREQUEST" 

	ADD CONSTRAINT "PK_RECURRINGREQ" PRIMARY KEY

		("REQUESTID");



COMMIT WORK;


DISCONNECT;




