<%-- IBM Confidential OCO Source Material --%>
<%-- 5724-J34 (C) COPYRIGHT International Business Machines Corp. 2005 --%>
<%-- The source code for this program is not published or otherwise divested --%>
<%-- of its trade secrets, irrespective of what has been deposited with the --%>
<%-- U.S. Copyright Office. --%>

<%-- ---------------------------------------------------------------------------------------- --%>
<%--                                      rolloutWizard.jsp                                   --%>
<%-- ---------------------------------------------------------------------------------------- --%> 

<%@ page language="java"%>

<%@ page import="java.util.ArrayList,java.util.Iterator"%>
<%@ page import="com.ibm.ws.console.appmanagement.appedition.RolloutWizardForm"%>
<%@ page import="org.apache.struts.util.MessageResources,org.apache.struts.action.Action"%>
<%@ page import="com.ibm.ws.security.core.SecurityContext"%>
<%@ taglib uri="/WEB-INF/ibmcommon.tld" prefix="ibmcommon" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<%@ taglib uri="/WEB-INF/tiles.tld" prefix="tiles" %>

<tiles:useAttribute name="actionHandler" classname="java.lang.String" />
<tiles:useAttribute name="actionForm" classname="java.lang.String" />
<tiles:useAttribute name="formType" classname="java.lang.String" />
<tiles:useAttribute name="titleKey" classname="java.lang.String" />
<tiles:useAttribute name="descKey" classname="java.lang.String" />
<tiles:useAttribute name="pluginId" classname="java.lang.String" ignore="true" />

<tiles:useAttribute id="contextType" name="contextType" classname="java.lang.String" />
<% request.setAttribute("contextType",contextType);%>

<ibmcommon:detectLocale/>

<%
   String fieldLevelHelpTopic = "";
   String DETAILFORM = "DetailForm";
   String COLLECTIONFORM = "CollectionForm";
   String FORM = "Form";
   String objectType = "";
   if (formType != null && formType.length() > 0)
      {
      int index = formType.lastIndexOf ('.');
      if (index > 0)
         {
         String fType = formType.substring (index+1);
         if (fType.endsWith(DETAILFORM))
            {
            objectType = fType.substring (0, fType.length()-DETAILFORM.length());
            fieldLevelHelpTopic = objectType + ".detail";
            }
         else if (fType.endsWith(COLLECTIONFORM))
            {
            objectType = fType.substring (0, fType.length()-COLLECTIONFORM.length());
            fieldLevelHelpTopic = objectType + ".collection";
            }
         else if (fType.endsWith(FORM))
            {
            objectType = fType.substring (0, fType.length() - FORM.length());
            fieldLevelHelpTopic = objectType;
            }
         else
            {
            fieldLevelHelpTopic = fType;
            }
         }
      else
         {
         fieldLevelHelpTopic = formType;
         }
      }
   request.setAttribute("fieldHelp", fieldLevelHelpTopic);     
%>
   <%-- ibmcommon:setPluginInformation pluginIdentifier="<%=pluginId%>" pluginContextRoot=""/  --%>

<html:html locale="true">
<HEAD>
<script language="JavaScript" src="<%=request.getContextPath()%>/scripts/menu_functions.js"></script>
<jsp:include page="/secure/layouts/browser_detection.jsp" flush="true" />
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=UTF-8">
<META HTTP-EQUIV="Expires" CONTENT="0">
</HEAD>

<BODY CLASS="content" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">

<%  
   String[] bcnamesT = { "", "", "", "", "", "", "", "", "", "", "", "", "", "", "" };
   ServletContext servletContext = (ServletContext)pageContext.getServletContext();
   MessageResources messages = (MessageResources)servletContext.getAttribute(Action.MESSAGES_KEY);
   String pageTitle = messages.getMessage(request.getLocale(),titleKey);
   if (session.getAttribute("bcnames") != null)  
      {
      bcnamesT = (String[])session.getAttribute("bcnames");
      pageTitle = bcnamesT[0];
      }
%>

<html:form action="<%=actionHandler%>" name="<%=actionForm%>" type="<%=formType%>">
  <ibmcommon:setPluginInformation
    pluginIdentifier="com.ibm.ws.console.appmanagement.appedition"
    pluginContextRoot="" />

  <TABLE WIDTH="98%" CELLPADDING="0" CELLSPACING="0" BORDER="0" class="portalPage">
  <TR>
  <TD CLASS="pageTitle">
    <%=pageTitle%>
  </TD>
  <TD CLASS="pageClose">
    <A HREF="<%=request.getContextPath()%>/secure/content.jsp"> 
      <bean:message key="portal.close.page" />
    </A>
  </TD>
  </TR>
  </TABLE>

  <TABLE WIDTH="100%" CELLPADDING="0" CELLSPACING="0" BORDER="0">
  <TR>
  <TD>

    <TABLE WIDTH="98%" CELLPADDING="0" CELLSPACING="0" BORDER="0" CLASS="wasPortlet">
    <TR>
    <TH class="wpsPortletTitle"><bean:message key="<%=titleKey%>" /></TH>
    <TH class="wpsPortletTitleControls"><ibmcommon:info
        image="help.additional.information.image" topic="<%=fieldLevelHelpTopic%>" />        
      <A href="javascript:showHidePortlet('wasUniPortlet')"> 
        <img id="wasUniPortletImg" SRC="<%=request.getContextPath()%>/images/title_minimize.gif"
             alt="<bean:message key="wsc.expand.collapse.alt"/>" border="0" align="texttop" tabindex="1" />
      </A>
    </TH>
    </TR>
    
    <TBODY ID="wasUniPortlet">
    <TR>
    <TD CLASS="wpsPortletArea" COLSPAN="2"><a name="important"></a> <ibmcommon:errors />

      <p class="instruction-text">
        <bean:message key="<%=descKey%>" />
      </p>

      <table border="0" cellpadding="3" cellspacing="0" width="100%" summary="Rollout Wizard">
      <TBODY>
              
      <%-- ------------------ --%>
      <%--  Rollout Strategy  --%>
      <%-- ------------------ --%>     

      <tr valign="top">
      <td class="table-text" scope="row">
        <fieldset>
        <legend TITLE="<bean:message key="ApplicationEdition.rolloutWizard.step1.description"/>">
                       <bean:message key="rollout.wizard.rollout.strategy.title" />
        </legend>
        <table width="100%" border="0" cellspacing="0" cellpadding="3" summary="Rollout Strategy">
        <tbody>
        <tr valign="top">
        <td class="table-text" nowrap scope="row">
          <label> 
          <html:radio property="rolloutStrategyOption" 
                      styleId="atomic"
                      value="atomic"
                      onclick="enableDisable('atomic,batch:batchSize')" />
          <bean:message key="rollout.wizard.atomic" /> 
          </label>
        </td>
        </tr>
        <tr valign="top">
        <td class="table-text" nowrap scope="row">
          <label> 
          <html:radio property="rolloutStrategyOption" 
                      styleId="batch"
                      value="batch"
                      onclick="enableDisable('atomic,batch:batchSize')" />
          <bean:message key="rollout.wizard.batch" /> 
          </label>
        </td>
        </tr>
        <tr>
        <td class="complex-property" nowrap>
          <label for="batchSize">
          <bean:message key="rollout.wizard.batch.size" />
          </label>
          <br>
          <html:text property="batchSize" 
                     size="4" 
                     styleId="batchSize"
                     styleClass="textEntry" />
        </td>
        </tr>
        </tbody>
        </table>
        </fieldset>
            
      </td>
      </tr>
               
      <%-- ---------------- --%>
      <%--  Reset Strategy  --%>
      <%-- ---------------- --%> 
        
      <tr valign="top">
      <td class="table-text" nowrap valign="top" scope="row">
        <fieldset>
        <legend TITLE="<bean:message key="ApplicationEdition.rolloutWizard.step2.description"/>"> 
                       <bean:message key="rollout.wizard.reset.strategy.title" /> 
        </legend>
        <table border="0" cellpadding="3" cellspacing="0" width="100%" summary="Reset Strategy">
        <tbody> 
        
        <tr valign="top">
        <td class="table-text">
          <LABEL for="softreset">
          <html:radio property="resetStrategyOption" styleId="soft" value="soft" />
          <bean:message key="rollout.wizard.soft.reset" />
          </LABEL>
        </td>
        </tr>
                  
        <tr valign="top">
        <td class="table-text">
          <LABEL for="hardreset">
          <html:radio property="resetStrategyOption" styleId="hard" value="hard" />
          <bean:message key="rollout.wizard.hard.reset" />
          </LABEL>
        </td>
        </tr>
                  
        </tbody>
        </table>
        </fieldset>
      </td>
      </tr>
      
      <%-- ------------------- --%>
      <%--  Drainage Interval  --%>
      <%-- ------------------- --%>  
        
      <tr valign="top">
      <td class="table-text" nowrap valign="top" scope="row">
        <fieldset>
        <legend TITLE="<bean:message key="ApplicationEdition.rolloutWizard.step3.description"/>"> 
                       <bean:message key="rollout.wizard.drainage.interval.title" /> 
        </legend>
        <table border="0" cellpadding="3" cellspacing="0" width="100%" summary="Drainage Interval">
        <tbody>
                
        <tr valign="top">
        <td class="table-text" nowrap valign="top" scope="row">
          <label for="batchSize">
          <bean:message key="rollout.wizard.drainage.interval.title" />
          </label>
          <br>
          <html:text property="drainageInterval" 
                     size="4" 
                     styleId="drainageInterval"
                     styleClass="textEntry" />
          <bean:message key="rollout.wizard.seconds.label"/>                     
        </td>                    
        </tr>
                  
        </tbody>
        </table>
        </fieldset>
      </td>
      </tr>
          
      <%-- ------------------- --%>
      <%--  OK/Cancel Buttons  --%>
      <%-- ------------------- --%> 
         
      <tr>
      <th class="navigation-button-section">
        <html:submit property="addNodeOK" styleId="navigation" styleClass="buttons">
          <bean:message key="button.ok" />
        </html:submit> 
        <html:cancel styleId="navigation" styleClass="buttons">
          <bean:message key="button.cancel" />
        </html:cancel></th>
      </TR>
            
      </TBODY>
      </table>
    </TD>
    </TR>
    </TBODY>
    </TABLE>
    
  </TD>
    <%@ include file="/secure/layouts/helpPortlet.jspf" %>      
  </TR>
  </TABLE>
  
  
  <SCRIPT>
    enableDisable('atomic,batch:batchSize')
  </SCRIPT> 
   
</html:form>
</BODY>
</html:html>
