<%-- IBM Confidential OCO Source Material --%>
<%-- 5724-J34 (C) COPYRIGHT International Business Machines Corp. 2005 --%>
<%-- The source code for this program is not published or otherwise divested --%>
<%-- of its trade secrets, irrespective of what has been deposited with the --%>
<%-- U.S. Copyright Office. --%>


<%@ page import="java.util.*"%>
<%@ page import="com.ibm.ws.security.core.SecurityContext"%>

<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/tiles.tld" prefix="tiles" %>

<tiles:useAttribute name="formAction" classname="java.lang.String"/>
<tiles:useAttribute name="formName"   classname="java.lang.String"/>
<tiles:useAttribute name="formType"   classname="java.lang.String"/>

<%-- bean:define id="bean"          name="<%=formName%>"/ --%>
<bean:define id="refId"      name="<%=formName%>" property="refId"        type="java.lang.String"/>
<bean:define id="type"       name="<%=formName%>" property="type"         type="java.lang.String"/>
<bean:define id="state"      name="<%=formName%>" property="currentState" type="java.lang.String"/>
<bean:define id="actionList" name="<%=formName%>" property="actionList"   type="java.util.List"/>

<%
boolean showButtons = true;
if (SecurityContext.isSecurityEnabled() && !(request.isUserInRole("administrator") || request.isUserInRole("operator"))) {
    showButtons = false;
}

if (showButtons) {
%>
<html:form action="<%=formAction%>" name="<%=formName%>" type="<%=formType%>">
<table class="framing-table" border="0" cellpadding="5" cellspacing="0" width="100%" summary="Buttons Table" >
    <tbody>
        <tr valign="top" class="table-button-section">
            <td nowrap> 
                <select name="jobAction_<%=refId%>">
                <%
                    Iterator i_actionList = actionList.iterator();
                    while (i_actionList.hasNext()) {
                        String curraction = (String) i_actionList.next();
                        String key        = curraction; 
                %>
                        <option value="<%=curraction%>">
                            <bean:message key="<%=key%>"/>
                        </option>
                <%
                    } // end while
                %>
                </select>
                <input type="submit" name="button.execute" value="<bean:message key="button.execute"/>" class="buttons" id="functions"/>
            </td>
        <% if (state.equalsIgnoreCase("job.state.executing") && type.equalsIgnoreCase("job.type.batch")) { %>
            <td nowrap> 
                &nbsp;&nbsp;<bean:message key="jobmanagement.suspended.time.label"/><br>
                <input type="text" id="suspendTime" name="suspendTime" class="textEntry" size="10" value="15"/>
            </td>
            <td width="75%"></td>
        <% } %>
        </tr>
    </tbody>
</table>
</html:form>
<%
    }
%>
<br>