// IBM Confidential OCO Source Material
// 5724-J34 (C) COPYRIGHT International Business Machines Corp. 2005
// The source code for this program is not published or otherwise divested
// of its trade secrets, irrespective of what has been deposited with the
// U.S. Copyright Office.

var jobPopup    = null;
var jobIfr      = null;
var hideOptions = true;

function createJobPopup() {
    document.writeln('<div id="jobPanel" style="z-index: 100;font-weight: normal; font-size:70.0%; font-family: Arial,Helvetica, sans-serif;  position:absolute; top:0; left:0; padding:5; background-color:white; border-color:black; border-style:solid; border-width:1;"><span class="provPanel" id="provPanelSpan"></span></div>');
    document.writeln('<iframe id="jobFrame" src="javascript:false;" scrolling="no" frameborder="0" style="position:absolute; top:0px; left:0px; display:none;"></iframe>');
       
    jobPopup = document.getElementById("jobPanel");
    jobIfr   = document.getElementById("jobFrame");
    hidePopup();
    return jobPopup;
}

function placeJobPanel(x, y) {
    if(jobPopup.style) {
        jobPopup.style.top  = y;
        jobPopup.style.left = x;

         jobIfr.style.top   = jobPopup.style.top;
        jobIfr.style.left   = jobPopup.style.left;
        jobIfr.style.width  = jobPopup.offsetWidth;
        jobIfr.style.height = jobPopup.offsetHeight;
        jobIfr.style.zIndex = jobPopup.style.zIndex-1;
    } else {
        jobPopup.top  = y;
        jobPopup.left = x;
    }
}

function hidePopup() {    
    if(jobPopup == null) return;
    
    //handle it in a browser by browser fashion
    if(jobPopup.style) {
        jobPopup.style.visibility = "hidden";
        jobIfr.style.visibility   = "hidden";
        jobPopup.style.display    = "none";
        jobIfr.style.display      = "none";
    } else {
        jobPopup.visibility = "hide";
        jobIfr.visibility = "hide";
    }
}

function showJobPopup() {

    if(jobPopup == null) return;
    
    //handle it in a browser by browser fashion
    if(jobPopup.style) {
        jobPopup.style.visibility = "visible";
        jobPopup.style.display    = "block";

        jobIfr.style.top        = jobPopup.style.top;
        jobIfr.style.left       = jobPopup.style.left;
        jobIfr.style.width      = jobPopup.offsetWidth;
        jobIfr.style.height     = jobPopup.offsetHeight;
        jobIfr.style.zIndex     = jobPopup.style.zIndex-1;
        jobIfr.style.display    = "block";    
        jobIfr.style.visibility = "visible";
    } else {
        jobPopup.visibility = "show";
    }
}

function populateJobPopup(list) {
    var text = "";
    var notFirst = false;
    for(var i = 0; i < list.length; i++) {
        if(notFirst) text += "<BR>";
        text += list[i];
        notFirst = true;
    }
    
    if(jobPopup.innerHTML)
        jobPopup.innerHTML = text;
    else if(jobPopup.layers) {
        var doc = jobPopup.layers["jobPanel"].document;
        doc.open();
        doc.write(text);
    }
}

function showJobDescription(e, type, status) {

    if(!jobPopup) return; //none exists...return before we get errors

    hidePopup();
        
    populateJobPopup([type, status]);
    if (isIE) {
        if (isDom) {  
            oT = e.clientY;
            oL = e.clientX;
        } else {  
            oT = e.clientY+document.body.scrollTop;
            oL = e.clientX;
        }                
    } else {
        oT = e.pageY;
        oL = e.pageX;
    }
    placeJobPanel(oL + 10, oT);
    showJobPopup();
}

function showHideSubmitOptions(showMsg, hideMsg) {
	if (hideOptions) {
        document.getElementById("other").value=hideMsg;
        document.getElementById("optionsControl").style.display="inline";
        hideOptions = false;
    } else {
        document.getElementById("other").value=showMsg;
        document.getElementById("optionsControl").style.display="none";
        hideOptions = true;
    }
}