<%-- IBM Confidential OCO Source Material --%>
<%-- 5724-i63, 5724-H88 (C) COPYRIGHT International Business Machines Corp. 1997, 2005 --%>
<%-- The source code for this program is not published or otherwise divested --%>
<%-- of its trade secrets, irrespective of what has been deposited with the --%>
<%-- U.S. Copyright Office. --%>

<%@ page import="com.ibm.ws.sm.workspace.*"%>
<%@ page import="com.ibm.ws.workspace.query.*"%>
<%@ page import="com.ibm.ws.console.core.*"%>
<%@ page import="com.ibm.ws.console.core.ConfigFileHelper"%>  <%-- LIDB2303A --%>
<%@ page import="java.util.*,com.ibm.ws.security.core.SecurityContext,com.ibm.websphere.product.*"%>
<%@ page import="com.ibm.websphere.management.metadata.ManagedObjectMetadataAccessor"%>
<%@ page import="com.ibm.websphere.management.metadata.ManagedObjectMetadataAccessorFactory"%>
<%@ page import="com.ibm.ws.console.core.selector.*"%>
<%@ page import="com.ibm.ws.*"%>
<%@ page import="com.ibm.wsspi.*"%>

<%@ page import="com.ibm.ws.console.taskmanagement.util.*" %>
<%@ page import="com.ibm.ws.taskmanagement.util.*" %>
<%@ page import="com.ibm.ws.taskmanagement.task.*" %>

<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/tiles.tld" prefix="tiles" %>
<%@ taglib uri="/WEB-INF/ibmcommon.tld" prefix="ibmcommon" %>

<tiles:useAttribute  name="readOnlyView" classname="java.lang.String"/>
<tiles:useAttribute  name="attributeList" classname="java.util.List"/>
<tiles:useAttribute name="formAction" classname="java.lang.String" />
<tiles:useAttribute name="formName" classname="java.lang.String" />
<tiles:useAttribute name="formType" classname="java.lang.String" />
<tiles:useAttribute name="formFocus" classname="java.lang.String" />

<style>
.readOnlyMessageElement { 
    color:#666666;
    font-family: Verdana,sans-serif; 
    background-color:#FFFFFF;
    margin-left: 0.5em;
    margin-top: 0em;
    border-bottom-width:1px;
    border-style:solid;
    padding-right:1px;
    border-right-width:1px;
    border-left-width:1px;
    padding-top:1px;
    border-color:#666666;
    padding-bottom:1px;
    border-top-width:1px;
    padding-left:1px;
}
.table-button-section { 
    background-color:#FFFFFF;
}    
</style>

<script type="text/javascript" language="JavaScript" src="<%=request.getContextPath()%>/com.ibm.ws.console.taskmanagement/collectiontable.js"></script>

<%String contextId = null;%>
<logic:notEmpty name="<%=formName%>" property="contextId">
<bean:define id="contextId_new" name="<%=formName%>" property="contextId" type="java.lang.String"/>
<%contextId = contextId_new;%>
</logic:notEmpty>

<bean:define id="perspective"    name="<%=formName%>" property="perspective"/>


<%

String contextType=(String)request.getAttribute("contextType");
String cellname = null;
String nodename = null;
String token = null;
java.util.Properties props= null;

java.util.ArrayList attributeList_ext =  new java.util.ArrayList();
for(int i=0;i<attributeList.size(); i++)
     attributeList_ext.add(attributeList.get(i));

IPluginRegistry registry= IPluginRegistryFactory.getPluginRegistry();

String extensionId = "com.ibm.websphere.wsc.form";
IConfigurationElementSelector ic = new ConfigurationElementSelector(contextType,extensionId);

IExtension[] extensions= registry.getExtensions(extensionId,ic);

if(extensions!=null && extensions.length>0){
    if(contextId!=null && contextId!="nocontext"){
        props = ConfigFileHelper.getNodeMetadataProperties((String)contextId); //213515
    }

    props = ConfigFileHelper.getAdditionalAdaptiveProperties(request, props, formName); // LIDB2303A

    attributeList_ext = FieldSelector.getFields(extensions,attributeList_ext,props,(String)perspective);
    }
attributeList_ext = FieldSelector.getCategories(extensions,attributeList_ext,(String)perspective);

pageContext.setAttribute("attributeList_ext",attributeList_ext);


%>


<%  String renderReadOnlyView = "no";
if( (readOnlyView != null) && (readOnlyView.equalsIgnoreCase("yes")) ) {
  renderReadOnlyView = "yes";
} else if (SecurityContext.isSecurityEnabled()) {
    renderReadOnlyView = "yes";
    if (request.isUserInRole("administrator")) {
        renderReadOnlyView = "no";
    }
    else if (request.isUserInRole("configurator")) {
        renderReadOnlyView = "no";
    }
}
%>

<%  
        //Boolean descriptionsOn = (Boolean) session.getAttribute("descriptionsOn");
        //String numberOfColumns = "3";
        //if (descriptionsOn.booleanValue() == false)
        //  numberOfColumns = "2";  
        WASProduct productInfo = new WASProduct();
%>

<%
   String fieldLevelHelpTopic = "";
   String fieldLevelHelpAttribute = "";
   String DETAILFORM = "DetailForm";
   String objectType = "";
   int index = formType.lastIndexOf ('.');
   if (index > 0)
   {
      String fType = formType.substring (index+1);
      if (fType.endsWith (DETAILFORM))
         objectType = fType.substring (0, fType.length()-DETAILFORM.length());
      else
         objectType = fType;
   }
   fieldLevelHelpTopic = objectType+".detail.";
   String topicKey = fieldLevelHelpTopic;
%>

<% 
//  If there's no properties, don't show this section
if (attributeList_ext.size() > 0) {
%>
 
   <a name="general"></a>
   
       <h2><bean:message key="task.situation.desc.title"/></H2>

    <% if (renderReadOnlyView.equalsIgnoreCase("yes")) { %>
    

<html:form action="<%=formAction%>" name="<%=formName%>" type="<%=formType%>">
<%--html:hidden property="action"/--%>

<table class="framing-table" border="0" cellpadding="5" cellspacing="0" width="100%" summary="Properties Table" >

    <tbody>

        <bean:define id="refId" name="<%=formName%>" property="refId" type="java.lang.String"/>
        <bean:define id="actionList" name="<%=formName%>" property="actionList" type="java.util.List"/>
        <bean:define id="taskState" name="<%=formName%>" property="currentState" type="java.lang.String" />
  		

        <% if (actionList.size()>0) { %>
            <tr valign="top">
            <td class="table-button-section"  nowrap> 
            <%
			Iterator i_actionList = actionList.iterator();					
			if (taskState.equals("new") || taskState.equals("renewed") || taskState.equals("suppressed")) {%> 
				<select name="taskAction_<%=refId%>">
			<%} else {%>
				<select name="taskAction_<%=refId%>" DISABLED> 
			<%}%>
			
			<% while (i_actionList.hasNext()) {
				String curraction = (String) i_actionList.next();
				String key = "task.action." + curraction;%>
				<option value="<%=curraction%>">
					<bean:message key="<%=key%>" />
				</option>
			<%} // end while %>
			</select>
    		
	    <input type="submit" name="button.execute" value="<bean:message key="button.execute"/>" class="buttons" id="functions"/>	

        </td>
        </tr>
        
    <% } %>
        
    </tbody>
</table>    

    <%
               int propCounterReadOnly = 0;
               String activeSubhead = "";
    
             %>

        <% com.ibm.ws.console.core.item.PropertyItem reasonItem = (com.ibm.ws.console.core.item.PropertyItem)attributeList_ext.get(5);
           String reasonProp=reasonItem.getAttribute(); %>
     	<P CLASS="table-text" ID="<%=reasonProp%>">
		<bean:write property="<%=reasonProp%>" name="<%=formName%>"/>
		</P>

        <table border="0" cellpadding="2" cellspacing="0" valign="top" width="100%" summary="Framing Table" >
        <tbody>
          <tr valign="top"> 
            <td class="table-text-white" id="data" nowrap scope="rowgroup"> 
              <a href="javascript:showHideSection('com_ibm_ws_taskDetail')" CLASS="expand-task">
              <img id="com_ibm_ws_taskDetailImg" SRC="/ibm/console/images/arrow_collapsed.gif" alt="<bean:message key="task.info.desc.title"/>" border="0" align="texttop" tabindex="1"/>
              <bean:message key="task.info.desc.title"/></A>
              <input type="hidden" name="show" value="collapsed">
            </td>
          </tr>
          </tbody>
        </table>

        
        <table id="com_ibm_ws_taskDetail" border="0" cellpadding="5" cellspacing="0" valign="top" width="100%" summary="Framing Table">
             

    <logic:iterate id="item" name="attributeList_ext" type="com.ibm.ws.console.core.item.PropertyItem">


    <%if (item.getCategoryId()!=null) {
	%>
    
        <%
          if ((!activeSubhead.equals(item.getCategoryId()) && (!activeSubhead.equals(""))) || ((item.getCategoryId().equalsIgnoreCase("general") && propCounterReadOnly!=0))) {
    	%>
           
        </TABLE>
        </FIELDSET>
        </TD>
        </TR>
        
        <%
    	  }
          if(!item.getCategoryId().equalsIgnoreCase("general")){
              activeSubhead = item.getCategoryId();
    	%>

        <TR>
        <TD CLASS="table-text">
        
        <FIELDSET>
        <LEGEND>
          <bean:message key="<%=item.getCategoryId()%>"/>
        </LEGEND>                        
                                
        <table class="categorizedField" id="<%=item.getCategoryId()%>" border="0" cellpadding="5" cellspacing="0" width="100%" summary="Properties Category Table" >

        
        

    <%}else
         activeSubhead="";
        } else { %>
    




    <%        fieldLevelHelpAttribute = item.getAttribute();
            if (fieldLevelHelpAttribute.equals(" ") || fieldLevelHelpAttribute.equals(""))
                fieldLevelHelpTopic = item.getLabel();
            else
                fieldLevelHelpTopic = topicKey + fieldLevelHelpAttribute;
            //this code gets productId from icon attribute of PropertyItem 
            //and checks if product is installed 
            // If product  is installed , then make row visible
            String productId = item.getIcon();
            boolean productEnabled = true;
            if ( (productId == null)  || (productId !=null && productId.equals("")) ) {
                productId = "BASE";
        } else if (productId.equals("ND") && productInfo.productPresent(productId)) {
            WorkSpaceQueryUtil util = WorkSpaceQueryUtilFactory.getUtil();
            RepositoryContext cellContext = (RepositoryContext)session.getAttribute(com.ibm.ws.console.core.Constants.CURRENTCELLCTXT_KEY);
            try {
                if (util.isStandAloneCell(cellContext)) {
                    productEnabled = false;
                }
                else {
                    productEnabled = true;
                } 
            }
            catch (Exception e) {
                System.out.println("exception in util.isStandAloneCell " + e.toString());
                productEnabled = false;
            }
        } else if (productId.equals("PME") && productInfo.productPresent(productId)) {
                productEnabled = true;
        } else {
            productEnabled = false;
        }

            if (productEnabled) { 
       
           String prop = item.getAttribute();
    %>

    <% if (!prop.equals("reasonMsg"))  { %>

    <tr valign="top">
                <% if (item.getType().equalsIgnoreCase("Custom")) { %>
                        
        <tiles:insert page="/secure/layouts/customLayout.jsp" flush="false">
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        <tiles:put name="readOnly" value="true" />
        <tiles:put name="jspPage" value="<%=item.getUnits()%>"/>
        <tiles:put name="units" value=""/>
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="isRequired" value="<%=item.getRequired()%>" />
        <tiles:put name="size" value="30" />
        </tiles:insert>

                <% } else if (item.getType().equalsIgnoreCase("jsp")) { %>
                        
        <tiles:insert page="<%=item.getUnits()%>" flush="false">
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        <tiles:put name="readOnly" value="true" />
        <tiles:put name="jspPage" value="<%=item.getUnits()%>"/>
        <tiles:put name="units" value=""/>
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="isRequired" value="<%=item.getRequired()%>" />
        <tiles:put name="size" value="30" />
        </tiles:insert>

                    <% } else if (item.getType().equalsIgnoreCase("select")) { 
                        
                        try {
                            session.removeAttribute("valueVector");
                            session.removeAttribute("descVector");
                        }
                        catch (Exception e) {
                        }
                        
                        StringTokenizer st1 = new StringTokenizer(item.getEnumDesc(), ";,");
                        Vector descVector = new Vector();
                        while(st1.hasMoreTokens()) 
                        {
                            String enumDesc = st1.nextToken();
                            descVector.addElement(enumDesc);
                        }
                        StringTokenizer st = new StringTokenizer(item.getEnumValues(), ";,");
                        Vector valueVector = new Vector();
                        while(st.hasMoreTokens()) 
                        {
                            String str = st.nextToken();
                            valueVector.addElement(str);
                        }
            
                        session.setAttribute("descVector", descVector);
                        session.setAttribute("valueVector", valueVector);
                        %>
                        
        <tiles:insert page="/secure/layouts/submitLayout.jsp"  flush="false">
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="isRequired" value="<%=item.getRequired()%>" />
        <tiles:put name="readOnly" value="true" />
        <tiles:put name="valueVector" value="<%=valueVector%>" />
        <tiles:put name="descVector" value="<%=descVector%>" />
        <tiles:put name="size" value="30" />
        <tiles:put name="units" value=""/>
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        </tiles:insert>

                        <% } else if (item.getType().equalsIgnoreCase("Dynamicselect")) { 
                        try {
                            session.removeAttribute("valueVector");
                            session.removeAttribute("descVector");
                        }
                        catch (Exception e) {
                        }
                        Vector valVector = (Vector) session.getAttribute(item.getEnumValues());
                        Vector descriptVector = (Vector) session.getAttribute(item.getEnumDesc());
    
                        session.setAttribute("descVector", descriptVector);
                        session.setAttribute("valueVector", valVector);
                        %>
    
        <tiles:insert page="/secure/layouts/dynamicSelectionLayout.jsp" flush="false">
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="readOnly" value="true" />
        <tiles:put name="isRequired" value="<%=item.getRequired()%>" />
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="size" value="30" />
        <tiles:put name="units" value=""/>
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        <tiles:put name="multiSelect" value="<%=item.isMultiSelect()%>" />
        </tiles:insert>

                    <% } else if (item.getType().equalsIgnoreCase("Password")) { %>
                                  
        <td class="table-text"  scope="row" nowrap>
            <label  for="<%=item.getAttribute() %>">
            <bean:message key="<%= item.getLabel() %>"/>
            </label>
            <BR>
            <DIV CLASS="readOnlyElement" ID="<%= item.getAttribute() %>">
                **********
            </DIV>
        </td>
        
        <% } else { %>

  		    <td class="table-text"  scope="row" valign="top">
                         
           
           	<!-- <bean:write property="<%=prop%>" name="<%=formName%>"/> -->
            
            <% if (prop.equals("finalStatus")) { %>
    			<bean:define id="finalStatus" name="<%=formName%>" property="<%=item.getAttribute()%>" type="java.lang.String"/>
    			<bean:define id="finalStatusMsg" name="<%=formName%>" property="finalStatusMsg" type="java.lang.String"/>
	      		<% if (finalStatus.length() > 0) { %>      
	    		 	<label  for="<%=prop%>" title="<bean:message key="<%=item.getLabel()%>"/>">
        				<bean:message key="<%=item.getLabel()%>" />
       				</label>
	      				
	      			<br>
	      			<P CLASS="readOnlyElement" ID="<%=prop%>" width="50%">
	      			<bean:message key="<%=finalStatus%>"/>: <%=finalStatusMsg%>
	      		<%}%>	
        	<% } else { %> 
       			<label  for="<%=prop%>" title="<bean:message key="<%=item.getLabel()%>"/>">
        			<bean:message key="<%=item.getLabel()%>" />
        			</label>
        		<br>
	            <% if (prop.equals("reasonMsg")) { %>
      	   	     	<P CLASS="readOnlyMessageElement" ID="<%=prop%>">
      		    <%} else { %>
        	     		<P CLASS="readOnlyElement" ID="<%=prop%>">
  			    <%}%>
		        <% if (prop.equals("currentState") || prop.equals("globalSeverity")) { %>
		  			<bean:define id="property" name="<%=formName%>" property="<%=prop%>" type="java.lang.String"/>
		  			<bean:message key="<%=property%>"/>        
		 		<%} else if (item.getAttribute().equals("taskId")) { %>    
		 			<bean:define id="taskType" name="<%=formName%>" property="taskType" type="java.lang.String" />
		 			
					<%String typekey = "task.type.";
					if (taskType.equalsIgnoreCase(Byte.toString(TaskConstants.PLANNEDTASK_TYPE_EXECUTING))) {
						typekey += "executing";
					} else if (taskType.equalsIgnoreCase(Byte.toString(TaskConstants.PLANNEDTASK_TYPE_APPROVAL))) {
						typekey += "approval";
					} else if (taskType.equalsIgnoreCase(Byte.toString(TaskConstants.PLANNEDTASK_TYPE_MANUAL))) {
						typekey += "manual";
					} else {
						typekey += "nonplanned";
					}%>
					<bean:write property="<%=prop%>" name="<%=formName%>"/>&nbsp;(<bean:message key="<%=typekey%>"/>)
		      	<%} else { %>
		  			<bean:write property="<%=prop%>" name="<%=formName%>"/>
		  		<%}%>
		  	<%}%>

            
            
            &nbsp;
            </P>

           
        </td>
       



        

                    <% } %>
                    
                    <% propCounterReadOnly += 1;%>

              


    </tr>
    
	  	<%}%>

            <% }%> 
            
    <%}%>

    </logic:iterate>
    
    <%
      if (!activeSubhead.equals("")) {
	%>
       
    </TABLE>
    </FIELDSET>
    </TD>
    </TR>
    
    <%
	  }
	%>


    <!-- <tr>
        <td class="navigation-button-section" VALIGN="top">
            <input type="submit" name="org.apache.struts.taglib.html.CANCEL" value="<bean:message key="button.back"/>" class="buttons" id="navigation">
        </td> -->
    </tr>

    </tbody>



</table>
<script>
document.getElementById('com_ibm_ws_taskDetail').style.display="none";
</script>
</html:form>

    <% } %>
    
    
    
    
    
    
    
    
    
    <% if (renderReadOnlyView.equalsIgnoreCase("no")) { %>
    
<html:form action="<%=formAction%>" name="<%=formName%>" type="<%=formType%>">
<html:hidden property="action"/>
<table class="framing-table" border="0" cellpadding="5" cellspacing="0" width="100%" summary="Properties Table" >
    <tbody>

        <tr valign="top">
        <td class="table-button-section"  nowrap> 
    
          <bean:define id="refId" name="<%=formName%>" property="refId" type="java.lang.String"/>
          <bean:define id="actionList" name="<%=formName%>" property="actionList" type="java.util.List"/>
	    <bean:define id="taskState" name="<%=formName%>" property="currentState" type="java.lang.String"/>
    			<%	
			Iterator i_actionList = actionList.iterator();					
			if (taskState.equals("new") || taskState.equals("renewed") || taskState.equals("suppressed")) {%> 
				<select name="taskAction_<%=refId%>">
			<%} else {%>
				<select name="taskAction_<%=refId%>" DISABLED> 
			<%}%>
			
			<% while (i_actionList.hasNext()) {
				String curraction = (String) i_actionList.next();
				String key = "task.action." + curraction;%>
				<option value="<%=curraction%>">
					<bean:message key="<%=key%>" />
				</option>
			<%} // end while %>
			</select>
    		
	    <input type="submit" name="button.execute" value="<bean:message key="button.execute"/>" class="buttons" id="functions"/>	

        </td>
        </tr>
	    
             <%
               int propSet = attributeList_ext.size();
               int propEven = propSet%2;
               int propCounter = 0;
               String activeSubhead = "";

    
             %>
            
    <logic:iterate id="item" name="attributeList_ext" type="com.ibm.ws.console.core.item.PropertyItem">

    <%if (item.getCategoryId()!=null) {
	%>
    
        <%
          if ((!activeSubhead.equals(item.getCategoryId()) && (!activeSubhead.equals(""))) || ((item.getCategoryId().equalsIgnoreCase("general") && propCounter!=0))) {
    	%>
           
        </TABLE>
        </FIELDSET>
        </TD>
        </TR>
        
        <%
    	  }
          if(!item.getCategoryId().equalsIgnoreCase("general")){
              activeSubhead = item.getCategoryId();
    	%>

        <TR>
        <TD CLASS="table-text">
        
        <FIELDSET>
        <LEGEND>
          <bean:message key="<%=item.getCategoryId()%>"/>
        </LEGEND>                        
                                
        <table class="categorizedField" id="<%=item.getCategoryId()%>" border="0" cellpadding="5" cellspacing="0" width="100%" summary="Properties Category Table" >

        
        

    <%}else
         activeSubhead="";
       } else { %>
    
    <%  
            fieldLevelHelpAttribute = item.getAttribute();
            if (fieldLevelHelpAttribute.equals(" ") || fieldLevelHelpAttribute.equals(""))
                fieldLevelHelpTopic = item.getLabel();
            else
                fieldLevelHelpTopic = topicKey + fieldLevelHelpAttribute;
            //this code gets productId from icon attribute of PropertyItem 
            //and checks if product is installed 
            // If product  is installed , then make row visible
            String productId = item.getIcon();
            boolean productEnabled = true;
            if ( (productId == null)  || (productId !=null && productId.equals("")) ) {
            productId = "BASE";
        } else if (productId.equals("ND") && productInfo.productPresent(productId)) {
            WorkSpaceQueryUtil util = WorkSpaceQueryUtilFactory.getUtil();
            RepositoryContext cellContext = (RepositoryContext)session.getAttribute(com.ibm.ws.console.core.Constants.CURRENTCELLCTXT_KEY);
            try {
                if (util.isStandAloneCell(cellContext)) {
                    productEnabled = false;
                }
                else {
                    productEnabled = true;
                } 
            }
            catch (Exception e) {
                System.out.println("exception in util.isStandAloneCell " + e.toString());
                productEnabled = false;
            }
        } else if (productId.equals("PME") && productInfo.productPresent(productId)) {
                productEnabled = true;
        } else {
            productEnabled = false;
        }
    
            if (productEnabled) {
    %>
    
           
          
            <tr valign="top">
           
           
                    <% 
                    String isRequired = item.getRequired(); 
                    String strType = item.getType();
                    String isReadOnly = item.getReadOnly();
                    %>
     
                    <% if (strType.equalsIgnoreCase("Text")) { %>
                        
        <tiles:insert page="/secure/layouts/textFieldLayout.jsp" flush="false">
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="isReadOnly" value="<%=isReadOnly%>" />
        <tiles:put name="isRequired" value="<%=isRequired%>" />
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="size" value="30" />
        <tiles:put name="units" value="<%=item.getUnits()%>"/>
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        </tiles:insert>
                    <% } %>
                    
                    <% if (strType.equalsIgnoreCase("TextMedium")) { %>
                        
        <tiles:insert page="/secure/layouts/textFieldLayout.jsp" flush="false">
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="isReadOnly" value="<%=isReadOnly%>" />
        <tiles:put name="isRequired" value="<%=isRequired%>" />
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="size" value="60" />
        <tiles:put name="units" value="<%=item.getUnits()%>"/>
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        </tiles:insert>
                    <% } %>
                    
                    <% if (strType.equalsIgnoreCase("TextLong")) { %>
                        
        <tiles:insert page="/secure/layouts/textFieldLayout.jsp" flush="false">
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="isReadOnly" value="<%=isReadOnly%>" />
        <tiles:put name="isRequired" value="<%=isRequired%>" />
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="size" value="90" />
        <tiles:put name="units" value="<%=item.getUnits()%>"/>
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        </tiles:insert>
                    <% } %>
       
                    <% if (strType.equalsIgnoreCase("TextArea")) { %>
                        
        <tiles:insert page="/secure/layouts/textAreaLayout.jsp" flush="false">
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="isReadOnly" value="<%=isReadOnly%>" />
        <tiles:put name="isRequired" value="<%=isRequired%>" />
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="size" value="5" />
        <tiles:put name="units" value="<%=item.getUnits()%>"/>
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        </tiles:insert>
                    <% } %>
            
                    <% if (strType.equalsIgnoreCase("checkbox")) { %>
                        
        <tiles:insert page="/secure/layouts/checkBoxLayout.jsp" flush="false">
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="isReadOnly" value="<%=isReadOnly%>" />
        <tiles:put name="isRequired" value="<%=isRequired%>" />
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="size" value="30" />
        <tiles:put name="units" value="<%=item.getUnits()%>"/>
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        </tiles:insert>
                    <% } %>
            
                    <% if (strType.equalsIgnoreCase("Password")) { %>
                        
        <tiles:insert page="/secure/layouts/passwordLayout.jsp" flush="false">
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="isReadOnly" value="<%=isReadOnly%>" />
        <tiles:put name="isRequired" value="<%=isRequired%>" />
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="size" value="30" />
        <tiles:put name="units" value="<%=item.getUnits()%>"/>
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        </tiles:insert>
                    <% } %>
                    
                    <% if (strType.equalsIgnoreCase("Custom")) { %>
                        
        <tiles:insert page="/secure/layouts/customLayout.jsp" flush="false">
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        <tiles:put name="readOnly" value="<%=isReadOnly%>" />
        <tiles:put name="jspPage" value="<%=item.getUnits()%>"/>
        <tiles:put name="size" value="30" />
        <tiles:put name="units" value=""/>
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="isRequired" value="<%=item.getRequired()%>" />
        </tiles:insert>
                    <% } %>
                    
                    <% if (strType.equalsIgnoreCase("jsp")) { %>
                        
        <tiles:insert page="<%=item.getUnits()%>" flush="false">
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        <tiles:put name="readOnly" value="<%=isReadOnly%>" />
        <tiles:put name="jspPage" value="<%=item.getUnits()%>"/>
        <tiles:put name="size" value="30" />
        <tiles:put name="units" value=""/>
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="isRequired" value="<%=item.getRequired()%>" />
        </tiles:insert>
                    <% } %>
            
                    <% if (strType.equalsIgnoreCase("select")) { 
                        
                        try {
                            session.removeAttribute("valueVector");
                            session.removeAttribute("descVector");
                        }
                        catch (Exception e) {
                        }
                        
                        StringTokenizer st1 = new StringTokenizer(item.getEnumDesc(), ",");
                        Vector descVector = new Vector();
                        while(st1.hasMoreTokens()) 
                        {
                            String enumDesc = st1.nextToken();
                            descVector.addElement(enumDesc);
                        }
                        StringTokenizer st = new StringTokenizer(item.getEnumValues(), ",");
                        Vector valueVector = new Vector();
                        while(st.hasMoreTokens()) 
                        {
                            String str = st.nextToken();
                            valueVector.addElement(str);
                        }
            
                        session.setAttribute("descVector", descVector);
                        session.setAttribute("valueVector", valueVector);
                        %>
                        
        <tiles:insert page="/secure/layouts/submitLayout.jsp" flush="false">
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="readOnly" value="<%=isReadOnly%>" />
        <tiles:put name="isRequired" value="<%=isRequired%>" />
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="size" value="30" />
        <tiles:put name="units" value=""/>
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        </tiles:insert>
                    <% } %>
                    
                    <% if (strType.equalsIgnoreCase("Dynamicselect")) { 
                        try {
                            session.removeAttribute("valueVector");
                            session.removeAttribute("descVector");
                        }
                        catch (Exception e) {
                        }
                        Vector valVector = (Vector) session.getAttribute(item.getEnumValues());
                        Vector descriptVector = (Vector) session.getAttribute(item.getEnumDesc());
    
                        session.setAttribute("descVector", descriptVector);
                        session.setAttribute("valueVector", valVector);
                        %>
    
        <tiles:insert page="/secure/layouts/dynamicSelectionLayout.jsp" flush="false">
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="readOnly" value="<%=isReadOnly%>" />
        <tiles:put name="isRequired" value="<%=isRequired%>" />
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="size" value="30" />
        <tiles:put name="units" value=""/>
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        <tiles:put name="multiSelect" value="<%=item.isMultiSelect()%>" />
        </tiles:insert>
                    <% } %>
                    

                    <% if (strType.equalsIgnoreCase("Radio")) { 
                        
                        try {
                            session.removeAttribute("valueVector");
                            session.removeAttribute("descVector");
                        }
                        catch (Exception e) {
                        }
                        
                        StringTokenizer st1 = new StringTokenizer(item.getEnumDesc(), ",");
                        Vector descVector = new Vector();
                        while(st1.hasMoreTokens()) 
                        {
                            String enumDesc = st1.nextToken();
                            descVector.addElement(enumDesc);
                        }
                        StringTokenizer st = new StringTokenizer(item.getEnumValues(), ",");
                        Vector valueVector = new Vector();
                        while(st.hasMoreTokens()) 
                        {
                            String str = st.nextToken();
                            valueVector.addElement(str);
                        }
            
                        session.setAttribute("descVector", descVector);
                        session.setAttribute("valueVector", valueVector);
                        %>
                        
        <tiles:insert page="/secure/layouts/radioButtonLayout.jsp" flush="false">
        <tiles:put name="property" value="<%=item.getAttribute()%>" />
        <tiles:put name="isReadOnly" value="<%=isReadOnly%>" />
        <tiles:put name="isRequired" value="<%=isRequired%>" />
        <tiles:put name="label" value="<%=item.getLabel()%>" />
        <tiles:put name="size" value="30" />
        <tiles:put name="units" value=""/>
        <tiles:put name="desc" value="<%=item.getDescription()%>"/>
        <tiles:put name="bean" value="<%=formName%>" />
        </tiles:insert>
                    <% } %>
    
        <% } %>    
    

             <% propCounter += 1;%>
             
             </TR>
             

    <%}%>

    </logic:iterate>
    
</table>
    
    <%
      if (!activeSubhead.equals("")) {
	%>
       
    </TABLE>
    </FIELDSET>
    </TD>
    </TR>
    
    <%
	  }
	%>
    

    <tr>
        <td class="navigation-button-section" nowrap VALIGN="top">
            <input type="submit" name="apply" value="<bean:message key="button.apply"/>" class="buttons" id="navigation">
            <input type="submit" name="save" value="<bean:message key="button.ok"/>" class="buttons" id="navigation">
            <input type="reset" name="reset" value="<bean:message key="button.reset"/>" class="buttons" id="navigation">
            <input type="submit" name="org.apache.struts.taglib.html.CANCEL" value="<bean:message key="button.cancel"/>" class="buttons" id="navigation">
        </td>
    </tr>

    </tbody>
</table>

</html:form>
    <% } %>
    
 
<br>

<%
}
%>
