#  This program may be used, executed, copied, modified and distributed
#  without royalty for the purpose of developing, using, marketing, or distributing.

#
# script for creating XD default template
#
# author: bkmartin

def convertToList(inlist):
     outlist=[]
     if (len(inlist)>0 and inlist[0]=='[' and inlist[len(inlist)-1]==']'):
        inlist = inlist[1:len(inlist)-1]
        clist = inlist.split(" ")
     else:
        clist = inlist.split("\n")
     for elem in clist:
        elem=elem.rstrip();
        if (len(elem)>0):
           outlist.append(elem)
     return outlist

def getConfigIdForTemplate(templateName):
   templates=convertToList(AdminConfig.listTemplates("Server"))
   for template in templates:
       cname = AdminConfig.showAttribute(template,"name")
       if (cname == templateName):
          return template
   return ""

print "creating xd template"
AdminTask.createTemplateFromTemplate('[-sourceTemplate default -destinationTemplate defaultXD -description "WebSphere XD Default Template"]')
template=getConfigIdForTemplate("defaultXD")
threadpools=convertToList(AdminConfig.list("ThreadPool",template))
for threadpool in threadpools:
   tname = AdminConfig.showAttribute(threadpool,"name")
   if (tname == "WebContainer"):
      print "modifying WebContainer threadpool in xd template"
      AdminConfig.modify(threadpool,[['maximumSize','500']])


print "creating xd ZOS template"
AdminTask.createTemplateFromTemplate('[-sourceTemplate defaultZOS -destinationTemplate defaultXDZOS -description "WebSphere XD ZOS Default Template"]')
template=getConfigIdForTemplate("defaultXDZOS")
threadpools=convertToList(AdminConfig.list("ThreadPool",template))
for threadpool in threadpools:
   tname = AdminConfig.showAttribute(threadpool,"name")
   if (tname == "WebContainer"):
      print "modifying WebContainer threadpool in xd zOS template"
      AdminConfig.modify(threadpool,[['maximumSize','500']])


print "saving workspace"
AdminConfig.save()
print "finished."

